#ifndef _ECOMMON
#define _ECOMMON
#include "utils2.h"
#include "baserst.h"
#include "eval.h"
//void tthrow(const char *s);
//SD str(signed long n);
struct CPS { //for selfbalancing indexes
	BOOL bb;
 DWORD* nob,*key;
	OVERLAPPED ** ovp;
 bool set;
 HANDLE cp;
};

struct UCH {
	_int64 rhppos;
 char type;
	union {
		_int64 lastp;
		long infid; //during append
	};
	//bool isvalid;
 unsigned char * fdabuf;
	long actualsize;
 long totalsize;
	UCH() {
		//isvalid=false;
		fdabuf=0;
		actualsize=0;
		totalsize=0;
	}
	~UCH() {
		if (fdabuf) free(fdabuf);
	}
	void alloc();
	//void readfrom(Socket * s);
};


struct CHECKSF {
 long tablepos; //records position
 long starting;
 long size;
 long nodepos;
};
struct ICHANGE {
 _int64 rootppos;
 _int64 oldli;
 _int64 oldcuri1; //from
 _int64 oldcuri2; //to
 _int64 newli,newcuri,newendi;
};
struct LASTII {
 _int64 lasti;		//file position of cluster node
 _int64 curipos; //file position of current record pointer
 _int64 endipos; //file position AFTER the last record in the cluster
};
struct IndexNode {
 //ulong tablerec;
	_int64 left; // less than
	_int64 right; // greater than
	_int64 next; // for browsing
	_int64 previous; //for browsing
	_int64 root;
	signed long maxrecs;  //maximum no. of index entries
	signed long totrecs;  //total no. of index entries (always <=maxrecs)
	//ulong rno;  //total no. of nodes on the right hand branch
	//ulong lno;  //total no. of nodes on the left hand branch
};


struct PS {
 unsigned long port,ip;
 char type; //can be 'S' or 'W'
 bool accept;
 PS() {
  port=0;
  ip=0;
  type=0;
  accept=true;
 }
};

bool buildps(const char * filename,SArray<PS> & ps);
unsigned long findport(SArray<PS> & ps);

struct ICD {
 char type;
 union {
  struct { //icchange
   _int64 rootppos;
   _int64 oldli;
   _int64 oldcuri1; //from
   _int64 oldcuri2; //to
   _int64 newli,newcuri,newendi;
  } i;
  struct { //ndel
   _int64 rootppos;
   _int64 oldp;
   _int64 oldi,oldcuri;
   _int64 newi,newcuri,newendi,newp;
   bool eof,bof;
  } d;
 };
};

typedef enum DataType {
 dtString=1,
 dtChar=2,
 dtWord=3,
 dtLong=4,
 dtDateTime=5,
 dtDouble=6,
 dtFloat=7,
 dtBoolean=8,
 dtCurrency=9,
 dtFstring=10,
 dtDate=11,
 dtLonglong=12,
 dtVariable=13, //for sbWorkbook only
 dtCyclic=14,  //for sbWorkbook only
 dtFunction=15,  //for tokens
};

DED extern char sizeary[13];

struct TableDef2 {
 int n; //no of fields
 DED void clear() {
  if (f) delete[]f;
  n=0;
  f=0;
 }
 struct Field {
  SD name;
  unsigned char datatype;
  //long pos;
  long mempos;
  long maxsize;
 };
 Field * f;
 DED TableDef2() {
  n=0;
  f=0;
 }
 DED ~TableDef2() {
  if (f) delete[]f;
 }
};

struct TableDef {
 int n; //no of fields
 DED void clear() {
  if (f) delete[]f;
  n=0;
  f=0;
 }
 struct Field {
  SD name;
  unsigned char datatype;
  long pos;
  long mempos;
  long maxsize;
 };
 Field * f;
 DED TableDef() {
  n=0;
  f=0;
 }
 DED ~TableDef() {
  if (f) delete[]f;
 }
};



//---------------EVALJoin starts------------------------------------------
//#include "eval.h"
class Eval;
struct token;
class EVALJoin:public Join{
public: //rivate:
 bbaserst * rst;
 SArray2<Eval> evals;
 SArray<unsigned char> dts;
 //EVALJoin * parent,*child;
public:
 bool check(Eval *e,token **tkn=0);
 //bool EVALJoin check(Eval *e,int n);
 SD errorstr;
 SDA fields; //ormulas;
 DED static void fixstack(Stack<token*> & st,bbaserst * rst);
 //DED static LRESULT CALLBACK evalf(Eval * e,bbaserst* rst,token * f,Stack<token *> & st,token * nnew);
 DED static bool CALLBACK evalv(Eval * e,bbaserst * rst,token * t,token * newt);
 DED EVALJoin();
 DED StringData GetFieldName(signed long pos);
 DED unsigned char GetFieldType(signed long pos);
 DED long GetMaxSize(signed long pos);
 DED Join * GetNew();
 DED unsigned char getfpos(const char * fn);
 DED signed long getfpos2(const char * fn);
 DED bool Addformula(const char * formula,const char * fieldname=0,unsigned char dt=0);
 DED void Attach(bbaserst * r);
 DED void Detach();
 DED virtual ~EVALJoin();
 DED int GetFieldCount();
 DED void  GetFieldValue(int pos,StringData & sd);
};
//---------------EVALJoin ends------------------------------------------
struct RST;
struct nameid{
 SD fieldname;
 unsigned char dt;
 unsigned long pos; //ver 2 - relative position
 long maxsize;
 //RST * rst;
};

typedef enum ErrorCodes{
 deNoContext=-1,
 deInvalidParameter=-1,
 deEof=-2,
 deBof=-3,
 deNoRecords=-4,
 deNoFields=-4,
 deNoBuffer=-5,
 deItemNotFound=-6,
 deDeleted=-7,
 deInvalidDatatype=-8,
 deDuplicateItem=-9,
 deRetry=-12,
 deInvalidPassword=-13,
 deOk=1,
};

DED void Undolog(Recordset & r,IDatabase & db);
DED void servererr(signed char c);
DED SD getword3(const char *s,char **ss);
DED SD ffix(SD s);
//DED bool prasewhere(baserst * rst,char **s,SDArray &where,SDArray &wherec,SPtrArray &wherev,SByteArray &indexable,CWordArray &trueskip,CWordArray &falseskip,char * wheretype);
DED SD getwordc(const char * s,char **ss);
//DED bool getadjoining(int x,CWordArray &netbrac,int & y1,int & y2);
//DED bool getblocksize(int x,CWordArray &netbrac,long * size);
//DED bool killwhere(int a,SDA &where,SDA &wherec,SPtrArray &wherev,SByteArray &indexable,CWordArray &trueskip,CWordArray &falseskip,CWordArray &netbrac,SByteArray & andor,CWordArray &blevel);
//DED void insertwhere(int y,int x,SDA &where,SDA &wherec,SPtrArray &wherev,SPtrArray &wnids,SPtrArray &wdts,CWordArray &wlens,SByteArray &wbreak,bool * wc,SByteArray &indexable,CWordArray &trueskip,CWordArray &falseskip,SByteArray & islike);
DED char isinmem(char * main,char * sub,int lenmain,int lensub);

struct FieldInfo {
 SD name;
 union {
  unsigned char datatype;
  bool descending;
 };
 bool same;
 long maxsize;
 FieldInfo() {
  maxsize=0; //false;
  datatype=0;
  same=false;
  descending=false;
 }
};

class IndexStruct {
public:
 DED bool addfield(const char * fieldname,bool descending=false,bool same=false);
 //DED bool addfield(const char * fieldname,bool descending,bool same);
 DED IndexStruct();
 SD tablename;
 SD indexname;
 bool unique,primary;
 DED bool addfield(FieldInfo * fi);
 DED long getfieldcount();
 DED FieldInfo * getfieldinfo(long index);
 DED void clear();
 DED ~IndexStruct();
 SArray<FieldInfo*> fields;
};

class TableStruct {
public:
 DED bool iseq(TableStruct& ts,bool withposition=false);
 DED bool changedatatype(const char * fieldname,unsigned char newdt,long maxsize=0);
 DED bool deletefield(const char * fieldname);
 DED bool addfield(const char * fieldname,unsigned char dt,long maxsize=0);
 SD tablename;
 DED bool addfield(FieldInfo * fi);
 DED long getfieldcount();
 DED FieldInfo * getfieldinfo(long index);
 DED void clear();
 DED ~TableStruct();
//private:
 SArray<FieldInfo *> fields;
};

struct RST;
class Recordset;
struct IDS {
 bool mlockedex;
 bool maxsizechanged,reccountchanged;
 //bool autounlock;
 //void * lockedby;
 Recordset * defrst; //for universal edit/delete/append
 unsigned long lastrecno; //for appending only .. - server side
 signed long recnofid;//bool recnofidset;
 SD tablename;
 _int64 firstpos,lastpos,reccountpos; //position of pointers to the first and last record headers
 _int64 lastrecpos; //usefull when compacting
 _int64 lastrecnopos;
 _int64 rhppos; //pointer to the table's record header;
 long tableid;
 signed long reccount; //must be signed because of signed for loop in addindex
 //unsigned short depth; //ideal depth - server side
 bool operator==(_int64 p) {
  return rhppos==p;
 }
 bool operator<(_int64 p) {
  return rhppos<p;
 }
 DED IDS() {
  mlockedex=false;
  maxsizechanged=false;
  reccountchanged=false;
  //locked=false;
  //lockedby=0;
  defrst=0;
  recnofid=-1;
  lastrecno=0;
 }
 unsigned long recordsize; //ver 2 - size of the entire record
 struct indexinfo {
  indexinfo(){
   rsd=0;
   defrag=false;
  }
  ~indexinfo() {
   ASSERT(rsd!=0);
   delete[]rsd;
  }
  bool defrag;
  long indexid;
  SD name;
  SArray<signed long> fids;
  SByteArray descending;
  SByteArray sames;
  _int64 rootppos,base;
  bool unique,primary;
  SPtrArray ra,ia,nids;
  StringData * rsd;
 };
 SPtrArray indexes;

 signed long getfpos(const char * fn) {
  int n=nameids.GetSize();
  for (int x=0;x<nameids.GetSize();x++) {
		 nameid * ni= (nameid *) nameids.GetAt(x);
		 if (ni->fieldname.CompareNoCase(fn)==0) return x;
  } 
	 return -1;
 }

 DED bool fillis(IndexStruct & is,const char * name) {
  IDS::indexinfo * inf=getinf(name);
  if (!inf) return false;
  is.clear();
  is.tablename=tablename;
  is.indexname=inf->name;
  is.primary=inf->primary;
  is.unique=inf->unique;
  for (int x=0;x<inf->fids.GetSize();x++) {
   nameid * ni=(nameid *)nameids.GetAt(inf->fids[x]);
   VERIFY(is.addfield(ni->fieldname,inf->descending[x]?true:false,inf->sames[x]?true:false));
  }
  return true;
 }

 DED void fillts(TableStruct & ts) {
  ts.clear();
  ts.tablename=tablename;
  for (int x=0;x<nameids.GetSize();x++) {
   nameid * ni=(nameid *)nameids.GetAt(x);
   VERIFY(ts.addfield(ni->fieldname,ni->dt,ni->maxsize));
  }
 }

 DED bool isfixedlen() {
  for (int x=0;x<nameids.GetSize();x++) {
   nameid * ni=(nameid *)nameids.GetAt(x);
   if (ni->dt==dtString) return false;
  }
  return true;
 }

 DED indexinfo * getprimaryindex() {
  for (int x=0;x<indexes.GetSize();x++) {
   indexinfo * inf=(indexinfo*)indexes.GetAt(x);
   if (inf->primary) return inf;
  }
  return 0;
 }
 DED indexinfo * getinf(const char *index) {
  for (int x=0;x<indexes.GetSize();x++) {
   indexinfo * inf=(indexinfo*)indexes.GetAt(x);
   if (inf->name.CompareNoCase(index)==0) return inf;
  }
  return 0;
 }
 SPtrArray nameids;
};

struct BookMark {
 _int64 lastp,lasti,curipos,endipos;
 _int64 currec;
 bool rid;
 bool eof,bof,reposition;
};

struct RST {
 IDS * ids;
 _int64 lastp,lasti;
 _int64 curipos,endipos; //disk positions
 IDS::indexinfo * inf;
 bool eof,bof;
 bool sqltype;
 Recordset * rrst;
 //char rid;
 bool rid;
 DED RST() {
  /*rid=0;
  rrst=0;
  sqltype=false;
  ids=NULL;
  lastp=0;
  lasti=0; //index pos
  curipos=0;
  endipos=0;
  eof=false;
  bof=false;
  inf=0;*/
 }
 DED ~RST() {

 }
};


#endif
