#ifndef HTML_INCLUDED
#define HTML_INCLUDED
//#define DEFAULTWIDTH (48) //*POINTTOPIXEL)
//#define DEFAULTHEIGHT (12.75) //*POINTTOPIXEL)

#include "utils2.h"
#include "baserst.h"
#include "rt.h"
#include "eval.h"
class Database;
/*struct sRange2 {
 long sheetid,sr,sc,er,ec;
 long Rowcount() { return abs(er-sr)+1;}
 long Colcount() { return abs(ec-sc)+1;}
 void operator += (long r) {
  sr+=r;
  er+=r;
 }
};*/





struct sFont {
private:
 void init() {
  memset(this,0,sizeof(sFont));
 }
public:
 bbaserst * rst;SD listfield;
 SD name,format;
 double size;
 bool underline,bold,italic,wraptext,shrinktofit;
 char halign,valign;
 long forecolor,backcolor;
 char bb,bt,bl,br;
 long bbc,btc,blc,brc;
 sFont(sFont & f) {
  init();
  *this=f;
 }
 sFont() {
  init();
 }


 void operator =(sFont &f) {
  ASSERT(this!=&f);
  shrinktofit=f.shrinktofit;
  wraptext=f.wraptext;
  name=f.name;
  format=f.format;
  size=f.size;
  underline=f.underline;
  bold=f.bold;
  italic=f.italic;
  halign=f.halign;
  valign=f.valign;
  forecolor=f.forecolor;
  backcolor=f.backcolor;
  bb=f.bb;
  bt=f.bt;
  bl=f.bl;
  br=f.br;
  bbc=f.bbc;
  btc=f.btc;
  blc=f.blc;
  brc=f.brc;
  rst=f.rst;listfield=f.listfield;
 }

 bool xlseq(sFont &f) {
  ASSERT(this!=&f);
  if (size!=f.size) return false;
  if (bold!=f.bold) return false;
  if (underline!=f.underline) return false;
  if (name!=f.name) return false;
  if (forecolor!=f.forecolor) return false;
  return true;
 }

 bool operator !=(sFont & f) {
  if (name!=f.name) return true;
  if (format!=f.format) return true;
  if (size!=f.size) return true;
  if (shrinktofit!=f.shrinktofit) return true;
  if (wraptext!=f.wraptext) return true;
  if (underline!=f.underline) return true;
  if (bold!=f.bold) return true;
  if (italic!=f.italic) return true;
  if (halign!=f.halign) return true;
  if (valign!=f.valign) return true;
  if (forecolor!=f.forecolor) return true;
  if (backcolor!=f.backcolor) return true;
  if (bb!=f.bb) return true;
  if (bt!=f.bt) return true;
  if (bl!=f.bl) return true;
  if (br!=f.br) return true;
  if (bbc!=f.bbc) return true;
  if (btc!=f.btc) return true;
  if (blc!=f.blc) return true;
  if (brc!=f.brc) return true;
  if (rst!=f.rst) return true;if (listfield!=f.listfield) return true;
  return false;
 }
 bool operator ==(sFont & f) {
  return !(this->operator !=(f));
 }
};

struct CFormat {
 Eval e;
 long fontid;
 void operator =(CFormat & c) {
  e=c.e;
  fontid=c.fontid;
 }
};
class sWorkbook;
class sCell {
private:
 sCell(sCell & c) {
  MMsgbox("err");
 }
public:
 //bool wraptext;
 //baserst * rst;
 long fontid,sid,mrow,mcol,row,col,rowspan,colspan;
 unsigned long changeid;
 SD comment,text,value;
 //char bb,bt,bl,br;
 Eval e;
 int ncfs;
 SArray2<CFormat> cfs;
 //token * getvalue() {
 // return e.process(true);
 //}
 sCell(){
  ncfs=0;
  //e=new Eval;
 }
 ~sCell() {
  //delete e;
 }
 void copy(sCell & c) {
  ASSERT(this!=&c);
  //wraptext=c.wraptext;
  fontid=c.fontid;
  rowspan=c.rowspan;
  colspan=c.colspan;
  e=c.e;
  comment=c.comment;
  text=c.text;
  value=c.value;
  cfs=c.cfs;
  ncfs=c.ncfs;
 }
 void operator =(sCell & c) {
  copy(c);
  sid=c.sid;
  row=c.row;
  col=c.col;
  mrow=c.mrow;
  mcol=c.mcol;
 }
 long fontidd(sWorkbook * b);
};

struct sRange {
 long sid,sr,sc,er,ec; 
 long Rowcount() { return (er-sr)+1;}
 long Colcount() { return (ec-sc)+1;}
 long Cellcount() {return Rowcount()*Colcount();}
 void operator = (sCell & c) {
  sid=c.sid;
  sc=c.col;
  sr=c.row;
  er=sr;
  ec=sc;
 }
 void operator = (token & t) {
  sid=t.fpos;
  sr=t.sr;
  sc=t.sc;
  er=t.er;
  ec=t.ec;
 }
 
 bool operator != (sRange &r) {
  if (sid!=r.sid) return true;
  if (sc!=r.sc) return true;
  if (sr!=r.sr) return true;
  if (ec!=r.ec) return true;
  if (er!=r.er) return true;
  return false;
 }
 bool operator == (sRange &r) {
  return !(*this!=r);
 }

 void operator += (long r) {
  sr+=r;
  er+=r;
 }

 sRange operator + (long r) {
  sRange rg=(*this);
  rg+=r;
  return rg;
 }

 inline sRange operator - (long r) {
  return (*this)+(-r);
 }

 bool inrange(long r,long c) {
  if (r<sr || r>er) return false;
  if (c<sc || c>ec) return false;
  return true;
 }
 bool inrange(sRange & rg) {
  if (sid!=rg.sid) return false;
  if (!inrange(rg.sr,rg.sc)) return false;
  return inrange(rg.er,rg.ec); //) return false;
  //return true;
 }

 sRange() {

 }
 sRange(long _sid,long _sr,long _sc,long _er,long _ec) {
  sid=_sid;
  sr=_sr;
  sc=_sc;
  er=_er;
  ec=_ec;
 }
 bool isbot(long sid,long row,long col) {
  if (sid==sRange::sid && row==er && col>=sc && col<=ec) return true;
  return false;
 }
 bool istop(long sid,long row,long col) {
  if (sid==sRange::sid && row==sr && col>=sc && col<=ec) return true;
  return false;
 }
 bool isleft(long sid,long row,long col) {
  if (sid==sRange::sid && col==sc && row>=sr && row<=er) return true;
  return false;
 }
 bool isright(long sid,long row,long col) {
  if (sid==sRange::sid && col==ec && row>=sr && row<=er) return true;
  return false;
 }
};

class sArea : public SArray<sRange> {
public:
 bool isbot(long sid,long row,long col) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x).isbot(sid,row,col)) return true;
  }
  return false;
 }
 bool istop(long sid,long row,long col) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x).istop(sid,row,col)) return true;
  }
  return false;
 }
 bool isleft(long sid,long row,long col) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x).isleft(sid,row,col)) return true;
  }
  return false;
 }
 bool isright(long sid,long row,long col) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x).isright(sid,row,col)) return true;
  }
  return false;
 }
};

//typedef SArray<sRange> sArea;


struct sName{
private:
 sName(sName& n) {
  MMsgbox("err");
 }
public:
 sName() {
 }
 SD name;
 sRange r;
 void operator =(sName & n) {
  ASSERT(this!=&n);
  name=n.name;
  r=n.r;
 }
};
typedef SArray2<sName> sNames;

class sCol {
public:
 double width;
 signed long fontid;
 sCol() {
  fontid=-1;
 }
};

//typedef SArray2<sCell> sCells;
class sRow {
private:
 //sRow(sRow & c) {
  //MMsgbox("err");
 //}
public:
 sRow() {
  changeid=(unsigned)-1; //0; //this statement is not needed in sCell (because sCells are swapped to disk with default value of 0)
  fontid=-1;
 }
 double height,factor;
 int maxh;
 unsigned long changeid;
 signed long fontid;
 void operator=(sRow & r) {
  height=r.height;
  fontid=r.fontid;
 }
};


//typedef SArray2<sRow> sRows;
class sSheet{
private:
 sSheet(sSheet & s) {
  MMsgbox("err");
 }
public:
 signed long fontid; //default fontid
 double mt,ml,mb,mr; //margins in points
 int selrow,selcol,currow,curcol,curx,cury,lastrow,lastcol; //used by WBUI
 bool c2active;
 int currow2,curcol2,curx2,cury2;
 char seltype;
 bool selected,viewgridlines;
 long maxr,maxc; //used when opening only ...
 long splitrow,splitcol;
 double splitv,splith; //in points ....
 double defh,defw; //default height & width
 inline int & curxx() {
  return c2active?curx2:curx;
 }
 inline int & curyy() {
  return c2active?cury2:cury;
 }
 inline int & curroww() {
  return c2active?currow2:currow;
 }
 inline int & curcoll() {
  return c2active?curcol2:curcol;
 }

 sSheet() {
  defw=48;
  defh=12.75;
  fontid=-1;
  c2active=false;
  selected=false;
  hidden=false;
  hsr=0;
  her=0;
  mt=15;
  mb=15;
  mr=15;
  ml=15;
  lastrow=1;
  lastcol=1;
  currow=1;
  curcol=1;
  curx=0;
  cury=0;
  zoom=100;
  fittopagestall=1;
  fittopageswide=1;
  viewzoom=100;
  mannualpagebreaking=false;
  seltype=0; //0=no selection, 1=range selection, 2=row selection, 3=col selection, 4=full selection
  landscape=false;
  viewgridlines=true;
  splitrow=0;
  splitcol=0;
 }
 double getrowheight(long row);
 double getcolwidth(long col);
 void makerows(long row);
 void createrows(long row,long n);
 void deleterows(long row,long n);
 void deletecols(long col,long n);
 void createcols(long col,long n);
 void makecols(long col);
 //sCell * getcell(int r,int c);
 //void killcell(int r,int c);
 bool mannualpagebreaking;
 long viewzoom;
 long zoom,fittopagestall,fittopageswide,hsr,her;
 SD name;
 SD name2; //VBA name
 //void sSheet::hidecol(int c);
 //Stack<sRow> rows;
 SArray2<sRow> rows;
 //sRows rows;
 SArray<long> rowpagebreaks;
 SArray<long> colpagebreaks;
 SArray2<sCol> cols;
 SArray2<sName> names;
 bool hidden,landscape;

 void operator=(sSheet & s) {
  ASSERT(this!=&s);
  defh=s.defh;
  defw=s.defw;
  fontid=s.fontid;
  hsr=s.hsr;
  her=s.her;
  mt=s.mt;
  mb=s.mb;
  ml=s.ml;
  mr=s.mr;
  mannualpagebreaking=s.mannualpagebreaking;
  zoom=s.zoom;
  fittopagestall=s.fittopagestall;
  fittopageswide=s.fittopageswide;
  //name=s.name;
  //cells=s.cells;
  rows=s.rows;
  cols=s.cols;
  names=s.names;
  hidden=s.hidden;
  landscape=s.landscape;
  viewzoom=s.viewzoom;
  rowpagebreaks=s.rowpagebreaks;
  splitrow=s.splitrow;
  splitcol=s.splitcol;
  splitv=s.splitv;
  splith=s.splith;
 }
};

struct sRun {
private:
 sRun(sRun & r) {
  MMsgbox("err");
 }
public:
 sRun() {
 }
 StringData text,comment;
 char type;
 long fontid;
 void operator =(sRun & r) {
  text=r.text;
  type=r.type;
  fontid=r.fontid;
  comment=r.comment;
 }
};

struct sColumn{
 double width;
};

struct sTable{
private :
 sTable(sTable & t) {
  MMsgbox("err");
 }
public:
 sTable() {
 }
 long totrows,totcols,alignment;
 SArray<sColumn> cols;

 void operator =(sTable & t) {
  totrows=t.totrows;
  totcols=t.totcols;
  cols=t.cols;
 }
};

struct sParagraph {
private:
 sParagraph(const sParagraph & p) {
  MMsgbox("err");
 }
public:
 long alignment,listlevel,listvalue,listtype,tableid,start,row,col,count,totcount;
 double leftindent,hanging;
 StringData listtext;
 SArray2<sRun> runs;
 void operator =(sParagraph & p) {
  tableid=p.tableid;
  start=p.start;
  row=p.row;
  col=p.col;
  count=p.count;
  totcount=p.totcount;
  hanging=p.hanging;
  alignment=p.alignment;
  listvalue=p.listvalue;
  listtype=p.listtype;
  listtext=p.listtext;
  leftindent=p.leftindent;
  listlevel=p.listlevel;
  runs=p.runs;
 }
 sParagraph() {
  //listlevel=0;
 }
};

class sDocument {
private:
 sDocument(sDocument * d) {
  MMsgbox("err");
 }
public:
 DED bool convert(StringData & sd);
 DED bool convertxml(StringData & sd);
 sDocument() {
 }
 SArray2<sTable> tbls;
 SArray2<sParagraph> ps;
 SArray2<sFont> fonts;
 DED bool open(IDatabase * db);
 DED void clear();
 DED void fillfonts(IDatabase *db);
};

struct Fallback {
 int cursheet,selrow,selcol,currow,curcol,curx,cury,lastrow,lastcol; //used by WBUI
 char seltype;
};

struct sUndo {
 char type;
 /*union {
  long n; //type=0
  struct {
   int col;
   double width;
  } colresize; //type=1
 };*/
 sCell c;
 void operator=(sUndo & u) {
  type=u.type;
  c=u.c;
 }
};

#define MAXUNDOS 125
class Per;
class sWorkbook {
 friend class sCell;
private:
 Eval eeval; //general purpose...
 int vbadepth;
public:
 void sWorkbook::freezepanes(int sid,int row,int col);
 SArray2<sUndo> undos,redos;
 long cursheet,scurx;
 void _writecell4(sCell & c);
 Per * per;
 bool sWorkbook::_getcellvalue3(); //long sid,long row,long col);
 void dump2();
 DED void dump();
 SD debugfn;
 SArray<Fallback> fallbacks;
 SArray2<TempTable> rts; //for auto expansion in web forms
 //SArray2<TempTableRst> rrts; //for auto expansion in web forms

 void sWorkbook::texttosd(const char * text,SD & value);
 void sWorkbook::setformula2(sCell * c,const char * formula);
 SD & sWorkbook::getformula2(sCell * cell,SD & formula);
 void sWorkbook::format(sCell * cell,SD & s);
 DED void sWorkbook::insertcols(long sid,long col,long n,char optimize=0);
 DED void addrowpagebreak(long sid,long row);
 unsigned long usedcells;
 SFile3 sfile;
 //DED void sWorkbook::savecellsub(sCell * c,bool withvalue);
 //DED sCell *sWorkbook::getcell2(long sid,long row,long col);
 sCell * sWorkbook::getnewcell();
 void sWorkbook::killcell2(sCell * c); //will not free it
 //void sWorkbook::writecell(sCell * c,bool src,bool text,bool value);
 //DED void sWorkbook::readcell(sCell * c,bool withvalue);
 //void sWorkbook::savecell(sCell * c,bool withvalue);
 void sWorkbook::killcell(sCell * c);
 //void sWorkbook::changesrc(sCell * c,long sid,long row,long col);
 DED void sWorkbook::freecell(sCell * c); //,bool save=false,bool withvalue=false);
 //StringData & sWorkbook::celltovalue(sCell & c);
 //void sWorkbook::texttocell(sCell & c);
 //void sWorkbook::valuetocell(sCell & c);
 DED static SD sWorkbook::getcolstr(int col);
 DED static int sWorkbook::getcc(char c);
 DED static bool sWorkbook::getrc(SD f,long & r,long & c,bool & rfixed,bool & cfixed);
 DED static SD sWorkbook::rctos(long r,long c,bool rfixed,bool cfixed);
 DED static SD sWorkbook::rgtos(sRange & rg);
 DED SD sWorkbook::rgtos2(sRange & rg);
 sArea redarea; //for use with wbui
 //StringData & sWorkbook::celltotext(sCell & c);
 SArray2<sCell> cells; //free cells
 SD sd;
 bool sWorkbook::_onpositionrt3();
 signed long _SID,_ROW,_COL,RT_CELL,RT_CHANGEID,RT_VALUE,RT_DT,RT_NODEP,RT1_PARENT,RT_DT_POS,RT_VALUE_POS,RT_CELL_POS,RT_NODEP_POS,RT1_BM,RT1_PARENT_POS,RT1_BM_POS,RT_CHANGEID_POS,RT1_CELLPTR_POS,RT1_CELLPTR;
 unsigned long lastchangeid,changeid,recalc2changeid;
 char stripformula;
 SD seeks[3];
 sSheet & sWorkbook::cursheett();
 bool sWorkbook::_onposition(sCell * c);
 sCell *sWorkbook::_getcell4(long sid,long row,long col);
 sCell *sWorkbook::_getcell3(long sid,long row,long col);
 sCell *sWorkbook::_getcell2(long sid,long row,long col);
 void sWorkbook::_savecell2(sCell & c);
 void sWorkbook::sort(sRange r,long * cols,bool * desc,long n);
 void _readcellvalue(long sid,long row,long col,token * t);
 sCell *sWorkbook::_getcell1(long sid,long row,long col);
 void sWorkbook::_writecell3(sCell & c);
 void sWorkbook::_writecell2(sCell & c);
 void sWorkbook::_writecell1(sCell & c);
 sSheet & sWorkbook::getsheet();
 sCell *sWorkbook::_readcell1();
 sCell *sWorkbook::_readcell2();
 sCell *sWorkbook::_getcell4_1(long sid,long row,long col,char dir);
 sCell *sWorkbook::_getcell1_1(long sid,long row,long col,char dir);
 sCell *sWorkbook::_getcell1_2(long sid,long row,long col);
 void sWorkbook::_savecell1_1(sCell & c);
 _int64 bm1,bm2; //bool usebm2; //for seek avoidance
 bool dirty;
 bool sWorkbook::_onposition(long sid,long row,long col);
 void sWorkbook::_readcell3(sCell * c);
 void sWorkbook::_heatup(Eval & e);
 token * sWorkbook::evaluatesub(Eval & e,long sid);
 void sWorkbook::_appendcell1(sCell & c);
 bool sWorkbook::_positionrt3();
 bool sWorkbook::_positionrt1(long sid,long row,long col);
 bool sWorkbook::_positionrt4(long sid,long row,long col);
 bool sWorkbook::_positionrt2(long sid,long row,long col);
 void sWorkbook::_savecell1(sCell & c);
 void sWorkbook::_texttocell1(sCell & c);
 bool sWorkbook::evaluate(SD & f,long sid);
 StringData & sWorkbook::_celltotext1(sCell & c);
 bool sWorkbook::_setrtvalue(SD & sd);
 DED sWorkbook();
 SD & sWorkbook::getformula2sub(Eval & e,SD & formula);
 SD getformula2sub(Eval & e);
 RamTable rt,rt1,rt2;
 SD errorstr;
 bool allowprinting,allowmodification;
 bool sWorkbook::Open(const char * fn);
 void sWorkbook::setcformat(sCell *c,const char * formula,long fontid,long pos);
 void sWorkbook::setformulasub(long sid,Eval & e,const char * formula);
 void sWorkbook::makeparent();
 void sWorkbook::deletesheet(long sid);
 void sWorkbook::movesheet(long sid,long bsid);
 //void sWorkbook::recalc3();
 DED SD & sWorkbook::getcellformula(long sid,long row,long col,SD & formula);
 DED SD & sWorkbook::getcellvalue(long sid,long row,long col,SD & value);
 SD & getcellcomment(long sid,long row,long col,SD & comment);
 sCell * sWorkbook::getcellvalue2(long sid,long row,long col,char full);
 sCell * sWorkbook::getcellrt1(bool withvalue);
 //bool sWorkbook::chksrc(sRange & src);
 void sWorkbook::removefromrt2();
 void sWorkbook::fastaddrt1(long sid,long row,long col,char parent);
 void sWorkbook::fastaddrt2(long sid,long row,long col);
 char sWorkbook::adddependants(sCell *cell);
 void sWorkbook::getvalue2(sCell * cell);
 DED SD sWorkbook::getformula(sCell * cell);
 DED SD sWorkbook::getformula2(sCell * cell);
 DED void sWorkbook::hidecol(long sheetid,long col,bool clearcol=false);
 DED bool sWorkbook::spanned(int r,int c,SDWordArray &hrow,SDWordArray &hcol);
 DED void appendcell(sCell & c,bool withvalue); //,bbaserst & rst);
 DED long addfont(sFont & ff);
 bool sWorkbook::_splitsheetname(SD & name,SD & basename, int & no);
 bool DuplicateSheetNameOptimization;
 DED void sWorkbook::setsheetname(long sid,SD & name);
 DED SD sWorkbook::getsheetname(long sid);
 //DED void setformula(sRange * r,const char * formula);
 DED void setformula(sCell * c,const char * formula);
 DED sRange sWorkbook::getrange(const char * name);
 DED void sWorkbook::nset(token*t,sName * n);
 DED SD sWorkbook::makev(token *n);
 DED bool sWorkbook::IsOpen();
 char sWorkbook::getrightbdr(long sid,long row,long col,sArea ** a=0);
 char sWorkbook::getleftbdr(long sid,long row,long col,sArea ** a=0);
 char sWorkbook::getbotbdr(long sid,long row,long col,sArea ** a=0);
 char sWorkbook::gettopbdr(long sid,long row,long col,sArea ** a=0);
 DED void sWorkbook::deletecols(long sid,long col,long n,char optimize=0);
 DED void sWorkbook::deleterows(long sid,long row,long n,char optimize=0);
 DED bool sWorkbook::setcellformula(long sid,long row,long col,const char * formula);
 DED bool sWorkbook::setcellvalue(long sid,long row,long col,const SD & value,long fontid=-1,char optimize=0);
 void sWorkbook::setcellcomment(long sid,long row,long col,const SD & comment);
 DED void sWorkbook::eval2optimize(sRange & rg,EVALCBF evalf,baserst * rst);
 DED void sWorkbook::eval2optimize(sArea & area,EVALCBF evalf,baserst * rst);
 DED void sWorkbook::evaloptimize(long sid,long row,long col,EVALCBF evalf,baserst * rst);
 DED void sWorkbook::eval2VBA(sRange & rg,EVALCBF evalf,baserst * rst=0,char depth=0,long rowoffset=0,long dsid=0,long drow=0,long dcol=0);
 DED void sWorkbook::eval2VBA(sArea & area,EVALCBF evalf,baserst * rst=0,char depth=0,long rowoffset=0,long dsid=0,long drow=0,long dcol=0);
 DED void sWorkbook::evalVBA(long sid,long row,long col,EVALCBF evalf,baserst * rst=0,char depth=0,long rowoffset=0,long dsid=0,long drow=0,long dcol=0);
 DED void sWorkbook::clearcol(long sheetid,long c);
 DED static LRESULT CALLBACK sWorkbook::evalvWB(Eval * e,sWorkbook* wb,token * t,token * nnew);
 DED void sWorkbook::clearrow(long sheetid,long r);
 DED void sWorkbook::copyformat(sCell *src,sCell *dest);
 //DED void sWorkbook::insertrow(long sheetid,long r);
 DED void sWorkbook::copyformula(sCell *src,sCell *dest);
 DED void sWorkbook::clearcell(long sheetid,long r,long c);
 DED void sWorkbook::hidesheet(long sheetid);
 DED SD & sWorkbook::getcellformattedvalue(long sid,long row,long col,SD & value);
 //DED sCell * sWorkbook::createcell(long sheetid,long r,long c);
 DED sCell * sWorkbook::createcell2(long sheetid,long r,long c);
 DED long sWorkbook::getsheetid(SPtrArray &area);
 DED long sWorkbook::getrow(SPtrArray &area);
 DED bool sWorkbook::setcformat(long sid,long row,long col,const char * formula,long fontid,long pos);
 DED void sWorkbook::hidecolarea(sArea & a,bool clearrow);
 DED void sWorkbook::hiderowarea(sArea & a,bool clearrow);
 DED void sWorkbook::hidecolrange(sRange & r,bool clearrow=false);
 DED void sWorkbook::hiderowrange(sRange & r,bool clearrow=false);
 DED void sWorkbook::hiderow(long sheetid,long row,bool clearrow=false);
 DED void sWorkbook::getarea(sArea & a,long sid,const char * name);
 bool sWorkbook::iscompatible(sArea & a1,sArea & a2);
 DED void sWorkbook::setrangefont(sRange r,sFont & f);
 sArea aarea,aarea2; //general purpose ...
 DED void sWorkbook::getarea(sArea & a,const char * name);
 //DED void sWorkbook::getarea(const char * name,SPtrArray & a);
 DED void sWorkbook::unmerge(long sid,long row,long col);
 DED void sWorkbook::merge(sRange r);
 DED void sWorkbook::unmerge(sRange r);
 DED sRange sWorkbook::getusedrange(long sid);
 DED void sWorkbook::getusedrange(sRange & r,long sheetid);
 DED void sWorkbook::sheetfix(sRange & r,long oldsid,long newsid,long rowoffset,long coloffset);
 DED void sWorkbook::sheetfix(sArea & area,long oldsid,long newsid,long rowoffset,long coloffset);
 DED void sWorkbook::insertrows(long sid,long row,long n,char optimize=0);
 DED void sWorkbook::copysheet(long * sids,int n,sWorkbook * dest=0);
 DED bool sWorkbook::copyrange(sRange & src,long sheetid,long row,long col,sWorkbook * dw=0,bool cut=false,char type=0); //dw=destination workbook
 DED bool sWorkbook::copyrange(sRange & src,sRange & dest,sWorkbook * dw=0,char type=0);
 DED bool sWorkbook::copyarea(sArea & src,sArea & dest,sWorkbook * dw=0);
 //class Database;
 //DED void sWorkbook::save(Database * db);
 DED bool open(SFile3 & f);
 DED static void sWorkbook::addtables(IDatabase & db);
 SArray2<sSheet> sheets;
 SArray2<sName> gnames;
 SArray2<sFont> fonts;
 DED void sWorkbook::setfields(SDA &fields,SDA & values,bool formula=false);
 DED void sWorkbook::getfields(SDA &fields,SDA & values);
 bool sWorkbook::isvalidfield(sCell * c);
 DED void Close();
 DED ~sWorkbook();
 DED void rset(token*t,long sheetid);
 //DED sCell * getcell(long sheetid,long row,long col,bool withvalue=false);
 DED void sWorkbook::setcellfont(long sid,long row,long col,sFont & f);
 DED long sWorkbook::savefont(sFont & f);
 //DED bool sWorkbook::convertdb(const char * fn);
 DED sFont & getcellfont(long sid,long row,long col,sFont & f);
 int getcellfontid(long sid,long row,long col);
 void sWorkbook::recalc(sRange & r);
 void sWorkbook::recalc(long sid=0);
 DED bool sWorkbook::recalc2();
 bool sWorkbook::_recalc2sub(sRange & r);
 //void sWorkbook::recalc(long sid=0);
 bool sWorkbook::_setrtvalue_1(SD & sd);
 sSheet & sWorkbook::insertnewsheet(long sid);
 //bool sWorkbook::issamert1(sCell * cell);
 //void sWorkbook::savecellvalue(sCell * c);
 //void sWorkbook::getvalue(sCell * cell);
 void sWorkbook::_skiphiddensheets();
 DED sSheet * getsheet(long id);
 SD & sWorkbook::ttos(token *t);
 SD & sWorkbook::ttos2(token *t);
 DED bool SaveAsExl(const char * fn=0);
 DED bool SaveAsXls(const char * fn=0);
 DED bool SaveAsHtml(const char * fn=0);
 DED bool SaveAsXml(const char * fn=0,bool protect=false);
 long sWorkbook::findsheet2(const char * name);
 long sWorkbook::findsheet(const char * name);
 void sWorkbook::delspanned(int r,SDWordArray &hrow,SDWordArray &hcol);

 bool allowexcelconversion;
private:
 void fillnames(SFile3 & f);
 void fillgnames(SFile3 & f);
 void fillsheets(SFile3 & f);
 void fillcells(SFile3 & f);
 void fillcols(SFile3 & f); //,sSheet & sh,SD & id);
 void fillrows(SFile3 & f); //,sSheet & sh,SD & id);
 void fillrowbreaks(SFile3 & f);
 void fillfonts(SFile3 & f);
 DED static bool CALLBACK evalv(Eval * e,sWorkbook *wb,token * t,token * nnew);
 DED static bool CALLBACK evalf(Eval * e,sWorkbook *wb,token * f,Stack<token*> & st,token * nnew);
};
typedef LRESULT (CALLBACK * VBA) (sWorkbook &wb);
/*class ExlToHtml {
public:
 sWorkbook wb;
 //DED bool convert(const char * fn=0); //StringData & sd);
 //DED bool convertxml(const char * fn=0,bool protect=false);
 //bool convert(IDatabase * db,VBA vba); //without extension
 DED ~ExlToHtml();

private:
 //DED bool spanned(int r,int c,SDWordArray &hrow,SDWordArray &hcol);
};*/

//class DocToHtml {
//public:
 //sDocument doc;
 //bool convert(IDatabase * db,VBA vba); //without extension
 //DED ~DocToHtml();
//};

#endif

//new Sheet Properties: name2,hsr,her (header row), findsheet,findsheet2
