#ifndef _RENGINE
#define _RENGINE
//#include <afxwin.h>
//#include <afxdisp.h>
//#include <winsock2.h>

#include "eval.h"
#include "baserst.h"
#include "bsort5.h"
#include "ecommon.h"
#include "sfile11.h"

#define MAXICDSIZE (2000)

//extern unsigned short PORT;
typedef unsigned long ulong;
/*#ifndef _DBDAOINT_H_
typedef enum RecordsetTypeEnum {
    dbOpenTable = 1,
    dbOpenDynaset = 2,
} RecordsetTypeEnum;

typedef enum EditModeEnum {
    dbEditNone = 0,
    dbEditInProgress = 1,
    dbEditAdd = 2,
    dbEditChanged = 4,
    dbEditDeleted = 8,
    dbEditNew = 16
} EditModeEnum;

/*typedef enum DataTypeEnum {
    dbBoolean = 1,
    dbByte = 2,
    dbInteger = 3,
    dbLong = 4,
    dbCurrency = 5,
    dbSingle = 6,
    dbDouble = 7,
    dbDate = 8,
    dbBinary = 9,
    dbText = 10,
    dbLongBinary = 11,
    dbMemo = 12,
    dbGUID = 15,
    dbBigInt = 16,
    dbVarBinary = 17,
    dbChar = 18,
    dbNumeric = 19,
    dbDecimal = 20,
    dbFloat = 21,
    dbTime = 22,
    dbTimeStamp = 23
} DataTypeEnum;*/
//#endif

#define RRecordset Recordset
//#define TOTFBUF 25000000 //5 mb
//#define FBUFSIZE (100000) //25000) //0) //(100000/2) //(100000) //50000
//#define MAXFBUFS (100*1024*1024/FBUFSIZE) //100) //10mb*6

class RDatabase;


//#define DBE_SUCCESS 0
//#define DBE_FILE_NOT_FOUND 1
//#define DBE_INVALID_FILE_FORMAT 2
//#define DBE_ERROR 3


/*struct IndexNode {
 //long tablerec;
 _int64 left; // less than
 _int64 right; // greater than
 _int64 next; // for browsing
 _int64 previous; //for browsing
 _int64 root;
 long maxrecs;  //maximum no. of index entries
 long totrecs;  //total no. of index entries (always <=maxrecs)
};*/

/*	struct SpaceTableRec {
		long starting; //starting offset in main database file;
		long size; //count of unused bytes
		//long next; //pointer to next record
	}*/;
/*
struct FieldInfo {
	SD name;
	union {
	 unsigned char datatype;
		bool descending;
		long maxsize;
	};
	FieldInfo() {
		datatype=0;
		descending=false;
		maxsize=0;
	}
};

class IndexStruct {
public:
	SD tablename;
	SD indexname;
 bool addfield(const char * fieldname,bool descending=false);
	bool addfield(FieldInfo & fi);
	long getfieldcount();
	FieldInfo * getfieldinfo(long index);
	void clear();
 ~IndexStruct();
//private:
 SPtrArray fields;
};

class TableStruct {
public:
	SD tablename;
	bool addfield(const char * fieldname,unsigned char dt);
	bool addfield(FieldInfo & fi);
	long getfieldcount();
	FieldInfo * getfieldinfo(long index);
	void clear();
 ~TableStruct();
//private:
 SPtrArray fields;
};*/



#include "rt.h"

struct RST;


/*struct LASTII {
 _int64 lasti;		//file position of cluster node
 _int64 curipos; //file position of current record pointer
 _int64 endipos; //file position AFTER the last record in the cluster
};*/
class Recordset;


/*struct ICHANGE {
 _int64 rootppos;
 _int64 oldli;
 _int64 oldcuri1; //from
 _int64 oldcuri2; //to
 _int64 newli,newcuri,newendi;
};*/

/*struct NDEL {  //deletion notification struct
 SD tablename;
 _int64 oldp;
 struct d2 {
  _int64 oldi,oldcuri,newi,newcuri,newendi,newp;
  bool eof,bof;
 };
 long nd2s;
 SPtrArray d2s;
 ~NDEL() {
  for (int x=1;x<=d2s.GetSize();x++) {
   d2* d=(d2*)d2s.GetAt(x-1);
   delete(d);
  }
 }
 NDEL() {
  nd2s=0;
 }
};*/

class TempTable;


//typedef void (* NOTIFYPROC) (unsigned char * buf,long size); //buf contains the notification data
#define MAXDEPTH 31  //cannot be more
//#define NOTIFYBUFSIZE 10000
//typedef bool (CALLBACK * CHANGECB) (const char * table,char op,Recordset * rst,RDatabase * db);

typedef void (CALLBACK * ONRECONNECT) (bool opened);
class RDatabase:public IDatabase {
 //friend class Database::Helper;
 friend class Recordset;
 //static SPtrArray ndels;
 //static long ndelsize;
 void nocache();
 void remoteopen(RST * rst);
 unsigned char version;
private:
 bool mayreconnect;
 long recvpacket(void * buf,long maxbytes,SOCKET sc,DWORD timeout=60);
 void disconnectsub();
 void buffercleanupnotification();
 struct State {
  SD suser,spwd,pwd,loguser,logcomputer;
  bool log,validate,readonly;
 } state;
 bool sendbytessub(unsigned char * buf,long n);
 void sendcmd();
 static SD cmdbuf;
 static bool autoreconnect;
 bool RDatabase::updateqry(SD & ssql,long * errorpos);
 bool RDatabase::updateqry2(Recordset & r,char &type,const char *tablename,const char *indexname,SDA & sets,SDWordArray & values);
 //void RDatabase::receive2notifications();
 //bool isvalidpos(RST * rst);
 void senduchs();
 SPtrArray uchs;
 long uchsize;
 //char * uchbuf;
 //long uchbufsize;
 //long uchbufoccupied;
 //bool isbuffering;
public:
 ONRECONNECT onreconnect;
 DED double ServerDateTime();
 void addtobuf2(const void * b,long size);
 void addtobuf(const void * b,long size);
 unsigned long streamid;
 unsigned short engid;
 bool checkpwd(const char *pwd);
 void savecache();
 bool IsConnected();
 static const char * modulename;
 SD ExecuteStoredProc(const char * procname,TempTable & rt);
 SD ExecuteStoredProc(const char * procname,SDA &fields,SDA & values,SPtrArray &rts,long & n);
 _int64 uniqueid; //for cache 3
 FILETIME ftc,ftc2; //for cache 3
 void ClearModificationLockEx();
 SD SetModificationLock(SDA &tables,SDA & wherepre,SDA & wherepost);
 SD SetModificationLockEx(DWORD duration,SDA &tables,SDA & wherepre,SDA & wherepost);
 static void CALLBACK removecb(RDatabase *db,FBUF * fbuf);
 static void CALLBACK removecb_more(RDatabase *db,FBUF * fbuf);
 static bool CALLBACK readcb(RDatabase *db,void * buf,_int64 pos,long size,_int64 & fbufwc);
 static bool CALLBACK readcb3(RDatabase *db,void * buf,_int64 pos,long size,_int64 & fbufwc);
 static bool CALLBACK readcb32(RDatabase *db,void * buf,_int64 pos,long size,_int64 & fbufwc);
 static void CALLBACK errorcb(RDatabase *db);
 //static double datetimeadj;
 double lastconnecttime,lastconnecttime2;
 double serverdatetime;
 DWORD conntickcount;
 //static _int64 mac;


 void Replicate(_int64 maxsize);
 bool noconnect;
 DED bool chknotification2();
 DED void recvnotification();
 //CHANGECB changecb;
 unsigned char getdt(const char * tablename,const char * fn);
 IDS * getids(const char * table);
 IDS * getids(int tableid);
 //bool LockDatabase(bool autounlock=true);
 //bool LockTables(const char * tables,bool autounlock=true);
 //void UnLockDatabase();
 //void UnLockTables(const char * tables);

 void BeginTransaction(bool atomic=false);
 void AbortTransaction();
 void EndTransaction(); //bool * locked=0,long * npos=0);
 unsigned long readlong(_int64 pos);
 //void fetchstring(StringData * sd,_int64 pos,nameid * ni);
 //RST * stringrst;
 //static NDEL gndel;
 static _int64 icrootppos;
 //private:
 static unsigned char getfpos(IDS *ids,const char * fn);
 //bool getnext(IndexNode * in, _int64 * inpos,long * curpos);
 //bool getprev(IndexNode * in, _int64 * inpos,long * curpos);
 //bool getleft(IndexNode * in, _int64 * inpos,long * curpos,long *top,long *bot);
 //bool getright(IndexNode * in, _int64 * inpos,long * curpos,long *top,long *bot);
 class Helper {
  //friend class Database;
  public:
  Helper();
  //static char sizeary[10];
  //static long depthary[MAXDEPTH];

  RDatabase * db;
  SFile3 * f; //,*sf;
  //long l;
  //SpaceTableRec sr;
  //IndexNode in;
  
  void checkindex(IDS::indexinfo * inf,SPtrArray * nameids,IDS * ids);
  //void clearia(SPtrArray * ra,SPtrArray *nids);
  void setia(SPtrArray * ra,SPtrArray * nids);
  //void fillia(SPtrArray * ra,SPtrArray *nids,_int64 base);
  void fillia2(SPtrArray * ra,SPtrArray *nids);
  //void fillirec(char * rec,SPtrArray *nids);
  void fetchstringfixed(char * buf,_int64 pos,int maxsize);
  long nrecvpacket(void * buf,long maxbytes);
  //void nrecvpacket();
  bool recvbytes2(int n,SOCKET sc,DWORD timeout=60*4);
  void recvbytes(int & covered,int n,SOCKET sc,DWORD timeout=60*4);
  void recvbytes(int n,SOCKET sc,DWORD timeout=60*4);
  long recvstr(int & covered,SOCKET sc,DWORD timeout=60*4);
  long recvstr(int start);
  long recvstr(SOCKET sc,DWORD timeout=60*4);
  //bool nrecvbytes(int n);
  void sendbytes(unsigned char * buf,long n);
  //bool compacting;
  long startrhpos; //used in addindex when compacting
  //bool positionto(RST * rst,char direction);
  void copyia(void * dest,void * source,unsigned char dt);
  void setstring(StringData *sd,const void * s,long size);
  long gettotfree(SPtrArray * i);
  //void delusedspc(SPtrArray * i);
  long chkusedspc(SPtrArray * i);
  void addusedindex(SPtrArray * i,long root);
  void addusedrec(SPtrArray * i,RecordHeader rh,long rhpos,unsigned char * dt);
  //void addusedspc(SPtrArray * i,SpaceTableRec sr);
  void buildusedspc(SPtrArray * i);
  void fdabuf(SPtrArray * fda,long fdasize, SPtrArray * nameids);
  //void fdabuf(SPtrArray * fda,unsigned char fdasize, unsigned char * datatype);
  void filllr(long ipos,IndexNode * inp,long top,long bot);
  void buildindexlpa(long ipos,long level,long position);
  void dbalcut(IndexNode in,long inpos,char side,long rootppos,long idealdepth,IDS::indexinfo * inf,unsigned char * datatype);
  void decdepthfrom(long ipos);
  //void dbalance(IndexNode in,long inpos,long rootppos,long idealdepth,IDS::indexinfo * inf,unsigned char * datatype,long upto);
  long getmaxlevel(long ipos);
  void updatelevel(IndexNode in, long inpos, long upto,long rootppos,IDS::indexinfo * inf,unsigned char * datatype);
  void breakpn(long ipos);
  void chknext(long pos);
  void ibalance3(IndexNode in,long inpos,long rootppos,IDS::indexinfo * inf,unsigned char * datatype);
  long leveleq(long ipos);
  void getweight(long pos,long * w,long wt);
  void ibalance2(IndexNode in,long inpos,long rootppos);
  bool incbuf(long size);
  void deleteinode2(IndexNode iin,long iinpos,long rootppos,SFile3 * sf,IDS::indexinfo * inf,unsigned char * datatype);
  void ibalance(IndexNode in,long inpos,long rootppos);
  long addinode(IndexNode *in,IndexNode in2,long in2pos,char lr,long rootppos,IDS::indexinfo * inf,unsigned char * datatype);
  void deletemove(RST * rst);
  long buildindexlnr(SDWordArray *tpos,SDWordArray * ipos,long pos,long root,long depth,bool checkno);
  //void checkindex(IDS::indexinfo * inf,unsigned char * datatype,bool checkno=true);
  long deletefromindex(RecordHeader rh,long rhpos,IDS::indexinfo * inf,unsigned char * datatype);
  void setia(SPtrArray * ra,IDS::indexinfo * inf);
  void clearia(SPtrArray * ra,IDS::indexinfo * inf);
  //signed char cmpia(SPtrArray * ra,SPtrArray * ia,IDS::indexinfo * inf,unsigned char *datatype,unsigned char level);
  signed char cmpia2(StringData * sd2,IDS::indexinfo * inf,unsigned char level,_int64 base);

  //signed char cmpia(SPtrArray * ra,SPtrArray * ia,IDS::indexinfo * inf,unsigned char level);
  //void vbfillia(unsigned char * v,unsigned char n,IDS::indexinfo * inf,SPtrArray * ia,unsigned char * datatype);

  //signed char ifcmpia(RST * rst,unsigned char * level);
  //void bfillia(long rpos,RecordHeader*rh,IDS::indexinfo * inf,SPtrArray * ia,unsigned char * datatype); //fills from databuf
  //void fillia(_int64 base,IDS::indexinfo * inf,SPtrArray * ia,unsigned char level);
  //void fillia(RecordHeader rh,IDS::indexinfo * inf,SPtrArray * ia,unsigned char * datatype,unsigned char level);
  long addtoindex(RecordHeader rh,long rhpos,IDS::indexinfo * inf,unsigned char * datatype,long idealdepth);
  void buildlnr(SPtrArray *i,long pos,long root);
  void checksf(bool internal=false,bool detailed=false);
  void checklnr(SPtrArray * i1,SPtrArray * i2);
  void csclear(SPtrArray * i);
  //void notify(unsigned char code,long rid,RST * rst);
  //void wfield(FieldHeader fh,unsigned char fieldtype,const void * buf,long size);
  void deleteinode(IndexNode iin,long iinpos,long rootppos,SFile3 * sf);
  //void getsfi_r(long pos,IndexNode * iin,SpaceTableRec * srr);
  //void deletespc2(SpaceTableRec * rr);
  //void unmarkasfree(long starting,long size);
  static long bufsize;
  //bool ifilbuf(IFILTER * ifil,unsigned char n,unsigned char * datatype);
  //void markasfree(long starting,long size);
  //void addspc2(SpaceTableRec sr,long tablerec);
  //void addspc1(SpaceTableRec sr,long tablerec);
  _int64 readlonglong(_int64 pos);
  char readchar(_int64 pos);
  void readfieldstr(_int64 pos , StringData * sd);
  void writefield(RecordHeader * rhh,long rechpos,unsigned char fieldid,unsigned char fieldtype,const void * buf,long size);
  //void writefield(unsigned char fieldid,void * buf,int count);
  void rhset(long rhpos,long next); //recordheader set
  void fhset(long fhpos,long next); //fieldheader set
  long findspace(long size);
  void alloc_move(long size);
  void getrightnode(IndexNode * in,SFile3 * ff);
  //void readfieldstr(RecordHeader rh,unsigned char fieldid,StringData * sd);
  //bool readfield(RecordHeader rh,unsigned char fieldid,void * buf,unsigned char datatype); //for fixed length fields
  //long getdatapos(RecordHeader rh,unsigned char fieldid);  //for fixed length fields
  long setni(nameid* ni,const char * name,unsigned char dt,long pos);
  void changelastp(long old, long nnew);
  //RST * isvalidrst(void * rst);
  //FieldHeader fh;
  RecordHeader rh;
  //SPtrArray rsts;
  static unsigned char * databuf;
  static long bufpos; //bufpos contains the extent upto which the buffer is currently occupied
  bool addtobuf(const void * data,long size);
  bool addzerotobuf(long size);
 };
 //bool dial(const char * comport,const char * phone);
 SD server,proxy;
 unsigned short port,proxyport;
 //static DWORD WINAPI ThreadProc(LPVOID lp);
 //char signal;
 friend class RDatabase::Helper;
 struct Http {
  SD hash;
  SD s,s2;
  SD buf; //recv buffer....
  long bufpos; //bytes unprocesed in the buffer ....
  long bytespending; //0=new packet
  void unread(long n) {
   ASSERT(n<=bufpos);
   memcpy(buf.buf,buf.buf+n,bufpos-n);
   bufpos-=n;
  }
 } http;
 bool gethash(char hash[16],_int64 pos,long size);
 bool recvhttppkt(DWORD timeout);
 long recvpacketsub(void * buf,long maxbytes,SOCKET sc,DWORD timeout=60);
 long recvpacketsubsub(void * buf,long maxbytes,SOCKET sc,DWORD timeout=60);
 bool RDatabase::sendbytessubsub(unsigned char * buf,long n);
 void _showprogress();
 static unsigned long showprogressslab;
 unsigned long lastbytesinout,bytesin,bytesout;
 static nameid sysni[6];
 static long sysrecsize;
 static nameid tableni[4];
 static long tablerecsize;
 static nameid indexni[6];
 static long indexrecsize;
 DWORD lastrecvtime;
 bool notifications;
 void unread(long n,char err=0);
 bool chargensoc();
 void processnotification();
 void drain(_int64 n,SOCKET sc);
 void copy(char *buf,_int64 n,SOCKET sc);
 static bool compress;
 static long prefetch;
 //typedef struct _poss{_int64 pos,hash;};
 static SArray<_int64> poss;
 static SArray<_int64> poss2; //hash
 bool atomic; //for transactions only
 bool opened,reconnecting;
 BookMark gbm; //database level bookmark, used in ieditmove
 //SFile2 f,sf;
 DED void movelastsub(RST * rst);
 DED void movefirstsub(RST * rst);
 DED long imove(RST * rstt,RST & newr,bool & newrsetted,_int64 from,int n);
 DED long movesub(RST * rst,RST & newr,bool & newrsetted,_int64 from,int n);
 //bool seekcore(RST * rst,const char * d,StringData * sd,unsigned char level,_int64 llastp);
 //bool RDatabase::qfetchstring(StringData * sd,_int64 pos,nameid * ni);
 //bool RDatabase::seekcore(RST * rst,short dd,StringData * sd,unsigned char level,_int64 llastp);
 //DED bool seekcore(RST * rst,const char * d,SPtrArray * ra,unsigned char level,_int64 llastp);
 //unsigned long waitforid;
 //bool flush;
 //bool compacting;  //the entire database is being compacted or recreated
 public:
 void addallids();
 void dumpstruct(const char * filename);
 //void getfield2(RST * rst,signed long pos,StringData & sd);
 //void nunread(long n);
 //bool dial(const char * comport,const char * phone);
 char notifybuf; //[1]; //NOTIFYBUFSIZE];
  //long notifybufpos;
 //unsigned long lastid;
 //void processnotification(SOCKET sc);
 //bool chknotification();
 DWORD lastntime;
 //SFile3 f; //,sf;
 //bool stop_autonumbering,disable_allocmove;
 void moveto(long dest,long src);
 Helper hlp;
 int GetTableCount();
 IDS * gettableinfo(const char * table);
 IDS * gettableinfo(int pos);
 //void idstotablestruct(IDS * ids,TableStruct &ts);
 //void idstoindexstruct(IDS * ids,int indexpos,IndexStruct & is);
 SD GetTableName(int pos);
 bool GetTableStruct(int pos,TableStruct & ts);
 bool GetTableStruct(const char * table,TableStruct & ts);
 int GetIndexCount(const char * table);
 int GetIndexCount(int tablepos);
 static char quiet;
 //bool GetIndexStruct(int tablepos,int indexpos,IndexStruct & is);
 //bool GetIndexStruct(const char * table,int indexpos,IndexStruct & is);
 //bool GetIndexStruct(const char * table,const char * index,IndexStruct & is);
 SPtrArray tableids;
 DED RDatabase(); //bool compact_mode=false);
 DED ~RDatabase();

 SD errorstr; //contains the last error string
 //signed char addindex(IndexStruct * in);
 DED bool Open(const char *fn,const char *suser=0,const char * spwd=0,ADDJOIN adj=0,const char * pwd=0,bool readonly=false,bool log=false,const char * loguser=0,const char * logcomputer=0,bool validate=false);
 //bool create(const char * fn);
 //bool AddTable(TableStruct * ts);
 //bool find(long h,signed long fid,const char * text,char type);
 IDS * addids(const char *tablename);
 
 bool openrst(const char * tablename,const char* indexname,RST * rst); //,Recordset * rrst);
 
 bool attachdll(const char * name);
 DED bool Create(const char * filename,const char *suser=0,const char * spwd=0,ADDJOIN adj=0,const char * pwd=0,bool serverclose=0,bool failifexist=true,bool log=false,const char * loguser=0,const char * logcomputer=0,bool validate=false);
 //bool positionto(RST * rst,char direction);
 //void closerst(long h);
 void clearids(IDS * ids);
 void clearids2(); //const char * tablename);
 DED void Close(bool serverclose=false);
 signed char disableflush(long h);
 signed char enableflush(long h);
 void movefirst(RST * rst);
 void movelast(RST * rst);
 long move(RST * rst,_int64 from,int n);
 void readrecs(long h,long * n,unsigned char * fids, unsigned char nfids,void **buf,long * bufsize);
 void edit(RST * rst,SPtrArray * fda,long fdasize);
 void edit(RST *rst,const unsigned char *buf);
 void append(RST * h,SPtrArray * fda,signed long fdasize,_int64 * newpos);
 void append(RST * h,unsigned char *buf,_int64 * newpos);
 bool ChangePassword(const char *pwd);
 _int64 GetFileSize();
 bool DeleteTable(const char * tablename);
 bool DeleteIndex(const char * tablename,const char *indexname);
 bool DeleteField(const char * tablename,const char *fieldname);
 void ExecuteQuery(SD & query,bool clientside=true);
 void GetFileList(const char * wildcard,SDA & filenames,SByteArray & directory);
 bool GetFile(const char * srcfn,const char * destfn);
 DED bool FetchFile(SD fn,SD * dest=0);
 bool IsFileOk(SD src, SD dest);
 bool GetFileInfo(const char * fn,_int64 * size,FILETIME *ftc,FILETIME *ftw);
 bool SaveFile(const char * src,const char * dest);
 bool IsOpen();
 //SArray2<RowLock> rowlocks;
 //void ExecuteQuery2(const char * query);
 _int64 approxfilesize;
 bool readcanfail;
 static _int64 RDatabase::getmid();
 bool RenameField(const char * tablename,const char *oldfieldname,const char *newfieldname);
 bool RenameIndex(const char * tablename,const char *oldindexname,const char *newindexname);
 bool SetIndexSame(const char * tablename,const char *indexname,const char *fieldname,bool same);
 bool RenameTable(const char * oldtablename,const char *newtablename);
 bool SetPrimaryIndex(const char * tablename,const char *indexname);
 bool AddField(const char * tablename,const char *fieldname, unsigned char datatype,long maxsize=0);
 bool ChangeDatatype(const char * tablename,const char *fieldname, unsigned char datatype,long maxsize=0);
 bool CopyTable(const char * oldtablename,const char *newtablename);
 bool AddIndex(IndexStruct & is);
 bool ModiIndex(IndexStruct & is,bool modi=true);
 bool AddTable(TableStruct & ts);
 bool ModiTable(TableStruct & ts,bool withposition=false,bool modi=true);
 void SetLogUser(const char * user,const char * computer,bool log=true);
 void deletee(RST *rst);
 void RDatabase::loadcache(const char * fn);
 char cache; //0=no cache, 1=cache, 2=checksum cache
 SD getinfo();
 //signed char removefid(long h,unsigned char *fids,unsigned char nfids);
 //void setindexedfilter(long h,const unsigned char *buf);
 bool seek(RST * rst,short d,StringData * sd,unsigned char n,_int64 llastp=0);
 //bool RDatabase::GetProxy(SD & pname,unsigned short & pport);
 //bool seek2(long h,const char * d,unsigned char * v,unsigned char n);
 RawFile cf; //cache file...
 
 bool shouldsavecache; //used in ACA
 long cachefbufsize;
 //bool iseof(RST * rst);
 bool purehttp;
 //bool isbof(RST * rst);
 void ieditmove(long h,SPtrArray * fda,unsigned char fdasize,signed char direction);
 void ieditmove(long h,const unsigned char *buf/*,long * rid*/,signed char direction);
 SDA tablests;
 SArray<ICD> icds;
 SArray<_int64> selfbals;
 bool buffercleanup;
 //void markbookmark(long h);  //because only one bookmark allowed
 //void gotobookmark(long h);  //because only one bookmark allowed
 DED bool Connect(const char * servername,unsigned short port=0,char checkproxy=1);
 DED bool Connect2(const char * servername,unsigned short port=0,const char * phost=0,unsigned short pport=0,bool purehttp=false);
 DED void Disconnect();
 //void disconnectsub();
 //void chkoffline();
 SOCKET soc,nsoc;
 WSAOVERLAPPED overlapped,noverlapped;
 WSAEVENT hevent,nhevents[2];
 //NOTIFYPROC notifyproc;
 //bool waitforconnect();
 //bool connectmsg,error;
 //static LRESULT CALLBACK ErecvProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam/*, void * pp*/);
 //static SPtrArray ary;
};

class TempTable;
class TempTableRst;
struct nameid;
//#include "rst.h"



unsigned char getfpos(Recordset * r,const char * fn);
void cseteof(Recordset * r);


//#include "bsort2.h"



unsigned char getfpos(TempTable * r,const char * fn);
unsigned char getfpos(TempTableRst * r,const char * fn);



#endif

//file size send with database open response
//notification - to tell only the chuncks that have changed based on the client chuncking
