#include "utils2.h"
//#include "ctrls2.h"
#include "baserst.h"
#include "ecommon.h"
#ifndef WINE
 #include "Shlwapi.h"
 #ifndef ENGINE
  #include "tlhelp32.h"
 #endif
 #include "winspool.h"
#endif
//#include <winuser.h>

bool GetFileInfo(const char * fn,_int64 * size,FILETIME *ftc,FILETIME *ftw,FILETIME *fta) {
 //WIN32_FILE_ATTRIBUTE_DATA wd;
 //VERIFY(GetFileAttributesEx(fn,GetFileExInfoStandard,&wd));
 //VERIFY(SetFileAttributesEx(fn,GetFileExInfoStandard,&wd));

 WIN32_FIND_DATA fd;
 HANDLE hf=FindFirstFile(fn,&fd);
 if (hf==INVALID_HANDLE_VALUE) return false;
 FindClose(hf);
 if (size) {
  memcpy(size,&fd.nFileSizeLow,4);
  memcpy(((char *)size)+4,&fd.nFileSizeHigh,4);
 }
 if (ftc) memcpy(ftc,&fd.ftCreationTime,8);
 if (ftw) memcpy(ftw,&fd.ftLastWriteTime,8);
 if (fta) memcpy(fta,&fd.ftLastAccessTime,8);
 return true;
}


SD getqpath(SD path) {
	char buf[1000];DWORD d=1000;
	if (!GetComputerName(buf,&d)) {
  MMsgbox("Error getqpath 1");
		return path;
	}
 int i=path.Find("\\");
	if (i==-1) {
		MMsgbox("Error getqpath 2");
		return path;
	}
	SD ll=path.Left(i);
	ll.Remove(':');
	ll="\\"+ll;
	path=path.Mid(i);
	path=ll+path;
	path=buf+path;
	path="\\\\"+path;
	return path;
}
/*
SD getservername(SD path) {
	if (path.Left(2)=="\\\\") {
		path=path.Mid(2);
		int i=path.Find("\\");
		if (i==-1) {
			MMsgbox("Server Name Prasing error");
			return "";
		}
		path=path.Left(i);
		return path;
	}
	return "";
}*/


SD Maskfix(SD s) {
 s.Remove(' ');
	if (s==".") s="";
	return s;
}

void Maskfix(SD * s) {
 s->Remove(' ');
	if ((*s)==".") (*s)="";
}




/*bool isneumerictype(SHORT type) {
	if (type==dbByte || type==dbInteger || type==dbLong || type==dbCurrency || type==dbSingle || type==dbDouble) {
		return true;
	}
	return false;
}*/

/*SD strw(_int64 n) {
	char buf[100];
	sprintf(buf,"%I64d",n);
	return buf;
}*/

SD lstr(_int64 n) {
	char buf[100];
	sprintf(buf,"%I64d",n);
	return buf;
}

SD hstr(signed long n) {
	char buf[100];
	sprintf(buf,"%X",n);
	return buf;
}

SD str(signed long n) {
 SD sd;
 return str(n,sd);
}

SD dstr(double n,int nod) {
 SD sd;
 return dstr(n,nod,sd);
}


SD dstr(double n) {
 SD sd;
 return dstr(n,sd);
}

SD datestr(int d,int m,int y) {
 SD s;
	char buf[20];
	sprintf(buf,"%02d",d);
	s=buf;s=s+"/";
 sprintf(buf,"%02d",m);
	s=s+buf;s=s+"/";
 sprintf(buf,"%02d",y);
 s=s+(buf+2);
	return s;
}

long strtodate(SD &s) {
 //dd/mm/yyyy
 s.putz();
 int i=s.Find('/');
 int ii=s.Find('/',i+1);
 if (i==-1 || ii==-1) return 0;
 int d=atoi(s.buf);
 int m=atoi(s.buf+i+1); //.Mid(i+1,ii-i);
 int y=atoi(s.buf+ii+1);
 return Date(y,m,d);
}

double strtodatetime(SD & s) {
 s.putz(); //to make it null terminated
 int i1=s.Find('/');
 int i2=s.Find('/',i1+1);
 if (i1==-1 || i2==-1) return 0;
 int d=atoi(s.buf);
 int m=atoi(s.buf+i1+1); //s.Mid(i1+1,i2-i1-1);
 int y=atoi(s.buf+i2+1);
 int i3=s.Find(' ',i2+1);
 int i4=s.Find(':',i3+1);
 int i5=s.Find(':',i4+1);
 if (i3==-1) return Date(y,m,d);
 bool pm=false;
 int i6=s.Find('M',i3+1);
 if (i6==-1) i6=s.Find('m',i3+1);
 if (i6!=-1) pm=(s.buf[i6-1]=='P' || s.buf[i6-1]=='p');
 int h=atoi(s.buf+i3+1);
 int min=0;
 int sec=0;
 if (i4!=-1) min=atoi(s.buf+i4+1);
 if (i5!=-1) sec=atoi(s.buf+i5+1);
 if (pm) {
  if (h<12) h+=12;
  else if (h==12 && min==0 && sec==0) h=24;
 }
 SD sd;
 sd.SetDateTime(y,m,d,h,min,sec);
 return sd.dval;
}


/*bool todate(SD s,COleDateTime * date,bool nullvalid) {
	date->SetStatus(COleDateTime::DateTimeStatus::invalid);
 date->m_dt=0;
 int p1=s.Find('/');
 if (p1==-1) return false;
 int p2=s.Find('/',p1+1);
	if (p2==-1) {
		p2=s.GetLength();
		s=s+"/";
	}
 SD ss;
	ss=s.Left(p1);
 int d=atoi(ss);
	ss=s.Mid(p1+1,p2-p1-1);
 int m=atoi(ss);
	ss=s.Mid(p2+1);
	int y;
 if (ss=="") {
		SYSTEMTIME st;
		::GetSystemTime(&st);
		y=st.wYear;
	} else y=atoi(ss);
	if (d==0) { //y==0 && m==0 && d==0) {
		date->m_dt=0;
		date->m_status=COleDateTime::DateTimeStatus::valid;
		if (nullvalid)	return true;
		return false;
	}
	if (y<85) y=y+2000;
	else if (y<100) y=y+1900;
 {
  p1=ss.Find(" ");
  int hr=0,min=0,sec=0;
  if (p1!=-1) {
   ss=ss.Mid(p1+1);
   hr=atoi(ss);
   p1=ss.Find(':');
   if (p1!=-1) {
    ss=ss.Mid(p1+1);
    min=atoi(ss);
    p1=ss.Find(':');
    if (p1!=-1) {
     ss=ss.Mid(p1+1);
     sec=atoi(ss);
    }
   }
  }
  ss=ss.Right(2);ss.MakeUpper();
  if (ss.Find('P')!=-1) {
   hr+=12;
  }
  date->SetDateTime(y,m,d,hr,min,sec);
 }
	return date->GetStatus()==COleDateTime::DateTimeStatus::valid;
}*/

bool sassert(int line,const char * fn) {
 MMsgbox("Assertion Failed: Line="+str(__LINE__)+SD(", File name=")+__FILE__);
 ::DebugBreak();
 return true;
}

StringData Sysdate2() {
 StringData sd;
 sd.lval=(int)Sysdatetime();
 sd.dt=dtDate;
 return sd;
}

double Sysdatetime() {
 SYSTEMTIME st;
	GetLocalTime(&st);
	//::GetSystemTime(&st);
 SD s;
 s.SetDateTime(st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	return s.dval;
}

SD Sysdate(int n) {
 SYSTEMTIME st;
	::GetSystemTime(&st);
	SD d;
	d.SetDate(st.wYear,st.wMonth,st.wDay);
	d.lval+=n;
 return d.asstring();
}

bool isdate(SD d,bool nullvalid) {
	if (nullvalid) {
		if (Maskfix(d)=="//") return true;
	}
	return strtodate(d)!=0;
}

/*SD DateFormatlong(COleDateTime d) {
 SD s;
	if (d.m_status==COleDateTime::DateTimeStatus::invalid) return "          ";
	char buf[20];
	sprintf(buf,"%02d",d.GetDay());
	s=buf;s=s+"/";
 sprintf(buf,"%02d",d.GetMonth());
	s=s+buf;s=s+"/";
 sprintf(buf,"%04d",d.GetYear());
 s=s+(buf);
	return s;
}*/

void dzfix(SD & sd) { //removes the unnecessary zeros after the decimal point
 while (sd.actualsize>0) {
  if (sd.buf[sd.actualsize-1]=='0') {
   sd.actualsize--;
  } else {
   if (sd.buf[sd.actualsize-1]=='.') sd.actualsize--;
   break;
  }
 }
}

void SetWindowtlbh(HWND hwnd, RECT * rc) {
 //int w=rc->right-rc->left+1;
 //if (w>5280) {w=5280;}
 MoveWindow(hwnd,rc->left,rc->top,rc->right-rc->left+1,rc->bottom-rc->top+1,false);
}

void Getclienttlbh(HWND hwnd, RECT * rc) {
 ::GetClientRect(hwnd,rc);
	rc->bottom--;
	rc->right--;
}

void GetWindowtlbh(HWND hwnd, RECT * rc) {
	POINT pt;
	//GetClientRect(hwnd,rc);
 ::GetWindowRect(hwnd,rc);
	pt.x=rc->left;
	pt.y=rc->top;
	::ScreenToClient(::GetParent(hwnd),&pt);
	rc->left=pt.x;
	rc->top=pt.y;
	pt.x=rc->right;
	pt.y=rc->bottom;
 ::ScreenToClient(::GetParent(hwnd),&pt);
	rc->right=pt.x;
	rc->bottom=pt.y;
	//adjustment .....
	rc->bottom--;
	rc->right--;
}


HFONT CreateFont(FONT * font) { //, HDC hdc){
	//SetGraphicsMode(hdc,GM_ADVANCED);
	HFONT hFont;
	LOGFONT lf;
	//int ly=GetDeviceCaps(hdc, LOGPIXELSY);
 //int lx=GetDeviceCaps(hdc, LOGPIXELSX);
 double h=-(font->size*font->DPIY)/72.0;
 //double w=-(font->width*font->DPIX)/72.0;

	lf.lfHeight=(int)round32(h); //-MulDiv(font->size, font->DPIY, 72);
 lf.lfWidth=0; //-MulDiv(font->width, font->DPIX, 72); //it can be 0
	lf.lfEscapement=font->escapement; //0;
	lf.lfOrientation=font->escapement; //0;
	lf.lfWeight=font->bold ? 700:0;
	lf.lfItalic=font->italic ? 1:0;
	lf.lfUnderline=font->underline ? 1:0;
	lf.lfStrikeOut=font->strikeout ? 1:0;
	lf.lfCharSet=DEFAULT_CHARSET;
	lf.lfOutPrecision=0;
	lf.lfClipPrecision=0;
	lf.lfQuality=0;
	lf.lfPitchAndFamily=0;
	strcpy(lf.lfFaceName,font->name);
	hFont=CreateFontIndirect(&lf);
	return hFont;
}

HFONT zEzCreateFont(HDC hdc,char * FaceName,int PtHeight,int PtWidth,bool bold,bool italic,bool underline,bool strikeout,bool fLogRes){
	FLOAT cxdpi,cydpi;
	HFONT hFont;
	LOGFONT lf;
	POINT pt;
	//goto skip;
	SaveDC(hdc);
	SetGraphicsMode(hdc,GM_ADVANCED);
	ModifyWorldTransform(hdc,NULL,MWT_IDENTITY);
	SetViewportOrgEx(hdc,0,0,NULL);
	SetWindowOrgEx(hdc,0,0,NULL);
	if (fLogRes){
		cxdpi=(FLOAT) GetDeviceCaps(hdc,LOGPIXELSX);
		cydpi=(FLOAT) GetDeviceCaps(hdc,LOGPIXELSY);
	} else {
		cxdpi=(FLOAT) (25.4*GetDeviceCaps(hdc,HORZRES)/GetDeviceCaps(hdc,HORZSIZE));
  cydpi=(FLOAT) (25.4*GetDeviceCaps(hdc,VERTRES)/GetDeviceCaps(hdc,VERTSIZE));
	}
	pt.x=(int) (PtWidth*cxdpi/72);
 pt.y=(int) (PtHeight*cydpi/72);
	DPtoLP(hdc,&pt,1);
	//int temp=-(int) (fabs(pt.y)/10.0+0.5);
//skip:
	//ASSERT(LogPixelsY==GetDeviceCaps(hdc, LOGPIXELSY));
	//int temp2=-MulDiv(PtHeight/10, GetDeviceCaps(hdc, LOGPIXELSY), 72);
 //ASSERT(temp2==temp);
	//lf.lfHeight=temp2;//-(int) (fabs(pt.y)/10.0+0.5);
	lf.lfHeight=-(int) (abs(pt.y)/10.0+0.5);
	lf.lfWidth=0;
	lf.lfEscapement=0;
	lf.lfOrientation=0;
	lf.lfWeight=bold ? 700:0;
	lf.lfItalic=italic ? 1:0;
	lf.lfUnderline=underline ? 1:0;
	lf.lfStrikeOut=strikeout ? 1:0;
	lf.lfCharSet=DEFAULT_CHARSET;
	lf.lfOutPrecision=0;
	lf.lfClipPrecision=0;
	lf.lfQuality=0;
	lf.lfPitchAndFamily=0;
	strcpy(lf.lfFaceName,FaceName);
	hFont=CreateFontIndirect(&lf);
	RestoreDC(hdc,-1);
	return hFont;
}

int MMsgbox(const char * s,UINT type,const char * title){

	HWND h;
	h=::GetFocus();
	//int i=MessageBox(0,s,NULL,type|MB_TASKMODAL/*MB_APPLMODAL/*MB_SYSTEMMODAL*/);
	int i;
#ifdef MMSG2
	MMsgbox2(s);
	i=0;
#else
 i=MessageBox(0,s,title?title:"Message",type|MB_TASKMODAL/*MB_APPLMODAL/*MB_SYSTEMMODAL*/);
#endif
	::SetFocus(h);
//#ifdef _DEBUG
 if (GetKeyState(VK_CONTROL)<0) {
  if (GetKeyState(VK_SHIFT)<0) {
   ::DebugBreak();
   //_asm int 3;
  }

 }
//#endif
	return i;

}

double getdt(long y,long m,long d) {
gg:
	long dd=Date(y,m,d);
 if (dd!=0) return dd;
 if (d<=28) return 0;
	d--;
	goto gg;
}

void Setwidth(HWND hwnd,int n) {
	RECT rc;
 GetWindowtlbh(hwnd, &rc);
	rc.right=rc.left+n-1;
 SetWindowtlbh(hwnd, &rc);
}

void Setheight(HWND hwnd,int n) {
	RECT rc;
 GetWindowtlbh(hwnd, &rc);
	rc.bottom=rc.top+n-1;
 SetWindowtlbh(hwnd, &rc);
}

int Getclientwidth(HWND hwnd) {
	RECT rc;
 Getclienttlbh(hwnd, &rc);
	return rc.right-rc.left+1;
}

int Getclientheight(HWND hwnd) {
	RECT rc;
 Getclienttlbh(hwnd, &rc);
	return rc.bottom-rc.top+1;
}

/*int Getheight(HWND hwnd) {
	RECT rc;
 GetWindowtlbh(hwnd, &rc);
	return rc.bottom-rc.top+1;
}*/

//void testt(HWND hwnd,int w,int h);

HBITMAP CaptureScreen(HWND hwnd,int t, int l, int width, int height) {
	HBITMAP hbitmap;
	HDC hdcmem,hdc;
	//height=height-1;
	hdc=GetDC(hwnd);
	hdcmem=CreateCompatibleDC(hdc);
	hbitmap=CreateCompatibleBitmap(hdc,width,height);
	SelectObject(hdcmem,hbitmap);
	//ASSERT(SetPixel(hdcmem,0,0,RGB(255,255,255))!=-1);
	//BITMAP bmp={0};
 //int i=::GetObject(hbitmap,sizeof(bmp),&bmp);
 //ASSERT(SetPixel(hdcmem,0,0,RGB(255,255,255))!=-1);

	/*{
		HBITMAP hbitmap;
	 HDC hdcmem,hdc;
	 hdc=GetDC(hwnd);
	 hdcmem=CreateCompatibleDC(hdc);
  hbitmap=CreateCompatibleBitmap(hdc,width,height); //width,height);
	 SelectObject(hdcmem,hbitmap);
		ASSERT(SetPixel(hdcmem,0,0,RGB(255,255,255))!=-1);
	 BITMAP bmp={0};
  int i=::GetObject(hbitmap,sizeof(bmp),&bmp);
  ASSERT(i!=0);
  ASSERT(SetPixel(hdcmem,0,0,RGB(255,255,255))!=-1);

	 for (int x=1;x<=width;x++) {
   for (int y=1;y<=height;y++) {
	 		ASSERT(SetPixel(hdcmem,x-1,y-1,RGB(255,255,255))!=-1);
	 	}
	 }
 }
	testt(hwnd,width,height);*/
	//ASSERT(SetPixel(hdcmem,0,0,RGB(255,255,255))!=-1);
	BitBlt(hdcmem,0,0,width,height,hdc,l,t,SRCCOPY);
	DeleteDC(hdcmem);
	ReleaseDC(hwnd,hdc);
	return hbitmap;
}

void PaintBitmap(HWND hwnd, HBITMAP hbitmap,int t, int l) {
	HDC hdc,hdcmem;
	BITMAP bitmap;
	if (hbitmap==0) return;
	GetObject(hbitmap,sizeof(BITMAP),&bitmap);
	hdc=GetDC(hwnd);
 hdcmem=CreateCompatibleDC(hdc);
	SelectObject(hdcmem,hbitmap);
	BitBlt(hdc,l,t,bitmap.bmWidth,bitmap.bmHeight,hdcmem,0,0,SRCCOPY);
 DeleteDC(hdcmem);
 ReleaseDC(hwnd,hdc);
}

void PaintBitmap(HWND hwnd, HBITMAP hbitmap,int t, int l, int height,char dir) {
	HDC hdc,hdcmem;
	BITMAP bitmap;
	if (hbitmap==0) return;
	GetObject(hbitmap,sizeof(BITMAP),&bitmap);
	hdc=GetDC(hwnd);
 hdcmem=CreateCompatibleDC(hdc);
	SelectObject(hdcmem,hbitmap);
	//BitBlt(hdc,l,t,bitmap.bmWidth,bitmap.bmHeight,hdcmem,0,0,SRCCOPY);
	SetStretchBltMode(hdc,COLORONCOLOR);
	StretchBlt(hdc,l,t,bitmap.bmWidth,/*bitmap.bmHeight*/height,hdcmem,0,0,bitmap.bmWidth,bitmap.bmHeight,SRCCOPY);
 DeleteDC(hdcmem);
 ReleaseDC(hwnd,hdc);
}

void Hidewindow(HWND hwnd) {
	::ShowWindow(hwnd,SW_HIDE);
}

void Showwindow(HWND hwnd) {
	::ShowWindow(hwnd,SW_SHOW);
}

void Invalidatewindow(HWND hwnd) {
 if (serverside && hwnd==0) return;
 ::InvalidateRect(hwnd,NULL,false);
}

void Settop(HWND hwnd,int n){  //you may remove oldh
 RECT rc;
	int oldh;
 GetWindowtlbh(hwnd, &rc);
	oldh=rc.bottom-rc.top+1;
	rc.bottom=rc.bottom-rc.top+n;
	rc.top=n;
 SetWindowtlbh(hwnd, &rc);
	GetWindowtlbh(hwnd, &rc);
	//if (rc.bottom-rc.top+1!=oldh) MMsgbox("selfcheck settop");
}

void Setleft(HWND hwnd,int n){  //you may remove oldh
 RECT rc;
 GetWindowtlbh(hwnd, &rc);
	rc.right=rc.right-rc.left+n;
	rc.left=n;
 SetWindowtlbh(hwnd, &rc);
}

bool Isvisible(HWND hwnd) {
	return (GetWindowLong(hwnd,GWL_STYLE) & WS_VISIBLE) == 0 ? false :true;
}

int Gettop(HWND hwnd) {
	RECT rc;
	::GetWindowtlbh(hwnd,&rc);
	return rc.top;
}

int Getleft(HWND hwnd) {
	RECT rc;
	::GetWindowtlbh(hwnd,&rc);
	return rc.left;
}

void Validatewindow(HWND hwnd) {
	::ValidateRect(hwnd,NULL);
}

/*void Invalidatescreen(HWND hwnd,int t,int l, int width, int height) {
 RECT rc;
	POINT pt;
	pt.x=l;pt.y=t;
	ClientToScreen(hwnd,&pt);
 rc.top=pt.y;
	rc.left=pt.x;
	pt.x=l+width-1;
	pt.y=t+height-1;
 ClientToScreen(hwnd,&pt);
 rc.right=pt.x;
	rc.bottom=pt.y;
	rc.bottom=0;rc.left=0;rc.right=0;rc.top=0;
	::InvalidateRect(0,&rc,false);
}*/

struct LLONG{
	int a;
	int b;
};

BOOL CALLBACK MCProc(HWND hwnd,LLONG *s){
	if (::GetParent(hwnd)==(HWND)s->b) {
	 int i=::Gettop(hwnd);
	 i+=s->a;
	 ::Settop(hwnd,i);
	 return TRUE;
	} else {
		return TRUE; //FALSE;
	}
}

void MoveChildren(HWND parent,int m) {
	LLONG s;
	s.a=m;
	s.b=(int)parent;
 EnumChildWindows(parent,(WNDENUMPROC) MCProc,(long)&s);
	//::Hidewindow(parent);
	//::Showwindow(parent);
	//::Invalidatewindow(parent);
	//::Sleep(5000);
	//::Invalidatewindow(parent);
	//::InvalidateChildwindows(parent);
	//::Sleep(5000);
	//::UpdateWindow(parent);
	::Invalidatetree(parent);
	//::Sleep(5000);
	//MMsgbox("updated");
	//::Invalidatetree(GetParent(parent));
}

bool CALLBACK ICWProc(HWND hwnd,LPARAM lp){
	if (lp=='v') ::Validatewindow(hwnd);
	else if (lp=='u') UpdateWindow(hwnd);
 else	::Invalidatewindow(hwnd);
 ::EnumChildWindows(hwnd,(WNDENUMPROC) ICWProc,lp);
	return true;
}

void InvalidateChildwindows(HWND hwnd) {
 if (serverside && hwnd==0) return;
 //all child windows of hwnd will be invalidated
	::EnumChildWindows(hwnd,(WNDENUMPROC) ICWProc,0);
}

void Validatetree(HWND hwnd) {
	::EnumChildWindows(hwnd,(WNDENUMPROC) ICWProc,'v');
	::Validatewindow(hwnd);
}

void Invalidatetree(HWND hwnd) {
 if (serverside && hwnd==0) return;
 //all child windows of hwnd will be invalidated
	::EnumChildWindows(hwnd,(WNDENUMPROC) ICWProc,0);
	::Invalidatewindow(hwnd);
}

bool CALLBACK UPDProc(HWND hwnd,LPARAM lp){
	::UpdateWindow(hwnd);
 ::EnumChildWindows(hwnd,(WNDENUMPROC) UPDProc,0);
	return true;
}

void Updatetree(HWND hwnd) {
 //all child windows of hwnd will be invalidated
	::EnumChildWindows(hwnd,(WNDENUMPROC) UPDProc,0);
	::UpdateWindow(hwnd);
}

void Updatechildwindows(HWND hwnd) {
 //all child windows of hwnd will be invalidated
	::EnumChildWindows(hwnd,(WNDENUMPROC) UPDProc,0);
	//::UpdateWindow(hwnd);
}

/*bool CALLBACK MOVEProc(HWND hwnd,LPARAM lp){
	::UpdateWindow(hwnd);
 ::EnumChildWindows(hwnd,(WNDENUMPROC) UPDProc,0);
	return true;
}

void Movechildwindows(HWND hwnd,) {
 //all child windows of hwnd will be invalidated
	::EnumChildWindows(hwnd,(WNDENUMPROC) UPDProc,0);
	::UpdateWindow(hwnd);
}*/

COLORREF GetBrushColor(HBRUSH hbrush) {
	LOGBRUSH lb;
	GetObject(hbrush,sizeof(lb),&lb);
	return lb.lbColor;
}


SD ltrim(SD s) {
	s.TrimLeft();
	return s;
}


bool AskForRename() {
	HWND h=::GetFocus();
	int i=MessageBox(NULL,"Do you wish to Rename ?","Rename",MB_YESNOCANCEL);
	::SetFocus(h);
	if (i==IDYES) return true;
	return false;
}

bool AskForClose() {
	HWND h=::GetFocus();
	int i=MessageBox(NULL,"Shall I close the window","Close",MB_YESNOCANCEL);
	::SetFocus(h);
	if (i==IDNO) return false;
	return true;
}

bool AskForSeeries() {
	HWND h=::GetFocus();
	int i=MessageBox(NULL,"You are starting a numbering seeries. Allow ?","Seeries",MB_YESNOCANCEL);
	::SetFocus(h);
	if (i==IDYES) return true;
	return false;
}

bool Ask(const char * s) {
	HWND h=::GetFocus();
	int i=MessageBox(NULL,s,0,MB_YESNOCANCEL);
	::SetFocus(h);
	if (i==IDYES) return true;
	return false;
}

bool AskForDelete() {
	HWND h=::GetFocus();
	int i=MessageBox(NULL,"Are you sure you want to delete this record?","Delete",MB_YESNOCANCEL);
	::SetFocus(h);
	if (i==IDYES) return true;
	return false;
}

SD Maskset(SD mask,SD s) {
	Maskset(&mask,&s);
	return s;
}

void Maskset(SD * mask,SD * s){
 if ((*mask)=="") return;
	//if (mask->GetLength()>=8 && mask->Mid(2,1)=="/" && mask->Mid(5,1)=="/") {
 if (mask->GetLength()>=8 && mask->GetAt(2)=='/' && mask->GetAt(5)=='/') {
		if ((*s)=="") {
			(*s)=(*mask);(*s).Replace('9',' ');
			return;
		} else {
   if (s->GetLength()>=8 && s->GetAt(2)=='/' && s->GetAt(5)=='/') {
    (*s)=s->Left(10);
			 if (mask->GetLength()==8) { //s->GetLength()) {
				 (*s)=s->Left(6)+s->Right(2);//Right(2);
			 //} else {
     //(*s)=s->Left(mask->GetLength());
    }
   }
		}
	} else {
		int pos=mask->Find('X')+1;
  if (pos!=0) {
			s->Remove(' ');
   SD m=mask->Left(pos-1);
			int z=s->GetLength();
			//char c=s->GetAt(z);
			int x;
			for (x=z;x>=1;x--) {
				if (s->GetAt(x-1)<='9') break;
			}
			SD s2=s->Left(x);
   ::Maskset(&m,&s2);
   (*s)=s2+s->Mid(x);
			pos=mask->GetLength()-s->GetLength();
   for (x=1;x<=pos;x++) (*s)+=" "; //->>Insert(
			return;
		}
		pos=mask->Find('.')+1;
		if (pos==0 || pos==mask->GetLength()) {
   int n=s->Find(".");
			if (n>=0) {
				(*s)=str((long)round32(atof(*s))); //s->Left(n);		//truncate decimal if present
			}
			n=mask->GetLength()-s->GetLength();
			for (int x=1;x<=n;x++) s->Insert(0,' ');
		} else {
			int ll=pos-1;	//left len
			int rl=mask->GetLength()-pos;//right len
			if ((*s)!="") {
			 Maskfix(s);
    //int i=strlen(*s);
			 *s=dstr(atof(*s),rl);
			}
			//rl=0;
   pos=s->Find('.')+1;
   if (pos==0) {
				(*s)+=".";
				pos=s->GetLength();
			}
			int n=rl-(s->GetLength()-pos);
			//ASSERT(n==0);
			int x;
   for (x=-1;x>=n;x--) s->Delete(s->GetLength()-1);
   for (x=1;x<=n;x++) s->Insert(s->GetLength(),' ');
   n = ll - (pos - 1);
   for (x=1;x<=n;x++) s->Insert(0,' ');
			n=s->GetLength();
   for (x=1;x<=n;x++) {	//if the s is not blank, then convert spaces after the decimal to zeros
				if ((*s)[x-1]>='0' && (*s)[x-1]<='9') {
					pos=s->Find('.')+1;
     for (int y=pos+1;y<=s->GetLength();y++){
						if ((*s)[y-1]==' ') s->SetAt(y-1,'0');
					}
					break;
				}
			}
		}
	}
}

int Bside(HWND hwnd){
 RECT rc;
	::GetWindowtlbh(hwnd,&rc);
	return max(rc.top,rc.bottom); //for zero height
}

int Rside(HWND hwnd){
 RECT rc;
	::GetWindowtlbh(hwnd,&rc);
	return max(rc.left,rc.right); //for zero width
}

int Lside(HWND hwnd){
 RECT rc;
	::GetWindowtlbh(hwnd,&rc);
	return rc.left;
}


bool DrainMessages() {
	MSG msg;
	bool quit=false;
	while (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
		if (msg.message==WM_QUIT) quit=true;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return quit;
}

//void FlushMessages() {
//}

void FlushMessages() {
	MSG msg; //CUIntArray a;
	while (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
		TranslateMessage(&msg);
		//if (isinputmsg(msg.message);
		//if (true || msg.hwnd==mdiapp->hwnd) a.Add(msg.message);
		if (msg.message!=15); // a.Add(msg.message);
		else DispatchMessage(&msg);
	}
 //for(int x=1;x<=a.GetSize();x++) {
		//UINT z=a.GetAt(x-1);
	//}
}

//bool isinputmsg(UINT msg) {
//	if (msg==WM_KEYDOWN
//}

//HDC GetPrinterDC(void) {
//	DWORD dwNeeded,dwReturned;

//void DispDaoerror(SDaoException &e) {
	//MMsgbox(e.m_pErrorInfo->m_strDescription);
//}

//void Disperr(CException * e) {
	//e->ReportError();
	//MMsgbox(e.m_pErrorInfo->m_strDescription);
//}

void seteof(bbaserst * r) {
	r->MoveLast();
	r->MoveNext();
}


void setbof(bbaserst * r) {
	r->MoveFirst();
	r->MovePrev();
}


bool isinbetween(int n,int a,int b) {
	if (n>=a && n<=b) return true;
	if (n>=b && n<=a) return true;
	return false;
}
int Bside3(HWND hwnd,HWND parent) {
	POINT p;p.x=0;p.y=::Getclientheight(hwnd)-1;
	::ClientToScreen(hwnd,&p);
 POINT p2;p2.x=0;p2.y=0;
	::ClientToScreen(parent,&p2);
	return p.y-p2.y;
}

int Bside2(HWND hwnd,HWND parent) {
	if (hwnd==0) {tthrow("selfcheck - "+str(__LINE__)+", File name="+__FILE__);return 0;}
	if (GetParent(hwnd)==parent) return Bside(hwnd);
 return Bside2(GetParent(hwnd),parent);
}

int Lside2(HWND hwnd,HWND parent) {
	if (hwnd==0) {tthrow("selfcheck - "+str(__LINE__)+", File name="+__FILE__);return 0;}
	if (GetParent(hwnd)==parent) return Lside(hwnd);
 return Lside2(GetParent(hwnd),parent);
}

int Tside2(HWND hwnd,HWND parent) {
	if (hwnd==0) {tthrow("selfcheck - "+str(__LINE__)+", File name="+__FILE__);return 0;}
	if (GetParent(hwnd)==parent) return Gettop(hwnd);
 return Tside2(GetParent(hwnd),parent);
}

int Rside2(HWND hwnd,HWND parent) {
	if (hwnd==0) {tthrow("selfcheck - "+str(__LINE__)+", File name="+__FILE__);return 0;}
	if (GetParent(hwnd)==parent) return Rside(hwnd);
 return Rside2(GetParent(hwnd),parent);
}

HWND gethwnd(HWND h,HWND ph) { //returns the immediate child hwnd
 while (true) {
		HWND hh=GetParent(h);
		if (hh==ph) return h;
  h=hh;
		if (h==0) tthrow("selfcheck - "+str(__LINE__)+", File name="+__FILE__);
	}
}


SD Gettext(HWND hwnd) {
 int l;
	char *ss;
 l=::GetWindowTextLength(hwnd)+1;
	ss=(char*)malloc(l);
	::GetWindowText(hwnd,ss,l);
	SD s;
	(s)=ss;
	free(ss); //delete(ss); - dont use delete
	return s;
}

void Sendmouseclick(int y,UINT msg) {
	//INPUT *i;
	/*i.type=INPUT_MOUSE;
	i.mi.dx=0;
	i.mi.dy=0;
	i.mi.mouseData=0;
	::SendInput(1,&i,sizeof(INPUT));*/
	if (msg==WM_LBUTTONDOWN) {
	 mouse_event(MOUSEEVENTF_LEFTDOWN,y+0,y,0,0);
	 mouse_event(MOUSEEVENTF_LEFTUP,y+0,y,0,0);
	} else {
  mouse_event(MOUSEEVENTF_RIGHTDOWN,y+0,y,0,0);
	 mouse_event(MOUSEEVENTF_RIGHTUP,y+0,y,0,0);
	}
}

void Sendkey(BYTE key) {
	keybd_event(key,0,0,0);
}


SD Alltrim(SD s) {
	s.TrimLeft();
	s.TrimRight();
	return s;
}

#ifndef JPEGTOBMP
HBITMAP jpegtobmp(const char * filename,void ** membuf) {
	return 0;
}
#else

extern "C" {
#include "jpeglib.h"
}

bool bmptojpeg(FILE * outfile,unsigned char * buf,int width,int height,int rowsize,bool mono,RGBQUAD * ctable,ULONG numentries) {
  struct jpeg_compress_struct cinfo;
		struct jpeg_error_mgr jerr;
		//FILE * outfile;		/* target file */
		JSAMPROW row_pointer[1];	/* pointer to JSAMPLE row[s] */
  //int row_stride;		/* physical row width in image buffer */
 	//DIBSECTION dib={0};
  //if (!GetObject(hbmp,sizeof(dib),&dib)) return false;
  /*if ((outfile = fopen(filename, "wb")) == NULL) {
   MMsgbox("Unable to create output file");
			return false;
  }*/
  if (ctable) {
			ASSERT(mono);
			mono=false;
		}
  cinfo.err = jpeg_std_error(&jerr);
		jpeg_create_compress(&cinfo);
		jpeg_stdio_dest(&cinfo, outfile);
  cinfo.image_width = width; //dib.dsBm.bmWidth; 	/* image width and height, in pixels */
  cinfo.image_height = height; //dib.dsBm.bmHeight;
  cinfo.input_components = mono?1:3;		/* # of color components per pixel */
  cinfo.in_color_space = mono?JCS_GRAYSCALE:JCS_RGB; 	/* colorspace of input image */
  jpeg_set_defaults(&cinfo);
		jpeg_set_quality(&cinfo, 50/*10/*30/*50/*75/*quality*/, TRUE /* limit to baseline-JPEG values */);
  jpeg_start_compress(&cinfo, TRUE);
		//unsigned char * buf=(unsigned char *)dib.dsBm.bmBits;
		ASSERT(abs(rowsize)>=width*((ctable || mono)?1:3));
  //int rowbytes=width*3;
		//if ((rowbytes % 2)==0);
		//else rowbytes+=(2-(rowbytes % 2));
		/*MMsgbox("rowsize="+str(rowsize));
		MMsgbox("rowbytes="+str(rowbytes));
  MMsgbox("width="+str(width));
  MMsgbox("height="+str(height));
		ASSERT(rowbytes<=-rowsize);
		rowbytes=-rowsize;*/
		unsigned char * cbuf;
  if (ctable) {
			cbuf=(unsigned char *) malloc(abs(width*3));
		} else {
		 cbuf=(unsigned char *) malloc(abs(rowsize));
		}
		//char aa[256]={0};
		while (cinfo.next_scanline < cinfo.image_height) {
			if (ctable) {
    for (int x=1;x<=width;x++) {
     unsigned char index=*(buf+(cinfo.next_scanline*rowsize)+x-1);
					if (index<=numentries-1) {
					 cbuf[(x-1)*3]=ctable[index].rgbRed;
      cbuf[((x-1)*3)+1]=ctable[index].rgbGreen;
      cbuf[((x-1)*3)+2]=ctable[index].rgbBlue;
					}
				}
			} else {
			 memcpy(cbuf,buf+(cinfo.next_scanline*rowsize),abs(rowsize));
			}
			row_pointer[0] = cbuf; //buf+(cinfo.next_scanline*rowsize); //dib.dsBm.bmWidthBytes);
			//can't use straight - have to reorder BGR to RGB
			if (!mono && !ctable) {
			 for (unsigned int x=1;x<=cinfo.image_width;x++) {
     unsigned char * c=cbuf+((x-1)*3);
			 	unsigned char temp;
			 	temp=*c;
			 	*c=*(c+2);
			 	*(c+2)=temp;
			 }
			} else {
				/*if (mono) {
				 for (int x=1;x<=abs(rowsize);x++) {
				 	aa[cbuf[x-1]]=1;
				 }
				 int count=0;
     for (x=1;x<=256;x++) {
      if (aa[x-1]==1) count++;
				 }
				 MMsgbox(str(count));
				 //ASSERT(count<=32);
				}*/
			}
			(void) jpeg_write_scanlines(&cinfo, row_pointer, 1);
		}
		free(cbuf);
		jpeg_finish_compress(&cinfo);
		//fclose(outfile);
		jpeg_destroy_compress(&cinfo);
		return true;
}

bool bmptojpeg(HBITMAP hbmp,const char * filename) {
  struct jpeg_compress_struct cinfo;
		struct jpeg_error_mgr jerr;
		FILE * outfile;		/* target file */
		JSAMPROW row_pointer[1];	/* pointer to JSAMPLE row[s] */
  //int row_stride;		/* physical row width in image buffer */
 	DIBSECTION dib={0};
  if (!GetObject(hbmp,sizeof(dib),&dib)) return false;
  if ((outfile = fopen(filename, "wb")) == NULL) {
   MMsgbox("Unable to create output file");
			return false;
  }
  cinfo.err = jpeg_std_error(&jerr);
		jpeg_create_compress(&cinfo);
		jpeg_stdio_dest(&cinfo, outfile);
  cinfo.image_width = dib.dsBm.bmWidth; 	/* image width and height, in pixels */
  cinfo.image_height = dib.dsBm.bmHeight;
  cinfo.input_components = 3;		/* # of color components per pixel */
  cinfo.in_color_space = JCS_RGB; 	/* colorspace of input image */
  jpeg_set_defaults(&cinfo);
		jpeg_set_quality(&cinfo, 75/*quality*/, TRUE /* limit to baseline-JPEG values */);
  jpeg_start_compress(&cinfo, TRUE);
		unsigned char * buf=(unsigned char *)dib.dsBm.bmBits;

		while (cinfo.next_scanline < cinfo.image_height) {
			row_pointer[0] = buf+(cinfo.next_scanline*dib.dsBm.bmWidthBytes);
			//can't use straight - have to reorder BGR to RGB
			for (unsigned int x=1;x<=cinfo.image_width;x++) {
    unsigned char * c=row_pointer[0]+((x-1)*3);
				unsigned char temp;
				temp=*c;
				*c=*(c+2);
				*(c+2)=temp;
			}
			(void) jpeg_write_scanlines(&cinfo, row_pointer, 1);
		}
		jpeg_finish_compress(&cinfo);
		fclose(outfile);
		jpeg_destroy_compress(&cinfo);
		return true;
}

METHODDEF(void)
my_error_exit (j_common_ptr cinfo)
{
  /* cinfo->err really points to a my_error_mgr struct, so coerce pointer */
 // my_error_ptr myerr = (my_error_ptr) cinfo->err;

  /* Always display the message. */
  /* We could postpone this until after returning, if we chose. */
  //(*cinfo->err->output_message) (cinfo);

  /* Return control to the setjmp point */
  //longjmp(myerr->setjmp_buffer, 1);
	throw 1;
}

HBITMAP jpegtobmp(const char * filename,void ** membuf) {
	struct jpeg_decompress_struct cinfo;
	struct jpeg_error_mgr jerr;
	FILE *infile; //input jpeg file
	int row_stride; //physical row width in output buffer
	JSAMPARRAY buffer; //row buffer

	//vars required to disply jpeg img
	HBITMAP bmp;
	//HDC hdc2;
	BITMAPINFO bmpInfo;
 //	BITMAPV4HEADER bmpHeader;
	unsigned char * pbmpBits;
	int pad_bytes; //no of bytes needed to pad the row to 4 byte (DWORD) boundary

		//step -2 - specify source file
	  if (strlen(filename)==0) return 0;
			if((infile = fopen(filename, "rb"))==NULL) {
				//MessageBox(NULL, "Can't open file","error", MB_OK);
				return 0;
			}

			//step 1 - create decompress object
			cinfo.err = jpeg_std_error(&jerr);
			jerr.error_exit=my_error_exit;
			try{
			jpeg_create_decompress(&cinfo);
   jpeg_stdio_src(&cinfo, infile);

			//step - 3 - read header for image info
			jpeg_read_header(&cinfo, TRUE);

			//step 4 - set params for decompresion
			cinfo.out_color_space = JCS_RGB;

			//step 5 - start decompress
			jpeg_start_decompress(&cinfo);
			//calculate physical row width
			row_stride=cinfo.output_width*cinfo.output_components;
			//allocate memory for the row buffer
			buffer = (*cinfo.mem->alloc_sarray)
				((j_common_ptr)&cinfo, JPOOL_IMAGE, row_stride, 1);
			//create a blank in memory bitmap
			//hdc2 = CreateCompatibleDC(hdc);
			memset(&bmpInfo, 0, sizeof(bmpInfo));
			bmpInfo.bmiHeader.biSize = sizeof(bmpInfo.bmiHeader);
			bmpInfo.bmiHeader.biWidth = cinfo.output_width;
			bmpInfo.bmiHeader.biHeight = -1 * cinfo.output_height;
			bmpInfo.bmiHeader.biPlanes = 1;
			bmpInfo.bmiHeader.biBitCount = 24;
			bmpInfo.bmiHeader.biCompression = BI_RGB;


			//create the DIB bitmap - system automatically allocates mem for buffer
			bmp = CreateDIBSection(0/*hdc2*/, &bmpInfo, DIB_RGB_COLORS, (void **)&pbmpBits, NULL, 0);
   if	(membuf) (*membuf)=pbmpBits;
			//calculate the number of pad bytes
			if((row_stride % 4)==0)
				pad_bytes=0;
			else	pad_bytes = 4-(row_stride % 4);
			DIBSECTION dib;
			::GetObject(bmp,sizeof(dib),&dib);
			ASSERT(dib.dsBm.bmWidthBytes>=row_stride);
			pad_bytes=dib.dsBm.bmWidthBytes-row_stride;
			//step 6 - while (more rows do)
			//            jpeg_read_scanlines
			while(cinfo.output_scanline<cinfo.output_height) {
				JSAMPROW row;
				jpeg_read_scanlines(&cinfo, buffer, 1);
				row = buffer[0];

				//move the scanline to the bitmap
				//memcpy(pbmpBits, row, row_stride);
				//pbmpBits += row_stride; //pbmpBits now points to end of scan line just written to buffer

				//can't use straight memcpy - have to reorder RGB to BGR
				for(int i=cinfo.output_width; i>0; i--) {
					*pbmpBits++ = row[2];
					*pbmpBits++ = row[1];
					*pbmpBits++ = row[0];
					row+=3;
				}
				//zero out the pad_bytes
				switch(pad_bytes) {
				case 3:
					*pbmpBits++=0; //intentional fallthrough to next case label
				case 2:
					*pbmpBits++=0;
				case 1:
					*pbmpBits++=0;
				}
			}

			//step 7 - finish decompress
			jpeg_finish_decompress(&cinfo);

			//step 8 - release decompression object
			jpeg_destroy_decompress(&cinfo);

			fclose(infile);
			}
			catch (int) {
    jpeg_destroy_decompress(&cinfo);
    fclose(infile);
				//MMsgbox("cought..");
    return 0;
			}
 return bmp;
}
#endif



void zap(baserst * r) {
	r->movefirst();
	while (!r->iseof()) {
		r->Delete();
		r->movenext();
	}
}

/*double atoff(const char * s) {
	if (s==0) return 0;
	return atof(s);
}*/


bool Shellexecute(const char * name,const char * param) {
	if ((int)ShellExecute(0,"open",name,param,0,SW_SHOW)>32) return true;
	return false;
}


BOOL Execute(SD fn,const char * cmdline,LPPROCESS_INFORMATION pi,bool hidden) {
	//MMsgbox(fn);
 //MMsgbox(cmdline);
	STARTUPINFO si;memset(&si,0,sizeof(si));
	si.cb=sizeof(si);
	if (hidden) {
		si.dwFlags=STARTF_USESHOWWINDOW;
		si.wShowWindow=SW_HIDE;
	}
	PROCESS_INFORMATION pii;
	if (pi==0) pi=&pii;
	if (cmdline!=0) {
	 fn+=" ";
	 fn+=cmdline;
	}
	BOOL b=::CreateProcess(0,(char *)(const char *)fn,0,0,0,(hidden?CREATE_NO_WINDOW:0),0,0,&si,pi);
	//fn.ReleaseBuffer();
	//MMsgbox("done ...");
	//DWORD d=::GetLastError();
 return b;
}

bool scmp(SD * s1,SD * s2,bool reset) {
	//s1=string to be searched
	//s2=string being searched
	static char type;
	if (reset) {
		type=0;
  if (s1->GetAt(0)=='*') type=1;
  if (s1->GetAt(s1->GetLength()-1)=='*') type+=2;
  s1->Remove('*');
		return true;
	}
	if (type==0) {
		return (*s1==*s2);
	} else if (type==1) { //* at left
  return (s2->Right(s1->GetLength())==*s1);
	} else if (type==2) { //* at right
  return (s2->Left(s1->GetLength())==*s1);
	} else {
  return (s2->Find(*s1)!=-1);
	}
}

bool Iswindowmaximized(HWND hwnd) {
 BOOL b=::IsZoomed(hwnd);
 if (b) return true; else return false;
}

void Maximizewindow(HWND hwnd) {
	WINDOWPLACEMENT wp;memset(&wp,0,sizeof(wp));
	wp.length=sizeof(wp);
	wp.showCmd=SW_SHOWMAXIMIZED;
	::SetWindowPlacement(hwnd,&wp);
}

SD Getfullname() {
 char ss[100];
	if (strlen(::GetCommandLine())>100-1) {
		MMsgbox("Error: Comand line length greater than 100");
		return "";
	}
	strcpy(ss,::GetCommandLine());
 SD name=ss;
 name.Remove(34);
 name.MakeUpper();
	name.TrimRight();
	int i=name.Find(' ');
	if (i!=-1) name=name.Left(i);
	return name;
}

/*SD Getpath2(const char * fn) {
 SD path;
	char ss[1000];
	//AfxGetInstanceHandle();
	//MMsgbox(str((long)afxCurrentInstanceHandle));
 if (afxCurrentInstanceHandle==0) {
		afxCurrentInstanceHandle=GetModuleHandle(fn);
	}
	//MMsgbox(str((long)afxCurrentInstanceHandle));
	GetModuleFileName(AfxGetInstanceHandle(),ss,1000);
 PathRemoveFileSpec(ss);
	path=ss;
	//}
	if (path.Right(1)!="\\") path+="\\";
	//path.Remove(34);
	return path;
}*/


void cmdline(SDA & a) {
 SD s=::GetCommandLine();
 int i;
 while (s!="")  {
  if (s.GetAt(0)=='"') {
   i=s.Find('"',1);
   ASSERT(i!=-1);
   a.Add(s.Mid(1,i-1));
   s=Alltrim(s.Mid(i+1));
  } else {
   i=s.Find(' ');
   if (i==-1) {
    a.Add(Alltrim(s));
	   s="";
   } else {
    a.Add(s.Left(i));
    s=Alltrim(s.Mid(i+1));
   }
  }
 }
}

SD Getpath(const char *fn,bool full) {
 SD path;
	char ss[1000];
	//void * p=Getpath;
 HMODULE hm; //=::GetModuleHandle(0);
 if (fn!=0) {
  hm=::GetModuleHandle(fn);
 } else {
  hm=::GetModuleHandle(0);
 }
 ASSERT(hm!=0);
	GetModuleFileName(hm,ss,1000);
 if (!full) {
  PathRemoveFileSpec(ss);
	 path=ss;
  if (path.Right(1)!="\\") path+="\\";
  return path;
 }
 return ss;
}


/*int getvsize(VARTYPE vt) {
	if (vt==VT_NULL) return 0;
 else if (vt==VT_I2) return 2;
 else if (vt==VT_I4) return 4;
	else if (vt==VT_R4) return 4;
	else if (vt==VT_R8) return 8;
 else if (vt==VT_CY) return sizeof(CY);
 else if (vt==VT_DATE) return sizeof(DATE);
	else if (vt==VT_BSTR) return -1;
 else if (vt==VT_BOOL) return sizeof(VARIANT_TRUE);
	else if (vt==VT_UI1) return sizeof(VT_UI1);
	else {
		return sizeof(VARIANT)-(sizeof(short)*4);
		MMsgbox("selfchec error .. variant type");
	}
	return -99;
}*/

void delay(WORD milliseconds) {
	DWORD t=GetTickCount();
	while(GetTickCount()-t <= milliseconds) ;
}

#ifndef ENGINE
#ifndef WINE
int countinstances95() {
	//return 1;
	int count=0;
 HANDLE h=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
	SD s= Getfullname();
	int i;
	i=s.ReverseFind('\\');
	if (i!=-1) {
		s=s.Mid(i+1);
	}
	SD s2=s+".exe";
	PROCESSENTRY32 pi;memset(&pi,0,sizeof(pi));
	pi.dwSize=sizeof(PROCESSENTRY32);
	BOOL b=Process32First(h,&pi);
	SD ss=pi.szExeFile;
	if (s.CompareNoCase(ss)==0 || s2.CompareNoCase(ss)==0) count++;
 while (Process32Next(h,&pi)) {
		ss=pi.szExeFile;
		i=ss.ReverseFind('\\');
	 if (i!=-1) {
	 	ss=ss.Mid(i+1);
	 }
  if (s.CompareNoCase(ss)==0 || s2.CompareNoCase(ss)==0) count++;
		else {
   i=ss.ReverseFind('_');
	  if (i!=-1) {
		 	ss=ss.Left(i);
		 	ss.TrimRight();
		 }
			if (s.CompareNoCase(ss)==0 || s2.CompareNoCase(ss)==0) count++;
   //if (strcmp(s,ss)==0) count++;
		}
	}
	CloseHandle(h);
	return count;
}
#else
int countinstances95() {
	return 1;
}

#endif
#endif

HINSTANCE gethinst() {
 return 0;
 return (HINSTANCE)GetWindowLong(GetActiveWindow(), GWL_HINSTANCE);
}


void Flushallmsg(UINT message,HWND hwnd) { //flush all except message
 MSG msg;
	while(PeekMessage(&msg,hwnd,0,0,PM_REMOVE)) {
		if (/*message==0 || */msg.message==message || msg.message==WM_PAINT) {
		 TranslateMessage(&msg);
		 DispatchMessage(&msg);
		}
	}
}

/*int safeconnect(SOCKET s,PSOCKADDR sa,int z) {
	::PostQuitMessage(0);
	int i=connect(s,sa,z);
	Flushallmsg(sb_SOCKET); //except sb_socket
 return i;
}

HOSTENT * safegethostbyname(const char * name) {
 ::PostQuitMessage(0);
	HOSTENT * h=gethostbyname(name);
 Flushallmsg(sb_SOCKET); //except sb_socket
	return h;
}*/

void selfcheck() {
	MMsgbox("Selfcheck error .....");
}

_int64 _roundl(double d) {
	//ASSERT(d>0);
	_int64 i=_int64(d);
	//double dd=d-int(d);
 if (d>=0) {
  if (d-i>0.499999999) {
	 	return i+1;
	 } else {
	 	return i;
	 }
 } else {
  if (d-i<-0.499999999) {
	 	return i-1;
	 } else {
	 	return i;
	 }
 }
}


long round32(double d) {
 if (d>=0) return long(d+0.500000001);
 return long(d-0.500000001);
}

_int64 round64(double d) { //benchmark with ceil() function for double to double rounding (used in PFRPT::filltot())
 if (d>=0) return _int64(d+0.500000001);
 return _int64(d-0.500000001);
}

double rounddbl(double d) { //benchmark with ceil() function for double to double rounding (used in PFRPT::filltot())
 if (d>=0) return floor(d+0.500000001);
 return ceil(d-0.500000001);
}

/*_int64 round(double d) {
	_int64 i=_int64(d);
 if (d>=0) {
  if (d-i>0.499999999) {
	 	return i+1;
	 } else {
	 	return i;
	 }
 } else {
  if (d-i<-0.499999999) {
	 	return i-1;
	 } else {
	 	return i;
	 }
 }
}*/

/*int round(double d) {
	int i=int(d);
 if (d>=0) {
  if (d-i>0.499999999) {
	 	return i+1;
	 } else {
	 	return i;
	 }
 } else {
  if (d-i<-0.499999999) {
	 	return i-1;
	 } else {
	 	return i;
	 }
 }
}*/

StringData replicate(const char *s,int n) {
	StringData ss;
	for (int x=1;x<=n;x++) {
		ss+=s;
	}
 return ss;
}

double roundt(double d,double tens) {
	return (double)round64(d*tens)/(double)tens;
	//return d;
}

double round(double d,char nod) {
	int ten=1;
 while (nod>0) {
  ten*=10;
  nod--;
 }
	d*=ten;
	return (double)round64(d)/(double)ten;
	//return d;
}

double roundh(double d,char nod) {
	//ASSERT(d>0);
	double f=pow(10.0,nod);
	d*=f;
	d=ceil(d);
 d/=f;
	return d;
}

int round2(double d,char bias) {
	//ASSERT(d>0);
	double dd=d-int(d);
	if (bias=='l') {
  if (dd>=0.85) {
		 return int(d)+1;
	 } else {
	 	return int(d);
	 }
	} else if (bias=='r') {
  if (dd>=1-0.85) {
		 return int(d)+1;
	 } else {
	 	return int(d);
	 }
	} else {
		MMsgbox("selfcheck...");
		return 0;
	}
}

bool toblocking(SOCKET soc,HWND hwnd) {
	int i=WSAAsyncSelect(soc,hwnd,0,0);
	if (i!=0) {
		return false;
	}
	unsigned long l=0;
	i=ioctlsocket(soc,FIONBIO,&l);
 if (i!=0) {
		return false;
	}
	return true;
}


void deleteclear(baserst * rst) {
	rst->movenext();
	if (rst->iseof() && !rst->isbof()) { //not necessary for rengine ...
		try {
			rst->moveprev();		//setting bof also
   rst->movenext();
		}
		catch (...) {}
	}
}



/*int textheight() {
 HDC hdc=GetDC();
	TEXTMETRIC tm;
	::GetTextMetrics(hdc,&tm);
	SIZE size;
 ::GetTextExtentPoint32(hdc,"99",2,&size);
 ReleaseDC(NULL,hdc);
}*/

bool setfiletext(const char * fn,const char * text) {
 return writefiletext(fn,text);
}

SD readfiletext(const char * fn) {
 SD s;
 FILE * f;
	f=fopen(fn,"rb");
	if (f==NULL) return "";
	fseek(f,0,SEEK_END);
	int size=ftell(f);
	char *buf=(char *)malloc(size+1);
	if (buf==0) {
		MMsgbox("insufficient memory");
		fclose(f);
		return "";
	}
 fseek(f,0,SEEK_SET);
 fread(buf,size,1,f);
 buf[size]=0;
	s=buf;
	free(buf);
	fclose(f);
	return s;
}

void getfilelines(const char * fn,SDA & s) {
	FILE * f;
	f=fopen(fn,"r");
 s.RemoveAll();
	if (f==NULL) return;
	char line[10000];
	//SPtrArray names; //globally declared
 while (true) {
	 if (!fgets(line,10000-1,f)) break;
		if (line[0]==0) continue; //break;

		SD ss=line;
		ss.Remove(10);
  ss.Remove(13);
		//MMsgbox(ss);
  s.Add(ss);
	}
 fclose(f);
}

SD getfiletext(const char * fn) {
	//returns the first line in a text file
	SD s;
 FILE * f;
	f=fopen(fn,"r");
	if (f==NULL) {
		DWORD d=::GetLastError();
		if (d==5) MMsgbox("Access denied "+SD(fn));
		s="";
	} else {
	 char line[1000];
	 if (!fgets(line,1000,f)) {
			s="";
		} else {
   s=line;
			s.Remove(10);
   s.Remove(13);
		}
		fclose(f);
	}
	return s;
}

bool appendfile(const char * fn,const void * buf,long n) {
 FILE * f=fopen(fn,"ab");
 if (f==0) return false;
 fwrite(buf,1,n,f);
 fclose(f);
 return true;
}

bool appendfiletext(const char * fn,const char * text) {
	if (strlen(text)==0) return true;
 FILE * f;
	f=fopen(fn,"a+");
	if (f==NULL) return false;
	fputs(text,f);
 fputs("\n",f);
	/*fseek(f,0,SEEK_END);
	bool b;
	b=(fwrite(text,strlen(text),1,f)==1);
	char c[2]={13,10};
	if (b) {
		b=(fwrite(c,2,1,f)==1);
	}*/
	fclose(f);
 return true; //b;
}

bool writefiletext(const char * fn,const char * text) {
 FILE * f;
	f=fopen(fn,"w");
	if (f==NULL) return false;
	if (fputs(text,f)==EOF) {
		fclose(f);
		return false;
	}
	fclose(f);
	return true;
}

double htod(double d) {
	double dif=d-int(d);
 if (dif>.99 /*.60*/) {
		return d;
	}
	dif=dif*(100.0/60.0);
 return int(d)+dif;
}

double dtoh(double d) {
 double dif=d-int(d);
	double dd=dif-1;
	if (fabs(dd)<.0001) return d;
 dif=dif*(60.0/100.0);
 return int(d)+dif;
}

double hours(SD &st,SD &et,bool * absent) {
	return dtoh(hoursd(st,et,absent));
	::Maskfix(&st);::Maskfix(&et);
	double d1,d2,tot;
	st.MakeUpper();et.MakeUpper();
	d1=atof(st);d2=atof(et);
	d1=htod(d1);d2=htod(d2);
	if (d1==0 || d2==0) {
  if (d1==0 && d2==0) {
			if (absent!=NULL) (*absent)=true;
		} else {
			if (absent!=NULL) (*absent)=false;
		}
		return 0;
	}
	if (absent!=NULL) (*absent)=false;
	if (st.Find('P')!=-1 && d1<=12) d1+=12;
 if (et.Find('P')!=-1 && d2<=12) d2+=12;
	if (et.Find('A')!=-1 && d2>12) d2-=12;
	if (st.Find('A')!=-1 && d1>12) d1-=12;
	if (d2<=d1) {
  tot=(24-d1)+d2;
	} else {
		tot=d2-d1;
	}
	tot=dtoh(tot);
	return tot;
}

double hoursd2(SD &st,SD &et,bool * absent) {
	double d=hoursd(st,et,absent);
 if (d>13.5) d=d-24;
	return d;
}

double tto24(SD & s) {
 double d=atof(s);
 if (strchr(s,'P')!=0 && d<=12) d+=12;
 return d;
}

double hoursd(SD &st,SD &et,bool * absent) {
	::Maskfix(&st);::Maskfix(&et);
	double d1,d2,tot;
	st.MakeUpper();et.MakeUpper();
	d1=atof(st);d2=atof(et);
	d1=htod(d1);d2=htod(d2);
	if (d1==0 || d2==0) {
  if (d1==0 && d2==0) {
			if (absent!=NULL) (*absent)=true;
		} else {
			if (absent!=NULL) (*absent)=false;
		}
		return 0;
	}
	if (absent!=NULL) (*absent)=false;
	if (st.Find('P')!=-1 && d1<=12) d1+=12;
 if (et.Find('P')!=-1 && d2<=12) d2+=12;
	if (et.Find('A')!=-1 && d2>12) d2-=12;
	if (st.Find('A')!=-1 && d1>12) d1-=12;
	if (d2<=d1) {
  tot=(24-d1)+d2;
	} else {
		tot=d2-d1;
	}
	//tot=dtoh(tot);
	return tot;
}

/*HOSTENT * safegethostbyaddr(const char *addr,int len,int type) {
 ::PostQuitMessage(0);
	HOSTENT * h=gethostbyaddr(addr,len,type);
 Flushallmsg(sb_SOCKET); //except sb_socket
	return h;
}

SD Getsocname(SOCKET soc) {
	SOCKADDR_IN sa={0};
	int z=sizeof(sa);
	getpeername(soc,(PSOCKADDR)&sa,&z);
	ASSERT(sa.sin_family==AF_INET);
	HOSTENT * hs=safegethostbyaddr((char*)&sa.sin_addr.S_un.S_addr,sizeof(sa.sin_addr),sa.sin_family);
	if (hs==NULL) return "";
	else return hs->h_name;
}*/



//AFX_STATIC_DATA VARIANT _afxOptionalVariant = { VT_ERROR, 0, 0, 0, DISP_E_PARAMNOTFOUND };

//SD getfieldstr(const char * fn,baserst * rst) {
	//return rst->getfieldstr(fn);
//}

void focusblink() {
	HWND h=::SetFocus(0);	//to flush any pending afterupdate messages
	::SetFocus(h);
}

static SDWordArray disabled_hwnds;

BOOL CALLBACK EnumThreadWndProc(HWND hwnd,LPARAM lParam) {
	//char buf[1000];buf[0]=0;
	//::GetWindowText(hwnd,buf,1000);
 //MMsgbox(buf);
	//ASSERT(::GetParent(hwnd)==0);
	if (::IsWindowEnabled(hwnd)) {
	 ::EnableWindow(hwnd,false);
		disabled_hwnds.Add((DWORD)hwnd);
	}
	return TRUE; //FALSE;
}

void disablewindow(HWND hwnd) {
 ::EnableWindow(hwnd,false);
}

void enablewindow(HWND hwnd) {
 ::EnableWindow(hwnd,true);
}


void disablethreadwindows() {
	::EnumThreadWindows(GetCurrentThreadId(),EnumThreadWndProc,false);
}

void enablethreadwindows() {
	//enables the prevoiusly disabled windows ..
	for (int x=1;x<=disabled_hwnds.GetSize();x++) {
		::EnableWindow((HWND)disabled_hwnds.GetAt(x-1),true);
	}
}

bool writesda(const char * fn,SDA * s) {
	FILE * f;
	f=fopen(fn,"w");
	for (int x=1;x<=s->GetSize();x++) {
		fputs(s->GetAt(x-1),f);
  fputs("\n",f);
	}
	fclose(f);
	return true;
}

unsigned char hextod(unsigned char c) {
 if (c<='9') return (c-'0');
 else return (c-'A'+10);
}

/*unsigned char hextod(char * buf) {
 unsigned char c;
 c=hextod(buf[0]);
 c|=hextod(buf[1])<<4;
 return c;
}*/

unsigned long hextod(char * buf) {
 unsigned long l;
 l=hextod(buf[0]);
 l|=hextod(buf[1])<<4;
 l|=hextod(buf[2])<<8;
 l|=hextod(buf[3])<<12;
 l|=hextod(buf[4])<<16;
 l|=hextod(buf[5])<<20;
 l|=hextod(buf[6])<<24;
 l|=hextod(buf[7])<<28;
 return l;
}

unsigned char dtohex(unsigned char c) {
 if (c<=9) return ('0'+c);
 else return ('A'+c-10);
}

void dtohex(unsigned char c,char * buf) {
 buf[0]=dtohex(c & 0xf);
 buf[1]=dtohex((c & 0xf0) >> 4);
}

SD & dtohex(unsigned long l,SD & sd) {
 sd.setsize(8);sd.dt=dtString;
 sd[0]=dtohex((unsigned char)(l & 0xf));
 sd[1]=dtohex((unsigned char)((l & 0xf0)>>4));
 sd[2]=dtohex((unsigned char)((l & 0xf00)>>8));
 sd[3]=dtohex((unsigned char)((l & 0xf000)>>12));
 sd[4]=dtohex((unsigned char)((l & 0xf0000)>>16));
 sd[5]=dtohex((unsigned char)((l & 0xf00000)>>20));
 sd[6]=dtohex((unsigned char)((l & 0xf000000)>>24));
 sd[7]=dtohex((unsigned char)((l & 0xf0000000)>>28));

 //unsigned char a=c & 0xf; ///16;
 //if (a<=9) buf[0]=('0'+a);
 //else buf[0]=('A'+a-10);
 //a=(c & 0xf0) >> 4; //% 16;
 //if (a<=9) buf[1]=('0'+a);
 //else buf[1]=('A'+a-10);
 return sd;
}





void fillsda(const char * fn,SDA * s) {
	FILE * f;
	f=fopen(fn,"r");
	//MMsgbox(fn);
	if (f==NULL) return;
	char line[1000];
	//SPtrArray names; //globally declared
 while (true) {
	 if (!fgets(line,1000,f)) break;
		if (line[0]==0) continue; //break;
		SD ss=line;
		ss.Remove(10);
  ss.Remove(13);
		//MMsgbox(ss);
  s->Add(ss);
	}
 fclose(f);
}
#ifndef WINE
bool isprinterok(HANDLE h,bool & default98) {
 DWORD needed;
	GetPrinter(h,2,0,0,&needed);
	void * buf=malloc(needed);
 if (GetPrinter(h,2,(LPBYTE) buf,needed,&needed)) {
		PRINTER_INFO_2 * pi=(PRINTER_INFO_2 *)buf;
		if (pi->Attributes &PRINTER_ATTRIBUTE_DEFAULT) {
   default98=true;
		} else default98=false;
		free(buf);
		return true;
	}
	free(buf);
	default98=false;
 return false;
}

extern "C" BOOL WINAPI GetDefaultPrinterA(
    IN LPSTR   pszBuffer,
    IN LPDWORD  pcchBuffer
    );

SD getdefaultprinterNT() {
 char buf[1000];
	DWORD d=1000;
	GetDefaultPrinterA(buf,&d); //this function should be called only on NT
	//d=::GetLastError();
	return buf;
}

SD getprintername() {
	//gets a valid printer name, gives preference to default printer ...
	OSVERSIONINFO ov;memset(&ov,0,sizeof(ov));
	ov.dwOSVersionInfoSize=sizeof(ov);
	GetVersionEx(&ov);
	SD dpnt; //default printer of windows NT
	if (ov.dwPlatformId==VER_PLATFORM_WIN32_NT) {
		dpnt=getdefaultprinterNT();
		return dpnt;
	}
	SD pn;
	PRINTER_INFO_2 * pi;
 DWORD needed=0,no=0;
	BOOL b=EnumPrinters(PRINTER_ENUM_LOCAL,0,2,0,0,&needed,&no);
	void * buf=malloc(needed);
	pi=(PRINTER_INFO_2 *) buf;
 b=EnumPrinters(PRINTER_ENUM_LOCAL,0,2,(unsigned char *)pi,needed,&needed,&no);
	for (unsigned int x=1;x<=no;x++) {
		HANDLE h;
	 PRINTER_DEFAULTS pd;memset(&pd,0,sizeof(pd));
	 pd.DesiredAccess=PRINTER_ALL_ACCESS; //_ADMINISTER;
	 b=OpenPrinter((pi+x-1)->pPrinterName,&h,0/*&pd*/);
	 if (b) {
			bool default98;
			if (isprinterok(h,default98)) {
    if (ov.dwPlatformId==VER_PLATFORM_WIN32_NT) {
     if (dpnt.CompareNoCase((pi+x-1)->pPrinterName)==0) {
      pn=(pi+x-1)->pPrinterName;
						::ClosePrinter(h);
						break;
					}
				} else if (default98) {
     pn=(pi+x-1)->pPrinterName;
				 ::ClosePrinter(h);
				 break;
				}
				pn=(pi+x-1)->pPrinterName;
			}
			::ClosePrinter(h);
		}
	}
	free(buf);
 return pn;
}
#endif
/*signed int ffind(SPtrArray * a,void * p) {
	for (int x=1;x<=a->GetSize();x++) {
		if (p==a->GetAt(x-1)) return x-1;
	}
	return -1;
}*/


void sort(SDA & cs) {
	int sorted=1;
rr:
	for (int y=sorted+1;y<=cs.GetSize();y++) {
		for (int x=1;x<=sorted;x++) {
			if (cs.GetAt(y-1)<cs.GetAt(x-1)) {
				cs.InsertAt(x-1,cs.GetAt(y-1));
				cs.RemoveAt(y);
				break;
			}
		}
		sorted++;
		goto rr;
	}
}

#ifndef THREED
 _3DText::_3DText() {
  signal=0;
 }

void vASSERT(bool b) {
	if (!b) {
		MMsgbox("V.Assertion Failed ...");
	}
}


long SMS2::recvpacket(void * buf,long maxbytes,SOCKET sc,DWORD timeout) {
		DWORD t=::GetTickCount();
	int i;
	WSABUF wsabuf;
	wsabuf.buf=(char*)buf; //(char*)databuf+bufpos;
	wsabuf.len=maxbytes; //bufsize-bufpos;
	unsigned long n=0,flags=0;
 i=WSARecv(sc,&wsabuf,1,&n,&flags,&overlapped,NULL);
	if (i==0) {
		VERIFY(WSAResetEvent(hevent));
  //bufpos+=n;
		if (n==0) {
			MMsgbox("Server connection closed");
			exit(0);
		}
		return n;
	}
	ASSERT(i==SOCKET_ERROR);
 if (::WSAGetLastError()!=WSA_IO_PENDING) {
	 MMsgbox("socket error in recvpacket");
	}
rr:
	if (::GetTickCount()-t>timeout*1000) {
		MMsgbox("timeout in recv");
		exit(0);
	}
	DWORD d=WSAWaitForMultipleEvents(1,&hevent,FALSE,0/*60*1000*/,FALSE);
	if (d==WSA_WAIT_FAILED || d==WSA_WAIT_TIMEOUT) {
		goto rr;
  //MMsgbox("timeout");
  //tthrow("Timeout - in reveiving bytes");
	}
	int index=d-WSA_WAIT_EVENT_0;
	ASSERT(index==0);
	BOOL b=WSAGetOverlappedResult(sc,&overlapped,&d,TRUE,&flags);
	VERIFY(WSAResetEvent(hevent));
	if (b==FALSE || d==0) {
		MMsgbox("Error Connection closed");
		exit(0);
	}
	ASSERT(d!=0);//if d==0 then server connection is closed
	return d;
}

void SMS2::recvbytes(char * buf,int n,SOCKET sc,DWORD timeout) {
	int bytesread=0;
	while (n>bytesread) {
		long i=recvpacket(buf+bytesread,n-bytesread,sc,timeout);  //it should throw exception on timeout expiry
		bytesread+=i;
	}
}

void SMS2::sendbytes(char * buf,long n,SOCKET soc) {
 long bytes_sent=0;
 DWORD t=::GetTickCount();
 while (bytes_sent<n) {
		// check for the notifications here too.
		long i=send(soc,(char*)buf,n-bytes_sent,0);
  if (i==SOCKET_ERROR) {
			//tthrow("Timeout - in sending bytes");
			MMsgbox("socket error on blocking socket");
			i=0;
			if (::WSAGetLastError()!=WSAEWOULDBLOCK) {
				MMsgbox("Socket error in send bytes");
			}
		}
  bytes_sent+=i;
  buf+=i;
		if (bytes_sent<n) {
			MMsgbox("Two trys taken");
		}
	 if (GetTickCount()<t) t=GetTickCount();
		if ((unsigned)(GetTickCount()-t)>50*1000) { //50 seconds
			MMsgbox("SMS2:Timeout - in sending bytes");
			exit(0);
		}
	}
}

bool SMS2::sendsms(SD phone,SD text,SD servername) {
	WORD port=3020;
	SOCKET soc=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
 if (soc==INVALID_SOCKET) {
	 MMsgbox("Error : creating socket.");
		return 0;
	}
	HOSTENT * hs=::gethostbyname(servername);
 if (hs==NULL) {
  closesocket(soc);
		MMsgbox("Error :Unable to find host name "+servername);
		return 0;
	}
	ASSERT(hs->h_addrtype==AF_INET);
	ASSERT(hs->h_length==4);
	void * p=(*hs->h_addr_list);
 SOCKADDR_IN sa;memset(&sa,0,sizeof(sa));
	sa.sin_family=AF_INET;
	sa.sin_port=htons(port);
	memcpy(&sa.sin_addr.S_un.S_addr,p,4);
	//connectmsg=false;
	//error=false;
 int i=connect(soc,(PSOCKADDR)&sa,sizeof(sa));
	if (i!=0) {
		i=WSAGetLastError();
	 if (true || i!=WSAEWOULDBLOCK){
			if (i==WSAENOBUFS) {
				MMsgbox("Error: No Buffer for socket");
			}
			closesocket(soc);
			soc=INVALID_SOCKET;
		 MMsgbox("Error: Unable to connect.");
		 return 0;
		}
	}
 hevent=WSACreateEvent();
 if (hevent==WSA_INVALID_EVENT) {
  i=WSAGetLastError();
		closesocket(soc);
		soc=INVALID_SOCKET;
		MMsgbox("Error: create event error.");
		return 0;
	}
	overlapped.hEvent=hevent;
	char c[5];
	recvbytes(c,5,soc);
	if (memcmp(c,"hello",5)!=0) {
  closesocket(soc);
  soc=INVALID_SOCKET;
		MMsgbox("Error: Incompatible Version.");
		return 0;
	}
 //-----------sending command -------------
	/*Command syntax
	  one byte command
			phone no //null terminated string
			text //null terminted string
		*/
 long size=0;
 size++; //command byte
 size+=strlen(phone)+1;
	size+=strlen(text)+1;
 char * buf=(char * )malloc(size);
 if (buf==0) {
		MMsgbox("Error: allocating buffer");
		closesocket(soc);
		return 0;
	}
 buf[0]=1;
	memcpy(buf+1,phone,strlen(phone)+1);
 memcpy(buf+1+strlen(phone)+1,text,strlen(text)+1);
 sendbytes(buf,size,soc);
 recvbytes(buf,1,soc,180*2);
 closesocket(soc);
	VERIFY(WSACloseEvent(hevent));
 //Invalidatetree(pform->hwnd);
	if (buf[0]==1) {
		MessageBox(0,"Message Successfully Sent","SMS",MB_OK);
	} else {
		MMsgbox("Error Sending Message");
	}
	free(buf);
	return true;
}


void tcpnodelay(SOCKET soc) {
	//return;
	BOOL b=1;
	int d=setsockopt(soc,IPPROTO_TCP,TCP_NODELAY,(char *)&b,sizeof(int));
	//ASSERT(d==0);
	//d=::WSAGetLastError();
	int i=0,ii;
 //d=setsockopt(soc,SOL_SOCKET,SO_RCVBUF,(char *)&i,sizeof(int));
	i=0;ii=4;
	d=setsockopt(soc,SOL_SOCKET,SO_SNDBUF,(char *)&i,sizeof(int));
 VERIFY(d==0);
 d=getsockopt(soc,SOL_SOCKET,SO_SNDBUF,(char *)&i,&ii);
 VERIFY(d==0);
}

void updatecstring(const char *s,SDA &cs) {
 for (int x=1;x<=cs.GetSize();x++) {
		if (cs.GetAt(x-1).CompareNoCase(s)==0) {
			cs.RemoveAt(x-1);break;
		}
	}
 cs.InsertAt2(0,s);
}

SD century(SD d) {
	d.TrimLeft();
	if (d.GetLength()!=8) return "";
	int i=atoi(d.Right(2));
 if (i<=5) i=2000+i;
	else i=1900+i;
	return d.Left(6)+str(i);
}

SD gettemppath() {
	char buf[1000];
 if (GetTempPath(1000,buf)==0) {
	 MMsgbox("Error getting temp path");
	 return "";
	}
 SD s=buf;
 if (s.Right(1).GetAt(0)!='\\') s+="\\";
 return s;
}

SD gettempfilename2(SD ext) {
 SD p=::gettemppath();
 SD fn;
 for (int x=1;x<=100;x++) {
  fn=p+str(x)+ext;
  FILE * f=::fopen(fn,"w");
  if (f) {
   fclose(f);
   return fn;
  }
 }
 return "";
}

bool IsLeapYear(long year) {
 return year %4==0;
}

int YearDays(long year) {
 return IsLeapYear(year)?366:365;
}

double Age(SD dob,SD date) {
 long y1,m1,d1;
 dob.GetYMD(&y1,&m1,&d1);
 long y2,m2,d2;
 date.GetYMD(&y2,&m2,&d2);
 long y=y2-y1;
 dob=Date(y1+y,m1,d1);
 if (dob.lval==0) dob=long(Date(y1+y,m1+1,d1)-1);
 return y+((date.lval-dob.lval)/((y2%4==0)?366:365));
}

SD gettempfilename(const char * path) {
	char buf[1000];
	if (path==0) {
	 if (GetTempPath(1000,buf)==0) {
	 	MMsgbox("Error getting temp path");
	 	return "";
	 }
	} else {
		if (strlen(path)>999) {
   MMsgbox("Error path length too large");
	 	return "";
	 }
		strcpy(buf,path);
	}
	char c[MAX_PATH];
 if (GetTempFileName(buf,"tmp",0,c)==0) return "";
	return c;
}


/*void setlbls(SPtrArray * ctrls) {
	SDWordArray lefts;
 SDWordArray m;
 SDWordArray bot;
	SPtrArray cc;
	for (int x=1;x<=ctrls->GetSize();x++) {
		ctrl * c=(ctrl *) ctrls->GetAt(x-1);
		//if (c->fieldname=="delv_date") {
		//	int i=0;
		//}
		if ((c->type=='t' || c->type=='k') && c->lbl!=0) {
		 DWORD l=c->Lside();
			DWORD w;
			w=c->lbl->Getwidth();
			DWORD b=c->Bside();
			DWORD t=Gettop(c->hwnd);
		 for (int y=1;y<=lefts.GetSize();y++) {
    if (l==lefts.GetAt(y-1)) {
     if (abs(bot.GetAt(y-1)-t)<50) {
      if (m.GetAt(y-1)<w) m.SetAt(y-1,w);
      bot.SetAt(y-1,b);
      SPtrArray * cp=(SPtrArray *)cc.GetAt(y-1);
				  cp->Add(c);
						break;
					}
				}
		 }
		 if (y>lefts.GetSize()) {
			 lefts.Add(l);
			 m.Add(w);
				bot.Add(b);
				SPtrArray * cp=new(SPtrArray);
				cp->Add(c);
				cc.Add(cp);
			}
		}
	}
	for (int y=1;y<=cc.GetSize();y++) {
  SPtrArray * cp=(SPtrArray *)cc.GetAt(y-1);
		for (x=1;x<=cp->GetSize();x++) {
   ctrl * c=(ctrl *) cp->GetAt(x-1);
			if (c->type=='t')	((TextBox*)c)->setlblwidth(m.GetAt(y-1));
			else ((CheckBox*)c)->setlblwidth(m.GetAt(y-1));
		}
		delete(cp);
	}
}*/



int Textwidth(HDC hdc,const char * s) {
 SIZE size;
 GetTextExtentPoint32(hdc,s,strlen(s),&size);
	return size.cx;
}

int Textheight(HDC hdc,const char * s) {
 SIZE size;
 GetTextExtentPoint32(hdc,s,strlen(s),&size);
	return size.cy;
}

int CurrentY(HDC hdc) {
	POINT pt;
 GetCurrentPositionEx(hdc,&pt);
	return pt.y;
}

int CurrentX(HDC hdc) {
	POINT pt;
 GetCurrentPositionEx(hdc,&pt);
	return pt.x;
}

int Boxprint(HDC hdc,SD s,int width,bool calculate,char lines,bool center) {
	//after printing, positions curenty at the botton
	//after printing, SD s will contain the remaining charecters not printed
 //if (lines==0) lines=(char) 255;
	int X=CurrentX(hdc);
	int YY=CurrentY(hdc);
	int th=Textheight(hdc,"9");
 UINT oldallign=SetTextAlign(hdc,TA_TOP|TA_LEFT|TA_UPDATECP);
	for(char x=1;x<=lines || lines==0;x++) {
		//if (CurrentY(hdc)+th-1>TotHeight) return false;
  SD ss=cut(hdc,&s,width,(x==lines)?false:true);
		int Y=CurrentY(hdc);
		if (center) {
			int w=Textwidth(hdc,ss);
   w=width-w;
			w=w/2;
			MoveToEx(hdc,CurrentX(hdc)+w,CurrentY(hdc),0);
		}
  if (!calculate) TextOut(hdc,0,0,ss,ss.GetLength());
  MoveToEx(hdc,X,Y+th,0);
		if (s=="") break;
 }
	//return *s=="" ? true:false;
 SetTextAlign(hdc,oldallign);
	return CurrentY(hdc)-YY;
}

SD cut(HDC hdc,SD *s,int width,bool spacecut) {
	WORD lastspace=0;
	int w=0;
	WORD x;
 for(x=1;x<=(*s).GetLength();x++) {
		char c=(*s).GetAt(x-1);
		if (c==13 || c==10) {
			x++;
   char cc=0;
			if (x<=s->GetLength()) cc=(*s).GetAt(x-1);
   if (cc==13 || cc==10) {
				if (c!=cc) x++;
			}
			break;
		}
  SIZE size;
  GetTextExtentPoint32(hdc,&c,1,&size);
  w=w+size.cx;
		if (w>width+1) {
			if (lastspace!=0) x=lastspace+1;
   break;
		}
		if (c==32 && spacecut) lastspace=x;
	}
	SD ss=(*s).Left(x-1);
	for(int y=1;y<=2;y++) {
	 if (ss.Right(1)=="\n" || ss.Right(1)=="\r") {
	 	ss=ss.Left(ss.GetLength()-1);
	 }
	}
 (*s)=(*s).Mid(x-1);
	return ss;
}

int Verticalprint(HDC hdc,SD s,int width,int height,bool center,bool calculate) {
	//HFONT lastf=(HFONT) ::SelectObject(hdc,hfont1);
	SDA ca,ca2;
	while (s!="") {
		int i=s.Find(" ");
  if (i==-1) {ca.Add(s);break;}
		ca.Add(s.Left(i));
		s=s.Mid(i+1);
	}
	SIZE size;memset(&size,0,sizeof(size));
	//::GetTextExtentPoint32(hdc," ",1,&spc);
	int totw=0,maxh=0,col=1;
	int x;
 for (x=1;x<=ca.GetSize();x++) {
		if (ca2.GetSize()<col) ca2.Add2("");
		SD s2=ca2.GetAt(col-1);
		if (s2!="") s2+=" ";
		s2+=ca.GetAt(x-1);
		::GetTextExtentPoint32(hdc,s2,s2.GetLength(),&size);
		//int t=size.cx;size.cx=size.cy;size.cy=t; //swap sp;
  if (size.cx>height) {
			if (ca2.GetAt(col-1)=="" || totw+size.cy*2>width) {
				ca2.SetAt(col-1,s2);
				maxh=max(maxh,size.cx);
			} else {
    totw+=size.cy;
				col++;
				x--;
			}
		} else {
   ca2.SetAt(col-1,s2);
			maxh=max(maxh,size.cx);
		}
	}
	totw+=size.cy;
 if (calculate) return maxh;
 //int topmargin=(height-maxh)/2;
	//if (topmargin)<0) topmargin=0;
	int X=CurrentX(hdc);
 int Y=CurrentY(hdc);
 int leftmargin=(width-totw)/2;
	if (leftmargin<0) leftmargin=0;
 for (x=1;x<=ca2.GetSize();x++) {
		SD s2=ca2.GetAt(x-1);
  ::GetTextExtentPoint32(hdc,s2,s2.GetLength(),&size);
  int topmargin=(height-size.cx)/2;
	 if (topmargin<0) topmargin=0;
		//MoveToEx(hdc,X+leftmargin,center?Y+height-1-topmargin:Y+min(height,size.cx),0);
  ::TextOut(hdc,X+leftmargin,center?Y+height-1-topmargin:Y+min(height,size.cx),s2,s2.GetLength());
		leftmargin+=size.cy;
	}
	return 0;
}

	/*while (s!="") {
  int th=0,lastspace=0;
	 for (int x=1;x<=s.GetLength();x++) {
	 	SIZE size;
   if (s.GetAt(x-1)==' ') lastspace=x;
			//::SelectObject(hdc,hfont1);
   ::GetTextExtentPoint32(hdc,s.Mid(x-1,1),1,&size);
			//int ax=::GetDeviceCaps(hdc,ASPECTX);
   //int ay=::GetDeviceCaps(hdc,ASPECTY);
   //::SelectObject(hdc,hvfont1);
			//size.cx=int(double(size.cx)*double(ax)/double(ay));
			//size.cy=int(double(size.cy)*double(ay)/double(ax));

   th=th+size.cx;
			maxw=max(maxw,size.cy);
   if (th>height && lastspace!=0) {
				ASSERT(x>1);
				if (lastspace!=0) x=lastspace;
    sp=new(SD);
				spary.Add(sp);
    (*sp)=s.Left(x-1);
    if (lastspace!=0) x++;
				s=s.Mid(x-1);
				break;
			}
		}
		if (th<=height) {
   sp=new(SD);
			spary.Add(sp);
   (*sp)=s;
			s="";
		}
	}
 int margin=width-(maxw*spary.GetSize());
 margin/=2;
	if (margin<0) margin=0;
	::SetTextAlign(hdc,TA_TOP|TA_LEFT /*TA_CENTER*);
	for (int x=1;x<=spary.GetSize();x++) {
		SD * sp;
		sp=(SD * )spary.GetAt(x-1);
		SIZE size;
  GetTextExtentPoint32(hdc,*sp,(*sp).GetLength(),&size);
		int vmargin=(height-size.cx)/2;
		if (vmargin<0) vmargin=0;
  if (((x-1)*maxw)+margin<width-1) {
   ::MoveToEx(hdc,(X+(x-1)*maxw)+margin,Y+height-vmargin,NULL); // necessary
		 if (!calculate) ::TextOut(hdc,(X+(x-1)*maxw)+margin,Y+height-vmargin,(*sp),(*sp).GetLength());
		}
  delete(sp);
	}
 //::SelectObject(hdc,lastf);
 ::SetTextAlign(hdc,TA_TOP|TA_LEFT|TA_UPDATECP);
	return true;
}*/

unsigned long getip(const char * server) {
 unsigned long l;
	l=inet_addr(server);
	if (l==INADDR_NONE) {
  HOSTENT * hs=::gethostbyname(server);
		if (hs==NULL) {
			MMsgbox("Error IP not found - "+SD(server));
			return INADDR_NONE;
		}
		ASSERT(hs->h_addrtype==AF_INET);
	 ASSERT(hs->h_length==4);
		memcpy(&l,hs->h_addr_list[0],4);
	}
	return l;
}


SD ntow3(long n) {
	if (n==0) return "";
	else if (n==1) return "One";
 else if (n==2) return "Two";
	else if (n==3) return "Three";
	else if (n==4) return "Four";
	else if (n==5) return "Five";
 else if (n==6) return "Six";
	else if (n==7) return "Seven";
	else if (n==8) return "Eight";
	else if (n==9) return "Nine";
	else if (n==10) return "Ten";
	else if (n==11) return "Eleven";
 else if (n==12) return "Twelve";
	else if (n==13) return "Thirteen";
	else if (n==14) return "Fourteen";
	else if (n==15) return "Fifteen";
 else if (n==16) return "Sixteen";
	else if (n==17) return "Seventeen";
	else if (n==18) return "Eighteen";
	else if (n==19) return "Nineteen";
 else {
		int nn=n%10;
		ASSERT(nn<=9);
  SD ss,s=ntow3(nn);
		n=n/10;
  ASSERT(n>=2 && n<=9);
		if (n==2) ss="Twenty";
		else if (n==3) ss="Thirty";
		else if (n==4) ss="Forty";
		else if (n==5) ss="Fifty";
		else if (n==6) ss="Sixty";
		else if (n==7) ss="Seventy";
		else if (n==8) ss="Eighty";
		else if (n==9) ss="Ninety";
		return ss+" "+s;
	}
}

SD ntow2(long n) {
 SD s;
	char * ll[]={"","Hundred","Thousand","Lac","Crore"};
	int level=0;
	while (n!=0) {
		if (level==4) {
			s=ntow2(n)+" "+ll[level]+" "+s;
			n=0;
	 } else {
			int mod=(level==1?10:100);
   long nn=n % mod;
		 n=n/mod;
			SD s1=ntow3(nn);
			if (s1!="") s1+=SD(" ")+ll[level];
			s=s1+" "+s;
		 //s=ntow3(nn)+" "+ll[level]+" "+s;
		}
		level++;
	}
	s.TrimRight();
	return s;
}

SD ntow(long n) {
	SD minus;
	if (n<0){
		minus="Minus ";
		n=abs(n);
	}
	return minus+ntow2(n);
}

SD dtow(double d) {
	int i=int(d);
	int ii=(int)round32((d-i)*100);
	SD s=ntow(i);
	SD ss=ntow(abs(ii));
	s=s+(ss==""?"":" and paisa "+ss);
	//if (s=="") MMsgbox("dntow - "+dstr2(d));
	return s;
}

SD getmonth(unsigned char mm) {
	if (mm==0) mm=12; //uised ihn member ledger
	else if (mm==13) mm=1;
 tm tt;tt.tm_mon=mm-1;
	char buf[20];
	strftime(buf,20,"%B",&tt);
 return buf;
}

void readFile(HANDLE h,void * buf,DWORD size) {
	DWORD nob;
	ReadFile(h,buf,size,&nob,0);
	if (nob!=size) throw (int) 1;
}

void writeFile(HANDLE h,void * buf,DWORD size) {
	DWORD nob;
	WriteFile(h,buf,size,&nob,0);
	if (nob!=size) throw (int) 1;
}

void aasert(bool x,long line,const char * file) {
 if (x) {
#ifdef WINE
  printf("assert failed");
  asm ("int $3");
#else
  MMsgbox("Assertion Failed: Line="+str(line)+SD(", File name=")+SD(file));
  ::DebugBreak();
#endif
 }
}

bool spltoemf2(const char * spl,int pageno,const char * emf) {
 HANDLE hspl = CreateFile(spl,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 if (hspl==INVALID_HANDLE_VALUE) {
		DWORD d=::GetLastError();
		MMsgbox(str(d)+" Unable to open (spltoemf)"+SD(spl));
		return false;
	}
	//MMsgbox(SD(spl) + " opened");
 /*HANDLE hmap=CreateFileMapping(hspl,NULL,PAGE_READONLY,0,0,NULL);
	if (hmap==0) {
  MMsgbox("Unable to map file");
		::CloseHandle(hspl);
		return false;
	}
 LPBYTE pmap= (LPBYTE)MapViewOfFileEx(hmap,FILE_MAP_READ,0,0,0,NULL);
 if (pmap==0) {
  MMsgbox("Unable to map view file");
		CloseHandle(hmap);
  CloseHandle(hspl);
		return false;
	}*/
	void * buf=0;
	bool retval=true;
 try {
  DWORD granularity;
		readFile(hspl,&granularity,4);
  DWORD splheader;
		readFile(hspl,&splheader,4);
		signed long p;
		splheader-=4;
		p=SetFilePointer(hspl,splheader,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
  DWORD metafilelen;
		readFile(hspl,&metafilelen,4);
		for(int Nbr = 1 ; Nbr < pageno ; Nbr++) {
			signed long pos=SetFilePointer(hspl,metafilelen,NULL,FILE_CURRENT);
	  if (pos<0) throw (int) 1;
			//try First case
   p=SetFilePointer(hspl,20-4,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
   DWORD cmd;
   readFile(hspl,&cmd,4);
			if (cmd!=0xC) { //try second case
    p=SetFilePointer(hspl,pos,NULL,FILE_BEGIN);if (p<0) throw (int) 1;
    p=SetFilePointer(hspl,4,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
    DWORD offset;
				readFile(hspl,&offset,4);
				p=SetFilePointer(hspl,offset,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
    p=SetFilePointer(hspl,16,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
    readFile(hspl,&cmd,4);
				if (cmd!=0xC) throw(int) 1;
			}
			readFile(hspl,&metafilelen,4);
		}
		if (metafilelen==0) throw(int) 1;
  buf=malloc(metafilelen);
		if (buf==0) {
			MMsgbox("Memory error " +str(metafilelen));
			throw (int) 1;
		}
		readFile(hspl,buf,metafilelen);
		HANDLE hemf=CreateFile(emf,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  writeFile(hemf,buf,metafilelen);
  ::CloseHandle(hemf);
	}
	catch(int) {
		retval=false;
	}
	if (buf) free(buf);
 ::CloseHandle(hspl);
 return retval;
}

bool spltoemf(const char * spl,int pageno,const char * emf) {
	//VERIFY(CopyFile(spl,"c:\\2.spl",FALSE));
 HANDLE hspl = CreateFile(spl,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 if (hspl==INVALID_HANDLE_VALUE) {
		DWORD d=::GetLastError();
		MMsgbox(str(d)+" Unable to open (spltoemf)"+SD(spl));
		return false;
	}
	//MMsgbox(SD(spl) + " opened");
 /*HANDLE hmap=CreateFileMapping(hspl,NULL,PAGE_READONLY,0,0,NULL);
	if (hmap==0) {
  MMsgbox("Unable to map file");
		::CloseHandle(hspl);
		return false;
	}
 LPBYTE pmap= (LPBYTE)MapViewOfFileEx(hmap,FILE_MAP_READ,0,0,0,NULL);
 if (pmap==0) {
  MMsgbox("Unable to map view file");
		CloseHandle(hmap);
  CloseHandle(hspl);
		return false;
	}*/
	void * buf=0;
 signed long p;
	bool retval=true;
 try {
		int pc=0;
		signed long size;
		while (true) {
   DWORD rec;
		 readFile(hspl,&rec,4);
			if (rec==0 || rec==0xffffffff) continue;
			readFile(hspl,&size,4);
			if (rec==0xc) {
				pc++;
				if (pc==pageno) {
     break;
				}
				size=size-0;//8;
				if (size<0) throw (int)1;
    p=SetFilePointer(hspl,size,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
				continue;
			}
   if (pc==0) size-=8;else size-=4;
			if (size<0) throw (int)1;
   p=SetFilePointer(hspl,size,NULL,FILE_CURRENT);if (p<0) throw (int) 1;
		}
		if (size<=0 || size>60*1024*1024) throw (int) 1;
		buf=malloc(size);
		if (buf==0) {
			MMsgbox("Memory error " +str(size));
			throw (int) 1;
		}
		readFile(hspl,buf,size);
		HANDLE hemf=CreateFile(emf,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  writeFile(hemf,buf,size);
  ::CloseHandle(hemf);
	}
	catch(int) {
		retval=false;
	}
	if (buf) free(buf);
 ::CloseHandle(hspl);
 return retval;
}

bool isparent(HWND child,HWND parent) {
	HWND h;
	while ((h=GetParent(child))!=0) {
		if (h==parent) return true;
		child=h;
	}
	return false;
}

void tthrow2(const char * s,bool quiet) {
	if (!quiet) MMsgbox2(s); //to avoid WM_PAINT (grid) ....
	throw SD(s);
	//MMsgbox("Quitting now");
	//exit(0);
}

void tthrow(const char * s,bool quiet) {
	if (!quiet) MMsgbox(s);
	throw SD(s);
	//MMsgbox("Quitting now");
	//exit(0);
}
LARGE_INTEGER Hptimer::fq={0,0};

void * salloc(DWORD size) {
 //if (size==0) return 0;
 return SysAllocStringByteLen(0,size);
}

void sfree(void * buf) {
 SysFreeString((OLECHAR *)(unsigned short *)buf);
}


/*void * hrealloc(void * buf,DWORD size) {
#ifdef BASED
 return realloc(buf,size);
#else
 if (buf==0) return halloc(size);
 return HeapReAlloc(::GetProcessHeap(),0,buf,size);
#endif
}

void * halloc(DWORD size) {
 //if (size==0) return 0;
#ifdef BASED
 return malloc(size);
#else
 return HeapAlloc(::GetProcessHeap(),0,size); //SysAllocStringByteLen(0,size);
#endif
}

void hfree(void * buf) {
#ifdef BASED
 free(buf);
#else
 VERIFY(HeapFree(::GetProcessHeap(),0,buf)!=0); //SysFreeString((unsigned short *)buf);
#endif
}*/


void * vvalloc(DWORD size) {
	void * a=VirtualAlloc(0,size,MEM_COMMIT,PAGE_READWRITE); //malloc(CSIZE); //MAXRAM/4);
// VERIFY(::VirtualLock(a,size));
	//if (a==0) MMsgbox("Virtual alloc failed");
	return a;
}

void * vrealloc(void * buf,DWORD size,DWORD oldsize) {
	//void * b=VirtualAlloc(buf,size,MEM_COMMIT,PAGE_READWRITE);
	//DWORD d=::GetLastError();
	//if (b==buf) return buf;
	//ASSERT(b==0);
	//return buf;
	void * a=vvalloc(size);
	memcpy(a,buf,min(size,oldsize));
	vfree(buf);
	return a;
	//VERIFY(VirtualAlloc(buf,size,MEM_COMMIT,PAGE_READWRITE));
}

void vreset(void * buf,DWORD size) {
	(VirtualAlloc(buf,size,MEM_RESET,PAGE_READWRITE));
	//DWORD d=::GetLastError();
}

void vfree(void * buf) {
 VERIFY(VirtualFree(buf,0,MEM_RELEASE));
}

SD getservername(SD path) {
	if (path.Left(2)=="\\\\") {
  int i=path.Find("\\",2);
		if (i!=-1) {
			return path.Mid(2,i-2);
		}
	}
	return "";
}

static int _afxMonthDays[13] =	{0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};

long Date(long y,long m,long d) {
 while (m>12) {
  y++;
  m=m-12;
 }
 while (m<1) {
  y--;
  m+=12;
 }

 //if (m==13) {m=1;y++;}
 //if (m==0) {m=12;y--;}
 long date;
 if (y>9999 || m<1 || m>12)	return 0; //no message shown because of server ... tthrow("Invalid parameters - Date");
		//  Check for leap year and set the number of days in the month
	BOOL bLeapYear = ((y & 3) == 0) &&	((y % 100) != 0 || (y % 400) == 0);
	int nDaysInMonth =
		_afxMonthDays[m] - _afxMonthDays[m-1] +
		((bLeapYear && d == 29 && m == 2) ? 1 : 0);

	// Finish validating the date
	if (d < 1 || d > nDaysInMonth)	return 0;//tthrow("Invalid parameters - SetDate");

	//It is a valid date; make Jan 1, 1AD be 1
	date = y*365L + y/4 - y/100 + y/400 +	_afxMonthDays[m-1] + d;

	//  If leap year and it's before March, subtract 1:
	if (m <= 2 && bLeapYear)	--date;

	//  Offset so that 12/30/1899 is 0
	date -= 693959L;
 return date;
}


void CDate::SetDate(long y,long m,long d) {
 date=Date(y,m,d);
 return;

 /*if (y>9999 || m<1 || m>12)	tthrow("Invalid parameters - SetDate");

	//  Check for leap year and set the number of days in the month
	BOOL bLeapYear = ((y & 3) == 0) &&	((y % 100) != 0 || (y % 400) == 0);

	int nDaysInMonth =
		_afxMonthDays[m] - _afxMonthDays[m-1] +
		((bLeapYear && d == 29 && m == 2) ? 1 : 0);

	// Finish validating the date
	if (d < 1 || d > nDaysInMonth)	tthrow("Invalid parameters - SetDate");

	//It is a valid date; make Jan 1, 1AD be 1
	date = y*365L + y/4 - y/100 + y/400 +	_afxMonthDays[m-1] + d;

	//  If leap year and it's before March, subtract 1:
	if (m <= 2 && bLeapYear)	--date;

	//  Offset so that 12/30/1899 is 0
	date -= 693959L;*/
}

long CDate::GetYear(long date) {
 if (date==0) return 0;
	tm tmm;
	Gettm(tmm,date);
	return tmm.tm_year;
}

long CDate::GetMonth(long date) {
 if (date==0) return 0;
	tm tmm;
	Gettm(tmm,date);
	return tmm.tm_mon;
}

long CDate::GetDay(long date) {
 if (date==0) return 0;
	tm tmm;
	Gettm(tmm,date);
	return tmm.tm_mday;
}

void CDate::GetYMD(long date,long &y,long & m,long & d) {
 if (date==0) {
  y=0;m=0;d=0;
 } else {
  tm tmm;
	 Gettm(tmm,date);
  y=tmm.tm_year;
  m=tmm.tm_mon;
  d=tmm.tm_mday;
 }
}

void CDate::Gettime(struct tm& tmDest,double date) {
 date+=HALF_SECOND;
 long nSecsInDay = (long)((date - floor(date)) * 86400.);
 if (nSecsInDay == 0)
		tmDest.tm_hour = tmDest.tm_min = tmDest.tm_sec = 0;
	else
	{
		tmDest.tm_sec = (int)nSecsInDay % 60L;
		long nMinutesInDay = nSecsInDay / 60L;
		tmDest.tm_min = (int)nMinutesInDay % 60;
		tmDest.tm_hour = (int)nMinutesInDay / 60;
	}
}

void CDate::Gettm(struct tm& tmDest,long date) {
	//if (dtSrc > MAX_DATE || dtSrc < MIN_DATE) // about year 100 to about 9999
	//	return FALSE;

	//long nDays;             // Number of days since Dec. 30, 1899
	long nDaysAbsolute;     // Number of days since 1/1/0
	//long nSecsInDay;        // Time in seconds since midnight
	//long nMinutesInDay;     // Minutes in day

	long n400Years;         // Number of 400 year increments since 1/1/0
	long n400Century;       // Century within 400 year block (0,1,2 or 3)
	long n4Years;           // Number of 4 year increments since 1/1/0
	long n4Day;             // Day within 4 year block
							//  (0 is 1/1/yr1, 1460 is 12/31/yr4)
	long n4Yr;              // Year within 4 year block (0,1,2 or 3)
	BOOL bLeap4 = TRUE;     // TRUE if 4 year block includes leap year

	//double dblDate = dtSrc; // tempory serial date

	// If a valid date, then this conversion should not overflow
	//nDays = (long)dblDate;

	// Round to the second
	//dblDate += ((dtSrc > 0.0) ? HALF_SECOND : -HALF_SECOND);

	nDaysAbsolute = (long)date + 693959L; // Add days from 1/1/0 to 12/30/1899

	//dblDate = fabs(dblDate);
	//nSecsInDay = (long)((dblDate - floor(dblDate)) * 86400.);

	// Calculate the day of week (sun=1, mon=2...)
	//   -1 because 1/1/0 is Sat.  +1 because we want 1-based
	tmDest.tm_wday = (int)((nDaysAbsolute - 1) % 7L) + 1;

	// Leap years every 4 yrs except centuries not multiples of 400.
	n400Years = (long)(nDaysAbsolute / 146097L);

	// Set nDaysAbsolute to day within 400-year block
	nDaysAbsolute %= 146097L;

	// -1 because first century has extra day
	n400Century = (long)((nDaysAbsolute - 1) / 36524L);

	// Non-leap century
	if (n400Century != 0) {
		// Set nDaysAbsolute to day within century
		nDaysAbsolute = (nDaysAbsolute - 1) % 36524L;
		// +1 because 1st 4 year increment has 1460 days
		n4Years = (long)((nDaysAbsolute + 1) / 1461L);

		if (n4Years != 0)	n4Day = (long)((nDaysAbsolute + 1) % 1461L);
		else	{
			bLeap4 = FALSE;
			n4Day = (long)nDaysAbsolute;
		}
	}	else	{
		// Leap century - not special case!
		n4Years = (long)(nDaysAbsolute / 1461L);
		n4Day = (long)(nDaysAbsolute % 1461L);
	}

	if (bLeap4) {
		// -1 because first year has 366 days
		n4Yr = (n4Day - 1) / 365;
		if (n4Yr != 0)	n4Day = (n4Day - 1) % 365;
	} else	{
		n4Yr = n4Day / 365;
		n4Day %= 365;
	}

	// n4Day is now 0-based day of year. Save 1-based day of year, year number
	tmDest.tm_yday = (int)n4Day + 1;
	tmDest.tm_year = n400Years * 400 + n400Century * 100 + n4Years * 4 + n4Yr;

	// Handle leap year: before, on, and after Feb. 29.
	if (n4Yr == 0 && bLeap4)	{
		// Leap Year
		if (n4Day == 59) {
			/* Feb. 29 */
			tmDest.tm_mon = 2;
			tmDest.tm_mday = 29;
			goto DoTime;
		}

		// Pretend it's not a leap year for month/day comp.
		if (n4Day >= 60)		--n4Day;
	}

	// Make n4DaY a 1-based day of non-leap year and compute
	//  month/day for everything but Feb. 29.
	++n4Day;

	// Month number always >= n/32, so save some loop time */
	for (tmDest.tm_mon = (n4Day >> 5) + 1;
		n4Day > _afxMonthDays[tmDest.tm_mon]; tmDest.tm_mon++);

	tmDest.tm_mday = (int)(n4Day - _afxMonthDays[tmDest.tm_mon-1]);

DoTime:;

	/*if (nSecsInDay == 0)
		tmDest.tm_hour = tmDest.tm_min = tmDest.tm_sec = 0;
	else
	{
		tmDest.tm_sec = (int)nSecsInDay % 60L;
		nMinutesInDay = nSecsInDay / 60L;
		tmDest.tm_min = (int)nMinutesInDay % 60;
		tmDest.tm_hour = (int)nMinutesInDay / 60;
	}*/


}

SD GetComputerName() {
	char buf[1000]={0};
	DWORD n=1000;
	::GetComputerName(buf,&n);
 return buf;
}

void getmessage() {
	MSG msg;
 while (GetMessage(&msg,NULL,0,0)){
	 TranslateMessage(&msg);
	 DispatchMessage(&msg);
	}
}

SD wctomb(void * a) {
 char * buf=NULL;
 int n=WideCharToMultiByte(CP_ACP,0,(WCHAR *)(unsigned short *)a,-1,buf,0,0,0);
	ASSERT(n>0);
	buf=(char *)malloc(n);
 n=WideCharToMultiByte(CP_ACP,0,(WCHAR *)(unsigned short *)a,-1,buf,n,0,0);
	SD s=buf;
	free(buf);
	return s;
}

SD upper(const char * s) {
 SD ss=s;
 ss.MakeUpper();
 return ss;
}

int SFind(SDA & a,SD & s) {
 for (int x=1;x<=a.GetSize();x++) {
  if (a.GetAt(x-1).CompareNoCase(s)==0) return x;
 }
 return 0;
}
#endif

SD getday(SD & d) {
 if (d.asdatetime().dval==0) return "";
 SD s=d.DateFormat("%a");
 s.MakeUpper();
 return s;
}

SD Getcurrentdirectory() {
 char buf[1000];
 ::GetCurrentDirectory(1000,buf);
 return SD(buf)+"\\";
}

bool setfiletime(SD fn,FILETIME * ftcreate,FILETIME * ftaccess,FILETIME * ftwrite) {
 HANDLE h = CreateFile(fn,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 if (h==INVALID_HANDLE_VALUE) {
  MMsgbox("Unable to open file " +fn+". Error code="+str(::GetLastError()));
  return false;
 }
 if (SetFileTime(h,ftcreate,ftaccess,ftwrite)==0) {
  MMsgbox("Unable to set file time file " +fn+". Error code="+str(::GetLastError()));
  CloseHandle(h);
  return false;
 }
 CloseHandle(h);
 return true;
}

bool getfiletime(SD fn,FILETIME * ftcreate,FILETIME * ftaccess,FILETIME * ftwrite) {
 HANDLE h = CreateFile(fn,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 if (h==INVALID_HANDLE_VALUE) {
  MMsgbox("Unable to open file " +fn+". Error code="+str(::GetLastError()));
  return false;
 }
 if (GetFileTime(h,ftcreate,ftaccess,ftwrite)==0) {
  MMsgbox("Unable to get file time file " +fn+". Error code="+str(::GetLastError()));
  CloseHandle(h);
  return false;
 }
 CloseHandle(h);
 return true;
}

void * readfile(SD fn,DWORD & n) {
 n=0;
 FILE * f=fopen(fn,"rb");
 if (f==0) return 0;
 VERIFY(fseek(f,0,SEEK_END)==0);
 n=ftell(f);
 VERIFY(fseek(f,0,SEEK_SET)==0);
 void * buf=malloc(n+4); //4 bytes for fix...
 fread(buf,1,n,f);
 fclose(f);
 return buf;
}

bool writefile(SD fn,void * buf,DWORD  n) {
 FILE * f=fopen(fn,"wb");
 if (f==0) return false;
 fwrite(buf,1,n,f);
 fclose(f);
 return true;
}

unsigned long strtoip(StringData s) {
 unsigned char c[4]={0,0,0,0};
 SDA cs;
 split(s,cs,'.');
 for (int i=0;i<min(4,cs.GetSize());i++) {
  c[i]=atoi(cs.GetAt(i));
 }
 return *((unsigned long *)c);
}

StringData iptostr(unsigned long ip) {
 SD sd;
 unsigned char * c=(unsigned char *)&ip;
 sd=str(c[0]);
 sd+="."+str(c[1]);
 sd+="."+str(c[2]);
 sd+="."+str(c[3]);
 return sd;
}

void flash(const char * s,HWND hwnd) {
 if (serverside) return;
 FONT font;
	HFONT hf;
	font.size=15;
	font.bold=true;
	hf=::CreateFont(&font);
	HDC hdc =::GetDC(0);
 int ScreenWidth=::GetDeviceCaps(hdc,HORZRES);
 int ScreenHeight=::GetDeviceCaps(hdc,VERTRES);
 //int LogPixelsY=GetDeviceCaps(hdc, LOGPIXELSY);
	::SelectObject(hdc,hf);
	SIZE size;
	::GetTextExtentPoint32(hdc,s,strlen(s),&size);
	::SetBkColor(hdc,RGB(255,0,0));
 ::SetTextColor(hdc,RGB(255,255,255));
	int lm,tm;
 lm=((hwnd==0?ScreenWidth:Getclientwidth(hwnd))-size.cx)/2;
 tm=((hwnd==0?ScreenHeight:Getclientheight(hwnd))-size.cy)/2;
	lm=max(0,lm);
 tm=max(0,tm);
	POINT p;memset(&p,0,sizeof(p));
	::ClientToScreen(hwnd,&p);
	lm+=p.x;
	tm+=p.y;
	::MoveToEx(hdc,lm,tm,0);
	::TextOut(hdc,lm,tm,s,strlen(s));
	::ReleaseDC(hwnd,hdc);
	::DeleteObject(hf);
}

//class stringData ------------------

StringData & StringData::MakeUpper() {
 //must not modify dt
 for (unsigned int x=0;x<actualsize;x++) {
  if (buf[x]>='a' && buf[x]<='z') buf[x]-=('a'-'A');
 }
 return *this;
}

StringData & StringData::MakeLower() {
 //must not modify dt
 for (unsigned int x=0;x<actualsize;x++) {
  if (buf[x]>='A' && buf[x]<='Z') buf[x]+=('a'-'A');
 }
 return *this;
}

void StringData::fputs(const char *s) {
 if (s==0) return;
 int l=strlen(s);
 addtobuf((void *)s,l,true);
}

void StringData::Dump() {
 StringData s="type=";s+=str(dt);
 s+="; value=";
 s+=asstring();
 s+='\n';
  ::OutputDebugStringA(s);
}

void StringData::addtobuf(void * bf,unsigned long n,bool fast) {
 setsize(actualsize+n,fast);
 memcpy(((char*)buf)+actualsize-n,bf,n);
}

void StringData::addzerotobuf(unsigned long n) {
 setsize(actualsize+n);
	memset(((char*)buf)+actualsize-n,0,n);
}

SD & StringData::Replace(const char * oldstr,const char * newstr) {
 //must not change the dt
 ASSERT(oldstr);
 ASSERT(newstr);
 int ol=strlen(oldstr),nl=strlen(newstr);
 if (ol==0) return *this;
 int diff=nl-ol,i,pos=0;
 while ((i=Find(oldstr,pos))!=-1) {
  setsize(actualsize+diff);
  memmove(buf+i+ol+diff,buf+i+ol,(actualsize-diff)-(i+ol));
  memcpy(buf+i,newstr,nl);
  pos=i+ol+diff;
 }
 return *this;
}

SD & StringData::Replace(char old,char nnew) {
 //must not change the dt
 for (int x=0;x<(signed)actualsize;x++) {
  if (buf[x]==old) buf[x]=nnew;
 }
 return *this;
}

signed int StringData::Find(const char * s,int start) const {
 signed int y,l;l=strlen(s);
 for (signed int x=start;x<=(signed)actualsize-l;x++) {
  for (y=0;y<l;y++) {
   if (buf[x+y]!=s[y]) break;
  }
  if (y>=l) return x;
 }
 return -1;
}

signed int StringData::Find(char c,int start,int end) const {
 //must not change the dt
 if (end==-1) end=actualsize;
 for (int x=start;x<(signed)end;x++) {
  if (buf[x]==c) return x;
 }
 return -1;
}

void StringData::init() {
 dt=dtString; //0; //can be dtString by default instead of 0
 actualsize=0;
	totsize=0;
	buf=NULL;
	sp=NULL;
 dval=0;
}

void StringData::destroy() {
 if (buf!=NULL) hfree(buf);
 buf=0;
}

void StringData::free() {
 if (buf!=NULL) {
  hfree(buf);
  buf=0;
  actualsize=0;
  totsize=0;
 }
}

StringData::~StringData() {
 if (buf!=NULL) {hfree2(buf);}
}

void StringData::setsize(unsigned int n,bool fast) {
 //must not modify the dt
 if (totsize<n) {
  unsigned int nn=n;
  if (fast) nn*=2;
		buf=(char *)hrealloc2(buf,nn);
  if (buf==NULL) {
	  tthrow("Error hrealloc memory StringData "+str(nn));
		}
		totsize=nn;
	}
	actualsize=n;
}


char StringData::aschar() {
 if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) return (char)lval;
 else if (dt==dtDouble || dt==dtDateTime) return (char) dval;
 else if (dt==dtFloat) return (char) fval;
 else if (dt==dtLonglong) return (char) llval;
 else return (char)atoi(*this);
 return 0;
}

short StringData::asshort() {
 if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) return (short)lval;
 else if (dt==dtDouble || dt==dtDateTime) return (short) dval;
 else if (dt==dtFloat) return (short) fval;
 else if (dt==dtLonglong) return (short) llval;
 else return (short) atoi(*this);
 return 0;
}

_int64 StringData::aslonglong() {
 if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) return lval;
 else if (dt==dtDouble || dt==dtDateTime) return (long) dval;
 else if (dt==dtFloat) return (long) fval;
 else if (dt==dtLonglong) return llval;
 else return _atoi64(*this);
 return 0;
}

long StringData::aslong() {
 if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) return lval;
 else if (dt==dtDouble || dt==dtDateTime) return (long) dval; //should do a fast round ..(because grid::setrst totals in double only??)
 else if (dt==dtFloat) return (long) fval;
 else if (dt==dtLonglong) return (long) llval;
 else return atoi(*this);
 return 0;
}

void StringData::SetDateTime(long y,long m,long d,long hour,long minute,long second) {
 long lval=Date(y,m,d);
 if (lval==0) {
  dval=0; //invalid date ...
 } else {
  ASSERT(lval>=0); //negative values not provided for
  dval= (((long)hour * 3600L) +  // hrs in seconds
	 	((long)minute * 60L) +  // mins in seconds
	 	((long)second)) / 86400.;
  dval+=lval;
 }
 dt=dtDateTime;
}

void StringData::SetDate(long y,long m,long d) {
 lval=Date(y,m,d);
 dt=dtDate;
}

void StringData::GetHMS(long *h,long * m,long * s) {
 struct tm t;
 CDate::Gettime(t,asdatetime().dval);
 if (h) *h=t.tm_hour;
 if (m) *m=t.tm_min;
 if (s) *s=t.tm_sec;
}

void StringData::GetYMD(long *y,long * m,long * d) {
 long dt=asdate().lval;
 if (dt==0) {
  if (y) *y=0;
  if (m) *m=0;
  if (d) *d=0;
 } else {
  tm t;
  CDate::Gettm(t,dt);
  if (y) *y=t.tm_year;
  if (m) *m=t.tm_mon;
  if (d) *d=t.tm_mday;
 }
}

long StringData::GetDay() {
 return CDate::GetDay(asdate().lval);
}

void DateOnlyFormat(const char * format,long d,SD & sd) {
 char buf[1000];
 struct tm t;
 //double d=asdatetime().dval;
 if (d==0) {sd="";return;}
 CDate::Gettm(t,d);
 //CDate::Gettime(t,d);
 t.tm_year -= 1900;  // year is based on 1900
	t.tm_mon -= 1;      // month of year is 0-based
	t.tm_wday -= 1;     // day of week is 0-based
	t.tm_yday -= 1;     // day of year is 0-based
 if (strftime(buf,1000-1,format,&t)==0) buf[0]=0;
 sd=buf;
 //return buf;
}

void DateTimeFormat(const char * format,double d,SD & sd) {
 char buf[1000];
 struct tm t;
 //double d=asdatetime().dval;
 if (d==0) {sd="";return;}
 CDate::Gettm(t,(long)d); //+ HALF SECOND
 CDate::Gettime(t,d);
 t.tm_year -= 1900;  // year is based on 1900
	t.tm_mon -= 1;      // month of year is 0-based
	t.tm_wday -= 1;     // day of week is 0-based
	t.tm_yday -= 1;     // day of year is 0-based
 if (strftime(buf,1000-1,format,&t)==0) buf[0]=0;
 sd=buf;
 //return buf;
}

StringData StringData::DateFormat(const char * format) {
 SD sd;
 DateTimeFormat(format,asdatetime().dval,sd);
 return sd;
}

long StringData::GetDayOfYear() {
 struct tm t;
 CDate::Gettm(t,asdate().lval);
 return t.tm_yday;
}

long StringData::GetDayOfWeek() {
 struct tm t;
 CDate::Gettm(t,asdate().lval);
 return t.tm_wday;
}

long StringData::GetHour() {
 struct tm t;
 CDate::Gettime(t,asdatetime().dval);
 return t.tm_hour;
}

long StringData::GetMinute() {
 struct tm t;
 CDate::Gettime(t,asdatetime().dval);
 return t.tm_min;
}

long StringData::GetSecond() {
 struct tm t;
 CDate::Gettime(t,asdatetime().dval);
 return t.tm_sec;
}

long StringData::GetYear() {
 return CDate::GetYear(asdate().lval);
}

long StringData::GetMonth() {
 return CDate::GetMonth(asdate().lval);
}

float StringData::asfloat() {
 if (dt==dtFloat) return fval;
 else if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) return (float)lval;
 else if (dt==dtDouble || dt==dtDateTime) return (float)dval;
 else if (dt==dtLonglong) return (float)llval;
 else return (float)atof(*this);
 return 0;
}

SD StringData::asdate() {
 SD sd;
 if (dt==dtDouble || dt==dtDateTime) sd=(long) (dval+HALF_SECOND);
 else if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) sd=lval;
 else if (dt==dtFloat) sd=(long) fval;
 else if (dt==dtLonglong) sd=(long) llval;
 else sd=strtodate(*this);
 sd.dt=dtDate;
 return sd;
}

SD StringData::asdatetime() {
 SD sd;
 if (dt==dtDouble || dt==dtDateTime) sd=dval;
 else if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) sd=(double)lval;
 else if (dt==dtFloat) sd=(double) fval;
 else if (dt==dtLonglong) sd=(double) llval;
 else sd=strtodatetime(*this);
 sd.dt=dtDateTime;
 return sd;
}

SD & StringData::tostring() {
 if (!isstring()) {
  asstring((*this));
 }
 return *this;
}

SD & StringData::tofloat() {
 (*this)=asfloat();
 return *this;
}

SD & StringData::tolonglong() {
 if (dt!=dtLonglong) (*this)=aslonglong();
 return *this;
}

SD & StringData::todatetime() {
 if (dt!=dtDateTime) {
  (*this)=asdatetime();
  dt=dtDateTime;
 }
 return *this;
}

SD & StringData::todate() {
 if (dt!=dtDate) {
  (*this)=asdate();
  dt=dtDate;
 }
 return *this;
}

SD & StringData::tolong() {
 if (!islong()) (*this)=aslong();
 return *this;
}

SD & StringData::todouble() {
 if (!isdouble()) (*this)=asdouble();
 return *this;
}

double StringData::asdouble() {
 if (dt==dtDouble || dt==dtDateTime) return dval;
 else if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) return (double)lval;
 else if (dt==dtFloat) return (double) fval;
 else if (dt==dtLonglong) return (double) llval;
 else return atof(*this);
 return 0;
}

bool StringData::isstring() {
 if (dt==dtString || dt==dtFstring || dt==0) return true;
 return false;
}

bool StringData::isdouble() {
 if (dt==dtDouble) return true;
 else if (dt==dtDateTime) {dt=dtDouble;return true;}
 if (dt==dtFloat) {dval=fval;dt=dtDouble;return true;}
 return false;
}

bool StringData::islong() {
 if (dt==dtLong) return true;
 else if (dt==dtDate) {dt=dtLong;return true;}
 else if (dt==dtWord) {lval=wval;dt=dtLong;return true;}
 else if(dt==dtChar) {lval=bval;dt=dtLong;return true;}
 return false;
}

SD & dstr(double n,int nod,SD & sd) {
 if (!_finite(n)) {
  sd="#Infinite";
 } else {
 	char buf[1000];
  char buf2[100];
  buf2[0]='%';
  buf2[1]='.';
  sprintf(buf2+2,"%d",nod);
  int l=strlen(buf2+2);
  buf2[2+l]='f';
  buf2[2+1+l]=0;
  //strcat(buf2,"f");
	 sprintf(buf,buf2,n);
	 sd=buf;
 }
 return sd;
}

SD & dstr(double n,SD & sd) {
 if (!_finite(n)) {
  sd="#Infinite";
 } else {
 	char buf[1000];
 	sprintf(buf,"%.6f",n);
  sd=buf;
  dzfix(sd);
 }
	return sd;
}

SD & str(signed long n,SD & sd) { //can  be sped up......
	char buf[1000];
	sprintf(buf,"%d",n);
 ASSERT(buf[0]!=0); //0 must be returned as "0" // used in sbWorkbook::ttos()
 sd=buf;
	return sd;
}

SD & lstr(_int64 n,SD & sd) {
	char buf[1000];
	sprintf(buf,"%I64d",n);
	sd=buf;
 return sd;
}

StringData & StringData::asstring(StringData & sd) {
 if (dt==dtString || dt==dtFstring || dt==0 || dt==dtVariable || dt==dtFunction) {
  sd=(*this);
 } else if (dt==dtLong) {
  if (lval==0) sd=""; else str(lval,sd);
 } else if (dt==dtWord) {
  if (wval==0) sd=""; else str(wval,sd);
 } else if (dt==dtChar) {
  if (bval==0) sd=""; else str(bval,sd);
 } else if (dt==dtDouble) {
  if (dval==0) sd=""; else dstr(dval,sd);
 } else if (dt==dtFloat) {
  if (fval==0) sd=""; else dstr(fval,sd);
 } else if (dt==dtDateTime) {
  DateTimeFormat("%d/%m/%Y %I:%M:%S%p",dval,sd);
 } else if (dt==dtDate) {
  DateOnlyFormat("%d/%m/%Y",lval,sd);
 } else if (dt==dtLonglong) {
  if (llval==0) sd=""; else lstr(llval,sd);
 } else if (dt==dtCyclic) {
  sd="#Cyclic";
 }
 return sd;
}

StringData StringData::asstring() {
 SD sd;
 return asstring(sd);
}

/* if (dt==dtString || dt==dtFstring || dt==0 || dt==dtVariable || dt==dtFunction) {
  return (*this);
  //SD s;
  //memcpy(s.GetBuffer(actualsize),buf,actualsize);
  //s.ReleaseBuffer(actualsize);
  //return s;
 }
 else if (dt==dtLong || dt==dtWord || dt==dtChar) {
  return lval==0?"":str(lval);
 }
 else if (dt==dtDouble) {
  return dval==0?"":dstr(dval);
 }
 else if (dt==dtFloat) {
  return fval==0?"":dstr(fval);
  //return dstr(asdouble());
 }
 else if (dt==dtDateTime) {
  return DateFormat("%d/%m/%Y %I:%M:%S%p");
 } else if (dt==dtDate) {
  return DateFormat("%d/%m/%Y"); // %I:%M:%S %p");
 } else if (dt==dtLonglong) {
  return llval==0?"":lstr(llval);
 }
 return "";
}*/

void StringData::operator +=(char c) {
 setsize(actualsize+1);
 buf[actualsize-1]=c;
 dt=dtString;
}

void StringData::operator +=(double d ) {
 if (dt==dtDouble)  dval+=d;
 else if (dt==dtFloat)  fval+=(float)d;
 else if (dt==dtLonglong)  llval+=(_int64)d;
 else lval+=(long)d;
}
void StringData::operator -=(double d ) {
 (*this)+=(-d);
}

signed char StringData::seq2(StringData & sd) { //string eqality
 //if (actualsize!=sd.actualsize) return false;
 signed char c;
 if (actualsize>sd.actualsize) {
  c=(signed char)memcmp(buf,sd.buf,sd.actualsize);
  if (c==0) c=1;
  ASSERT(c==-1 || c==0 || c==1);
 } else if (sd.actualsize>actualsize) {
  c=(signed char) memcmp(buf,sd.buf,actualsize);
  if (c==0) c=-1;
  ASSERT(c==-1 || c==0 || c==1);
 } else return (signed char) memcmp(buf,sd.buf,actualsize);
 return c;
}


bool StringData::iseq(StringData & sd) { //case insensitive string eqality
 //if (actualsize!=sd.actualsize) return false;
 if (actualsize>sd.actualsize) {
  if (buf[sd.actualsize]==0) {
   return (memicmp(buf,sd.buf,sd.actualsize)==0)?true:false;
  }
  return false;
 } else if (sd.actualsize>actualsize) {
  if (sd.buf[actualsize]==0) {
   return (memicmp(buf,sd.buf,actualsize)==0)?true:false;
  }
  return false;
 }
 //if (actualsize!=sd.actualsize) return false;
 return (memicmp(buf,sd.buf,actualsize)==0)?true:false;
}

bool StringData::seq(StringData & sd) { //string eqality
 //if (actualsize!=sd.actualsize) return false;
 if (actualsize>sd.actualsize) {
  if (buf[sd.actualsize]==0) {
   return (memcmp(buf,sd.buf,sd.actualsize)==0)?true:false;
  }
  return false;
 } else if (sd.actualsize>actualsize) {
  if (sd.buf[actualsize]==0) {
   return (memcmp(buf,sd.buf,actualsize)==0)?true:false;
  }
  return false;
 }
 //if (actualsize!=sd.actualsize) return false;
 return (memcmp(buf,sd.buf,actualsize)==0)?true:false;
}

bool StringData::operator !=(StringData & sd) {
 return !((*this)==sd);
}

signed char StringData::compare(StringData &sd) {
 if (dt==dtString || dt==dtFstring || dt==0) {
  return seq2(sd);
 } else if (dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDate) {
  if (lval<sd.lval) return -1;
  else if (lval>sd.lval) return 1;
  return 0;
 } else if (dt==dtDouble || dt==dtDateTime) {
  if (dval<sd.dval) return -1;
  else if (dval>sd.dval) return 1;
  return 0;
 } else if (dt==dtFloat) {
  if (fval<sd.fval) return -1;
  else if (fval>sd.fval) return 1;
  return 0;
 } else if (dt==dtLonglong) {
  if (llval<sd.llval) return -1;
  else if (llval>sd.llval) return 1;
  return 0;
 }else selfcheck();
 return 0;
}

bool StringData::operator ==(StringData & sd) {
 if (dt==dtString || dt==dtFstring || dt==0) {
  if (sd.dt==dtString || sd.dt==dtFstring || sd.dt==0) {
   return seq(sd);
  }
  return false;
 }
 if (dt!=sd.dt) return false;
 if (dt==dtChar) return bval==sd.bval;
 if (dt==dtWord) return wval==sd.wval;
 if (dt==dtLong || dt==dtDate) return lval==sd.lval;
 if (dt==dtDouble || dt==dtDateTime) return dval==sd.dval;
 if (dt==dtFloat) return fval==sd.fval;
 if (dt==dtLonglong) return llval==sd.llval;
 return false;
}

void StringData::operator +=(const StringData & s) { //unsed in buildlognew()
 long l=s.actualsize;
 setsize(actualsize+l);
 memcpy(buf+actualsize-l,s.buf,l);
 dt=dtString;
}

void StringData::operator +=(const char * s) {
 long l=strlen(s);
 setsize(actualsize+l);
 memcpy(buf+actualsize-l,s,l);
 dt=dtString;
}
void StringData::ReleaseBuffer(int x) {
 if (x==-1) setsize(strlen(buf));
 else setsize(x);
 dt=dtString;
}

int StringData::Compare(const char *s) {
 ASSERT(s);
 return strcmp(s,(const char *)(*this));
}

int StringData::CompareNoCase(const char *s) {
 //must not modify dt
 ASSERT(s);
 return stricmp(s,(const char *)(*this));
 /*long l=strlen(s);
 if (actualsize!=(unsigned)l) return 1;//false;
 if (memicmp(buf,s,actualsize)==0) return 0;
 return 1;*/
}

//bool StringData::operator ==(const char *s) {
  //return (strcmp(s,(const char *)(*this))==0)?true:false;
//}

/*StringData::operator long() {
 return aslong();
}*/

StringData::operator const char *() {
 putz();
 return buf;
}

/*StringData::operator char *() {
 putz();
 return buf;
}*/
/*StringData::operator void *() {
 putz();
 return buf;
}*/

StringData & StringData::TrimLeft() {
 unsigned int x;
 for (x=0;x<actualsize;x++) {
  if ((buf[x]!=' ') && (buf[x]!=10) && (buf[x]!=13)) break;
 }
 memmove(buf,buf+x,actualsize-x);
 actualsize-=x;
 return *this;
}


void StringData::operator =(unsigned short *s ) {
 ASSERT(s!=0);
 setsize(wcslen((WCHAR*)s));
 for (unsigned int x=0;x<actualsize;x++) {
  if (s[x]>255) {
   if (s[x]==8217) buf[x]='\'';
   else buf[x]=' ';
  } else buf[x]=(char)s[x];
 }
 dt=dtString;
}
void StringData::operator =(float d ) {
 fval=d;
 dt=dtFloat;
}
void StringData::operator =(const StringData & sd ) {
 //if (this==&sd) return;
 dt=sd.dt;
 if (dt==dtString || dt==dtFstring || dt==0 || dt==dtVariable || dt==dtFunction) {
  setsize(sd.actualsize);
  memcpy(buf,sd.buf,actualsize);
 } else {
  //ASSERT(sd.actualsize==0);
  dval=sd.dval; //else avoided because of tokens
 }
}
void StringData::operator =(double d ) {
 dval=d;
 dt=dtDouble;
}

void StringData::operator =(long l ) {
 lval=l;
 dt=dtLong;
}
void StringData::operator =(_int64 l ) {
 llval=l;
 dt=dtLonglong;
}
void StringData::operator =(const char * s ) {
 if (s==0) actualsize=0;
 else {
  setsize(strlen(s)+1);
  actualsize--;
  memcpy(buf,s,actualsize);
 }
 dt=dtString;
}

void StringData::operator =(short l ) {
 lval=l;
 dt=dtWord;
}

void StringData::operator =(char l) {
 setsize(1); //to keep it compatible with CString
 buf[0]=l;
 dt=dtString;
}

void StringData::operator =(bool b) {
 lval=b?1:0;
 dt=dtChar;
}

void StringData::Delete(int pos) {
 RemoveAt(pos);
}

StringData & StringData::Remove(char c) {
 for(signed int x=0;x<(signed)actualsize;x++) {
  if (buf[x]==c) {
   RemoveAt(x);
   x--;
  }
 }
 return *this;
}

void StringData::RemoveLast() {
 RemoveAt(actualsize-1);
}

void StringData::RemoveAt(int spos,int epos) {
 if (spos<0) spos=0;
 if (epos>=actualsize) epos=actualsize-1;
 if (epos<spos) return;
 memmove(buf+spos,buf+epos+1,actualsize-(epos+1));
 actualsize-=(epos-spos+1);
}

void StringData::RemoveAt(int pos) {
 if (pos<0 || pos>=(signed)actualsize) return;
 memmove(buf+pos,buf+pos+1,actualsize-pos-1);
 actualsize--;
}

void StringData::SetAt(int pos,char c) {
 //must not change the dt
 //ASSERT(pos>=0);
 if ((unsigned)pos>=actualsize) return;
 buf[pos]=c;
}

char & StringData::operator [](int pos) {
 ASSERT(pos>=0 && pos<(signed int)actualsize);
 return buf[pos];
}

char StringData::GetLast() { //cannot use char &
 return GetAt(actualsize-1);
}

char StringData::GetAt(int pos) {
 if ((unsigned)pos>=actualsize || pos<0) return 0;
 return buf[pos];
}

bool StringData::operator >=(StringData & sd) {
 if (cmp(sd)>=0) return true;
 return false;
}

bool StringData::operator <=(StringData & sd) {
 if (cmp(sd)<=0) return true;
 return false;
}

bool StringData::operator <(StringData & sd) {
 if (cmp(sd)==-1) return true;
 return false;
}

bool StringData::operator >(StringData & sd) {
 if (cmp(sd)==1) return true;
 return false;
}

bool StringData::cmpeq(StringData & sd) {
 //return true if both SD's are equal
 //This function is faster then cmp() function, especially for strings
 if (isstring()) {
  sd.tostring();
  return seq(sd);
 } else if (sd.isstring()) {
  tostring();
  return seq(sd);
 } else if (isdouble()) {
  sd.todouble();
  return dval==sd.dval;
 } else if (sd.isdouble()) {
  todouble();
  return dval==sd.dval;
 } else if (dt==dtLonglong) {
  sd.tolonglong();
  return llval==sd.llval;
 } else if (sd.dt==dtLonglong) {
  tolonglong();
  return llval==sd.llval;
 } else if (islong()) {
  sd.tolong();
  return lval==sd.lval;
 } else if (sd.islong()) {
  tolong();
  return lval==sd.lval;
 } else tthrow("StringData::cmpeq - invalid data type "+dttostr(dt));
 return 0;
}

signed char StringData::cmp(StringData & sd) {
 if (isstring()) {
  sd.tostring();
  return seq2(sd);
 } else if (sd.isstring()) {
  tostring();
  return seq2(sd);
 } else if (isdouble()) {
  sd.todouble();
  return (dval>sd.dval?1:(dval<sd.dval?-1:0));
 } else if (sd.isdouble()) {
  todouble();
  return (dval>sd.dval?1:(dval<sd.dval?-1:0));
 } else if (dt==dtLonglong) {
  sd.tolonglong();
  return (llval>sd.llval?1:(llval<sd.llval?-1:0));
 } else if (sd.dt==dtLonglong) {
  tolonglong();
  return (llval>sd.llval?1:(llval<sd.llval?-1:0));
 } else if (islong()) {
  sd.tolong();
  return (lval>sd.lval?1:(lval<sd.lval?-1:0));
 } else if (sd.islong()) {
  tolong();
  return (lval>sd.lval?1:(lval<sd.lval?-1:0));
 } else tthrow("StringData::cmp - invalid data type "+dttostr(dt));
 return 0;
}


// ASSERT(dt==dtString || dt==dtFstring || dt==0);
 //ASSERT(sd.dt==dtString || sd.dt==dtFstring || sd.dt==0);
 //return (strcmp(*this,sd)>0)?true:false;

 /*char c=memcmp(buf,sd.buf,min(actualsize,sd.actualsize));
 if (c>0) return true;
 if (c<0) return false;
 if (sd.actualsize>actualsize) return true;
 return false;*/
//}

void StringData::Insert(int pos,char c) {
 ASSERT(pos>=0);
 if ((unsigned int)pos>actualsize) pos=actualsize;
 setsize(actualsize+1);
 memmove(buf+pos+1,buf+pos,actualsize-1-pos);
 buf[pos]=c;
}

void StringData::Insert(int pos,const char * s) {
 ASSERT(s);
 ASSERT(pos>=0);
 int l=strlen(s);
 if ((unsigned int)pos>actualsize) pos=actualsize;
 setsize(actualsize+l);
 memmove(buf+pos+l,buf+pos,actualsize-l-pos);
 memcpy(buf+pos,s,l);
}

StringData StringData::Left(int count) {
  StringData sd;
  if (count<=0) return "";
  long len=min((unsigned)count,actualsize);
  sd.setsize(len);
  memcpy(sd.buf,buf,len);
  sd.dt=dtString;
  return sd;
 }

 StringData StringData::Right(int count) {
  StringData sd;
  ASSERT(count>=0);
  long len=min((unsigned)count,actualsize);
  sd.setsize(len);
  memcpy(sd.buf,buf+actualsize-len,len);
  sd.dt=dtString;
  return sd;
 }

StringData StringData::Mid(int pos) const{
 StringData sd;
 long len=actualsize-pos;
 if (len<0) len=0;
 sd.setsize(len);
 memcpy(sd.buf,buf+pos,len);
 sd.dt=dtString;
 return sd;
}

StringData StringData::Mid(int pos,int len) const{
 StringData sd;
 ASSERT(pos>=0);
 if (len<0) len=0;
 if (pos+len>(signed)actualsize) {
  len=actualsize-pos;
  if (len<0) len=0;
 }
 sd.setsize(len);
 memcpy(sd.buf,buf+pos,len);
 sd.dt=dtString;
 return sd;
}


long todate(const char * c,int len) {
 int y,m=0,d=0;
 if (len<=0) return 0;
 d=atoi(c);
 while (len!=0) {
  c++;len--;
  if (c[-1]=='/') break;
 }
 m=atoi(c);
 while (len!=0) {
  c++;len--;
  if (c[-1]=='/') break;
 }
 y=atoi(c);
 if (m==0 || d==0 || y==0) return 0;
 return Date(y,m,d);
}

//class stringData Ends------------------
void Hptimer::trace() {
 ::OutputDebugString("Hptimer::"+ts+" "+dstr(gettime(true),6)+" seconds\n");
  reset();
}

void Hptimer::report() {
  MMsgbox(dstr(gettime(true),6)+" seconds");
  reset();
}
//class hptimer Ends------------------

void split(const SD & s,SDA & ca,char c) {
 //s remains unchanged
	int i,ii,count;
 count=0;i=0;
 while (i<(signed)s.actualsize) {
  ii=s.Find(c,i);
  //ASSERT(ii>=i);
  if (ii==-1) {
   ca.SetAtGrow(count,s.Mid(i));count++;
   break;
  }
  ca.SetAtGrow(count,s.Mid(i,ii-i));count++;
  i=ii+1;
 }
 while (ca.GetSize()>count) {
  ca.RemoveAt(ca.GetSize()-1);
 }
}

int getdiff(int sy,int sm,int ey,int em) {
	return ((ey-sy)*12) + (em-sm);
}

/*template<class ARY,class ELE> int SortedAdd(ARY & a,ELE & e) {
 //ary must be sorted
 //returns the position at which the new element is inserted
 signed int top=0;
 signed int bot=a.GetSize()-1;
 signed int mid; //=(top+bot)/2;
 while (true) {
  mid=(top+bot)/2;
  if (bot<top) {
   a.InsertAt(top,e);
   return top;
  }
  if (e>=a.GetAt(mid)) top=mid+1;
  else bot=mid-1;
 }
}*/

/*//--------------SArray Starts-------------------------------
template <class C> void SArray<C>::insert2(C ele,int pos) {
 ASSERT(top>=0 && top<=bot);
 ASSERT(bot>=top && bot<max);
 ASSERT(pos>=top && pos<=bot+1);
 ASSERT(bot-top+1==n);
 ASSERT(n<max);
 if (pos-top<bot-pos+1) { //left side
	 if (top==0) { //make space
   int diff=max-bot;
	  ASSERT(diff>=2);
	  diff/=2;
   memmove(buf+diff,buf,n*sizeof(C));
   pos+=diff;
	  top+=diff;
	  bot+=diff;
	 }
	 ASSERT(top>0);
  memmove(buf+((top-1)),buf+(top),(pos-top)*sizeof(C));
	 buf[pos-1]=ele;
	 top--;
 } else {
  if (bot==max-1) { //make space
   int diff=top+1;
	  ASSERT(diff>=2);
	  diff/=2;
   memmove(buf+((top-diff)),buf+(top),n*sizeof(C));
   pos-=diff;
	  top-=diff;
	  bot-=diff;
	 }
  ASSERT(bot<max-1);
  memmove(buf+((pos+1)),buf+(pos),(bot-pos+1)*sizeof(C));
  buf[pos]=ele;
	 bot++;
 }
 n++;
}

template <class C> void SArray<C>::remove2(int pos) {
 ASSERT(top>=0 && top<=bot);
	ASSERT(bot>=top && bot<max);
	ASSERT(pos>=top && pos<=bot);
	ASSERT(bot-top+1==n);
	ASSERT(n<=max && n>0);
	if (pos-top<bot-pos) { //left side
  memmove(buf+top+1,buf+top,(pos-top)*sizeof(C));
		top++;
	} else {
		memmove(buf+pos,buf+pos+1,(bot-pos)*sizeof(C));
		bot--;
	}
	n--;
}

template <class C> SArray<C>::SArray(){
	buf=0;
	growby=100; //elements
	startwith=100; //elements
	n=0;
}

template <class C> SArray<C>::~SArray() {
	if (buf) hfree(buf);
}

template <class C> void SArray<C>::InsertAt(int pos,C ele) {
	if (buf==0) {
		ASSERT(startwith>0);
		buf=(C*)halloc(startwith*sizeof(C));
		if (buf==0) tthrow("No Memory");
		max=startwith;
		ASSERT(n==0);
	}
	ASSERT(n<=max);
 if (n==max) {
		ASSERT(growby>0);
		int oldmax=max;
		max+=growby;growby*=2;
  buf=(C*)hrealloc(buf,max*sizeof(C)); //,oldmax*sizeof(C));
		if (buf==0) tthrow("No Memory");
	}
	ASSERT(n<max);
	if (n==0) {
		top=max/2;
		bot=top;
		buf[top]=ele;
		n=1;
		return;
	}
	ASSERT(pos>=0 && pos<=n);
	ASSERT(n==bot-top+1);
 insert2(ele,pos+top);
}

template <class C> inline void SArray<C>::Add(C ele) {
	InsertAt(n,ele);
}

template <class C> inline int SArray<C>::GetSize() {
	return n;
}

template <class C> signed long SArray<C>::Find(C ele) {
 for (int x=0;x<GetSize();x++) {
  if (GetAt(x)==ele) return x;
 }
 return -1;
}

template <class C> void SArray<C>::RemoveAll() {
	n=0;
}

template <class C>C SArray<C>::GetAt(int pos) {
	ASSERT(pos>=0 && pos<n);
 return buf[pos+top];
}

template <class C>void SArray<C>::SetAt(int pos,C ele) {
	ASSERT(pos>=0 && pos<n);
 buf[pos+top]=ele;
}

template <class C>void SArray<C>::SetAtGrow(int pos,C ele) {
 ASSERT(pos>=0);
 while (pos>=n) {
  Add(C());
 }
 SetAt(pos,ele);
}

template <class C>void SArray<C>::RemoveAt(int pos) {
	ASSERT(pos>=0 && pos<n);
	remove2(pos+top);
}

//----------------SArray Ends ------------------------------------*/

void logbreak(SD & sd,SDA & fields,SDA & values) {
 //<field1>=<value1>,<field2>=<value2>, ....
 //assumes <field name> dosenot contains '=' charecter
 int n=0,l=0;
 sd.putz();
 static Eval e;
 while (true) {
  int i=sd.Find('=',l);
  if (i==-1) break;
  if (fields.GetSize()==n) fields.Add(SD());
  if (values.GetSize()==n) values.Add(SD());
  fields[n]=sd.Mid(l,i-l);
  char * start=sd.buf+i+1;
  const char * end;
  e.eval3(start,&end); //throws error on major errors
  if (e.tokens.GetSize()==0) values[n]=(long)0;
  else if (e.tokens.GetSize()!=1) tthrow("Error in logbreak string - "+SD(start));
  else values[n]=e.tokens[0]->sval;
  l=i+1;
  l+=end-start;
  //ASSERT(end>start);
  n++;
  if (sd.buf[l]==',') l++;
  else break;
 }
 while (fields.GetSize()>n) fields.RemoveLast();
 while (values.GetSize()>n) values.RemoveLast();
}

bool isvaliddt(unsigned char dt) {
 if (dt==dtString || dt==dtChar || dt==dtWord || dt==dtLong || dt==dtDateTime || dt==dtDouble || dt==dtFloat || dt==dtFstring || dt==dtDate || dt==dtLonglong) {
  return true;
 }
 return false;
}

unsigned char strtodt(SD & sd) {
 if (sd.CompareNoCase("dtString")==0) return dtString;
 else if (sd.CompareNoCase("dtChar")==0) return dtChar;
 else if (sd.CompareNoCase("dtWord")==0) return dtWord;
 else if (sd.CompareNoCase("dtLong")==0) return dtLong;
 else if (sd.CompareNoCase("dtDateTime")==0) return dtDateTime;
 else if (sd.CompareNoCase("dtDouble")==0) return dtDouble;
 else if (sd.CompareNoCase("dtFloat")==0) return dtFloat;
 else if (sd.CompareNoCase("dtFstring")==0) return dtFstring;
 else if (sd.CompareNoCase("dtDate")==0) return dtDate;
 else if (sd.CompareNoCase("dtLonglong")==0) return dtLonglong;
 return 0;
}

SD dttostr(unsigned char dt) {
 if (dt==1 || dt==0) return "dtString";
 else if (dt==2) return "dtChar";
 else if (dt==3) return "dtWord";
 else if (dt==4) return "dtLong";
 else if (dt==5) return "dtDateTime";
 else if (dt==6) return "dtDouble";
 else if (dt==7) return "dtFloat";
 else if (dt==8) return "dtBoolean";
 else if (dt==9) return "dtCurrency";
 else if (dt==10) return "dtFstring";
 else if (dt==11) return "dtDate";
 else if (dt==12) return "dtLonglong";
 else if (dt==13) return "dtVariable"; //for sbWorkbook only
 else if (dt==14) return "dtCyclic";  //for sbWorkbook only
 else if (dt==15) return "dtFunction";  //for tokens
 else return "invalid dt ("+str(dt)+")";
}

unsigned long getmaxram() {
 MEMORYSTATUS ms;
 GlobalMemoryStatus(&ms);
 return (ms.dwTotalPhys/(1024*1024));
}

void getnullfield(unsigned char dt,StringData & sd) {
 if (dt==dtString || dt==dtFstring)  {
	 sd.actualsize=0;
  sd.dt=dtString;
 } else  {
  sd.dval=0;
	 sd.dt=dt;
 }
}

void drawbox(HDC hdc,int l,int t,int r,int b) {
 MoveToEx(hdc,l,t,0);
 LineTo(hdc,r,t);
 LineTo(hdc,r,b);
 LineTo(hdc,l,b);
 LineTo(hdc,l,t);
}

void drawbox2(HDC hdc,int l,int t,int r,int b) {
 int w=r-l+1;
 int h=b-t+1;
 ::PatBlt(hdc,l,t,w,1,PATCOPY);
 ::PatBlt(hdc,l,t,1,h,PATCOPY);
 ::PatBlt(hdc,l,b,w,1,PATCOPY);
 ::PatBlt(hdc,r,t,1,h,PATCOPY);
}

unsigned char tobase64(unsigned char c) {
	if (/*c>=0 && */c<=25) return 'A'+c;
 if (c>=26 && c<=51) return 'a'+c-26;
 if (c>=52 && c<=61) return '0'+c-52;
	if (c==62) return '+';
 if (c==63) return '/';
 MMsgbox("selfcheck .. tobase64");
	return 0;
}

SD base64encode(const SD & src) {
 SD dest;
	unsigned char lastchar=0;
	unsigned char pendingbits=0;
 int chars=0;
	bool eof=false;
	int pad=4;
	int bufpos=0;
	while (true) {
		unsigned char cc;
		ASSERT(pendingbits<=6);
		cc=lastchar;
		cc=cc>>2; //<<(6-pendingbits);
		if (pendingbits<6) {
			WORD w;
			w=0;
   unsigned long count;
			if (bufpos==(signed)src.actualsize) count=0;
			else {
				count=1;
				memcpy(&w,src.buf+bufpos,1);
				bufpos++;
			}
		 if (count==0) {
				eof=true;
				if (pendingbits==0) break;
				w=0;
			}
			int bitsneeded=6-pendingbits;
   w=w<<bitsneeded;
			unsigned char * c=(unsigned char *)&w;
			lastchar=*c; //the unused bits in lastchar are zeroed
			c++;
			cc=(cc|(*c));
   pendingbits=8-bitsneeded;
			ASSERT(pendingbits<=6);
		} else {
			pendingbits=0;
			lastchar=0;
		}
  unsigned char c=tobase64(cc);
		if (false && chars==76) {
			//if (destpos>=destlen) selfcheck();
   dest+=(char)13;
   //if (destpos>=destlen) selfcheck();
   dest+=(char)10;
   //fwrite(CRLF,1,2,df);
			chars=0;
		}
  //if (destpos>=destlen) selfcheck();
  dest+=(char)c;
  //int count=fwrite(&c,1,1,df);
		pad--;
		if (pad==0) pad=4;
		chars++;
		if (eof) break;
	}
	if (pad!=4) {
		char c='=';
		for (int x=1;x<=pad;x++) {
   //if (destpos>=destlen) selfcheck();
   dest+=c;
   //fwrite(&c,1,1,df);
		}
	}
 return dest;
}

_int64 gethash(char * buf,long n) {//alternative to MD5 hash
 _int64 i=0;
 for (int x=1;x<=n;x++) i+=(x*buf[x-1]);
 return i;
}

unsigned char frombase64(unsigned char c) {
	if (c>='A' && c<='Z') return c-'A';
	if (c>='a' && c<='z') return c-'a'+26;
	if (c>='0' && c<='9') return c-'0'+52;
	if (c=='+') return 62;
 if (c=='/') return 63;
 MMsgbox("selfcheck .. frombase64");
	return 0;
}

SD base64decode(SD & src) {
 SD dest;
	int destlen=src.actualsize;
	//char * dest=(char *)malloc(destlen);
 //if (dest==0) return 0;
	//int destpos=0;
 int bufpos=0;
 unsigned char c=0;
	int bitsneeded=8;
	while (true) {
		WORD w;
		w=0;
		unsigned char * c2=(unsigned char *) &w;
  unsigned long count;
		if (bufpos>=(signed)src.actualsize) count=0;
		else {
			count=1;
   memcpy(&w,src.buf+bufpos,1);
   bufpos++;
		}
  if (count==0) break; //eof reached
		if (*c2=='=') break; //padding
  if (*c2==10 || *c2==13 || *c2=='!') continue; //break;
		(*c2)=frombase64(*c2);
		ASSERT(*c2<=63);
		int bits=min(6,bitsneeded);
  w=w<<(2+bits); //(min(6,bitsneeded)));
  int diff=bitsneeded-bits;
		ASSERT(diff>=0);
		if (diff>0) w=w<<diff;
		c=c|(*(c2+1));
		bitsneeded-=bits;
		if (bitsneeded==0) {
   //if (destpos>=destlen) bselfcheck();
   dest+=(char)c; //[destpos++]=c;
   //fwrite(&c,1,1,df);
   diff=6-bits;
   c=(*c2);
   bitsneeded=8-diff;
			if (bitsneeded==8) ASSERT(c==0);
		} else ASSERT(bits==6);
	}
	//(*dlen)=destpos;
 return dest;
}


#ifndef _DEBUG

//void * operator new(size_t,void * p) {
 //return p;
//}

//void operator delete(void * p,void *c) {
//}


#endif

void SetClipboardText(const char * s) {
 if (!OpenClipboard(NULL)) {
  MMsgbox("Unable to open Clipboard");
  return;
 }
 EmptyClipboard();
 HANDLE h=GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,strlen(s)+1);
 void * v=GlobalLock(h);
 memcpy(v,(const char *)s,strlen(s)+1);
 GlobalUnlock(h);
 if (SetClipboardData(CF_TEXT,h)==0) {
  DWORD d=::GetLastError();
  MMsgbox("Unable to open Set Clipboard Data");
  CloseClipboard();
  return;
 }
 CloseClipboard();
 GlobalFree(h);     
}

void GetClipboardText(SD & s) {
 if (!OpenClipboard(NULL)) {
  MMsgbox("Unable to open Clipboard");
  return;
 }
 HANDLE h=GetClipboardData(CF_TEXT);
	if (h==0) {
		MMsgbox("No Clipboard Data.");
  return;
 }
 s=(char *)GlobalLock(h);
 GlobalUnlock(h);
 CloseClipboard();     
}

BOOL sSetCaretPos(int X,int Y) {
 //static int c=0;
 //TRACE("Set X="+str(X)+",Y="+str(Y)+" "+str(++c)+"\n");
 //if (c>=109) ASSERT(X!=3);
 return SetCaretPos(X,Y);
}
