#ifndef GRID_INCLUDED
#define GRID_INCLUDED
#define GRIDB
#include "ctrls2.h"
#include "utils2.h"

#include "rt.h"
//#else
// #include "rengv6.h"
//#endif
//void selfcheck();
//bool bbmm(Grid * g);
//bool prasewhere(baserst * rst,char **s,SDArray &where,SDArray &wherec,SPtrArray &wherev,SByteArray &indexable,CWordArray &trueskip,CWordArray &falseskip,char * wheretype);
//char isinmem(char * main,char * sub,int lenmain,int lensub);
//void insertwhere(int y,int x,SDArray &where,SDArray &wherec,SPtrArray &wherev,SPtrArray &wnids,CWordArray &wlens,SByteArray &wbreak,bool * wc,SByteArray &indexable,CWordArray &trueskip,CWordArray &falseskip,SByteArray & islike);
class Gridcol {
public:
 unsigned char datatype;long datatype2; //used with load
 SD fontname,sumfunction;
	bool password,checkbox,button,locked,vertical;
 char type;
 double height;
	SD heading;
	SD mask;
	SD fieldname,sortfield;
	bool tristate,uppercase,tabstop,subtotal,groupable,hidden;
	SD linkedwith,softfield;
 int widthpixel;
	double width;
 Gridcol() {
  widthpixel=-1;
  sumfunction="SUM";
  tristate=false;
  password=false;
  checkbox=false;
  button=false;
  uppercase=true;
		height=1;
		//linkright=false;
		//softprint=false;
		vertical=false;
		locked=false;
		touched=false;
		subtotal=false;
		groupable=false;
		hidden=false;
		tabstop=true;
		width=10;
  type='t';
	}
	bool touched; //softhidden;
 void operator =(Gridcol & col) {
  tristate=col.tristate;
  password=col.password;
  fontname=col.fontname;
  checkbox=col.checkbox;
  button=col.button;
  uppercase=col.uppercase;
  fieldname=col.fieldname;
  sortfield=col.sortfield;
  groupable=col.groupable;
	 heading=col.heading;
	 subtotal=col.subtotal;
  sumfunction=col.sumfunction;
	 hidden=col.hidden;
	 linkedwith=col.linkedwith;
	 mask=col.mask;
	 width=col.width;
  softfield=col.softfield;
	 height=col.height;
	 vertical=col.vertical;
	 locked=col.locked;
	 tabstop=col.tabstop;
  touched=col.touched;
  type=col.type;
 }
};

class Gridcolgroup {
public:
	Gridcolgroup() {
		height=1;
		start=0;
	}
	SD heading;
	int start,height;
	int end;
};

class Grid;

/*class PROPForm:public Frame {
public:
 TempTable rt;
 TempTableRst rrt;
 void ask();
 static LRESULT CALLBACK ErecvProc(PROPForm * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack &st);
 PROPForm();
 ~PROPForm();
 SPtrArray ctrls;
 TBox2 heading,formula,sumfunction;
 CBox2 groupable,subtotal;
 bool ok;
};*/

class PROPForm2:public DDialog{
public:
 TempTable rt;
 TempTableRst rrt;
 void ask();
 TBox2 heading,formula;
 CBox2 groupable,subtotal;
 TBox2 sumfunction;
 TBox2 jname,datatype;
};

class sWorkbook;
class Grid:public ctrl {
private:
 
public:
 static bool ignoremousemove;
 int totrows;
 static bool disablepaint; //used internally by MMsgbox2
 COLORREF oldborderl;
 DED void changeprop(int pos);
 DED void sethilight(bool h);
 DED void Grid::setstate(unsigned char n);
 bool mousemove;
	bool dropdown,autohide,allowaddition,allowdelete,fixed,allowhiding,grandtotal;
 //unsigned char groupinglevel;
	GRIDCB gridcb; //,beforemove;
	void * gridcbval;
 //void * beforemoveval;
	DED ctrl * getctrl2(const char * heading);
	DED TBox * getctrl(const char * field,BYTE * pos=0);
 DED bool Hasfocus();
 DED void setfieldname(int pos,const char * fn);
 DED void swapforeground(SArray<ctrl*> & ctrls);
 //bool Grid::hasfilter();
 DED bool somethingchanged();
 DED int getstripheight();
 DED int gettotrows();
 DED void SetHeadlines(int n);
 void Grid::lload();
 void Grid::ssave();
 void Grid::lload(const char * fn,IDatabase * db=0);
 void Grid::ssave(const char * fn);
 DED int movedown();
 DED int moveup();
 DED int movepgup(bool first=false);
 DED int movepgdown(bool last=false);
 DED void colfix(baserst * rst);
 DED void SetLock(bool l);
 void Grid::_grp1();
 void Grid::invalidatectrls();
 bool quickescape;
 DED void setforeground(SArray<ctrl*> & ctrls,COLORREF o);
 DED void setbackground(SArray<ctrl*> & ctrls,COLORREF o,bool selected,long fr); //,COLORREF old);
 void Grid::ccopy();
 void Grid::ddel();
 DED void resetwidth();
 void Grid::deletee();
	SD where,distinct;
 unsigned long top,first;
 int headlines,lastcol;
 int Grid::getctrlpos(HWND h);
 DED void fillsub(bool actual);
 char lastfilterclick;
 bool hilight,fasthide,borderb;
 COLORREF background,cellbackground;
 bool popup;
	DED Grid();
 DED void DeleteColumns();
	DED ~Grid();
 bool totalhidden;
	DED int addcol(Gridcol & col,bool rearrange=true);
 DED void rearrange();
	SArray<Gridcol *> cols;
 DED void addcolgroup(Gridcolgroup & group);
	SArray<Gridcolgroup*> colgroups;
 void Grid::loadsub(SD sd,int row,sWorkbook & wb);
 void Grid::loadsub2(SD sd,int row,sWorkbook & wb,IDatabase * db);
	DED void addsubsort(const char * fn);
	DED void addsort(const char * field);
 DED void addsort2(const char * sql);
	DED void setgroupinglevel(unsigned char gl); 
	bool harddelete;
	DED void Create(HWND h);
	SDA newcols,newfns;
	SByteArray forprint;
 SDA sorts;
 char mode; //0=grid mode, 1=edit/ caret mode
 void Grid::setmode(char m);
	bool showgraph;
 bool sel;_int64 selstart,selend;
 int selcol;
 void Grid::ssave(sWorkbook & wb);
 void Grid::selset();
 DED void movecol(int from, int to);
 HWND lasthwnd;
 DED Gridcol * getcol2(const char * field,BYTE * pos);
	DED bool covered(Gridcol * gc,BYTE level);
	DED static Grid * Getref(HWND hwnd);
#ifdef GRIDB
	DED void setrst(bbaserst * rst); //,bool quick=false);
#else
 DED void setrst(baserst * rst); //,bool quick=false);
#endif
 DED void setrtfields(baserst* r);
 DED void stepp(char gl=-1,char statee=-1);
 TempTable * steprt;
 TempTableRst * steprrt;
 SDA custom;
	DED Gridcol * getcol(const char * s,BYTE * pos=0);
	unsigned char state;
	DED void applystate(); //bool quick=false);
	unsigned char tottabs;
 bool preferresort;
 SDA s; //contains the field names of all group levels
 signed long grps[6]; //contains the field count of all group levels
 unsigned char totgrps; //contains the total group levels
 bool _painting,finding;
 DWORD lastclicktime;void * lastclicklabel; //to avoid multiple left clicks in quick succession
	DED void hidecol(int pos,bool touch=false);
	DED void hidecol(const char * field,bool touch=false);
	DED void showcol(const char * field,bool touch=false);
 DED void setfieldname(char pos,const char * field);
	DED void setheading(const char * field,const char *heading);
	DED void swapcol(BYTE pos1,BYTE pos2);
	DED void swapcol(const char *f1,const char *f2);
	DED void showcol(BYTE pos,bool touch=false);
 DED void addctrl(Gridcol &gc);
 DED void Grid::toexcel(SD title);
	DED bool hideit(Gridcol * gc);
	SD lastsort;
	SArray<ctrl*> ctrls,ctrls2;
	SDA names;
	unsigned char tabsets,tabset;
 TBox3 hcol;
 TBox4 glevel;
 void ppaste(bool ask);
 char pasting;
 void Grid::ctrla();
 void pastesub(bool ask);
 TBox * Grid::getlastctrl(long * pos=0);
	Btn filterr,newcol,paste,load,save,step;
 CBox allowpaste;
	//void Setwidthint(int w);
	SDA where2;
	unsigned char groupinglevel;
	DED static SPtrArray ary;
 baserst *rst2;
#ifdef GRIDB
	bbaserst * rst;
#else
 baserst * rst;
#endif
 void Grid::clear();
 void Grid::loadsub3();
 void Grid::loadsub4();
 void lload(sWorkbook & wb,IDatabase * db=0);
 SArray<long> lfpos; //locked fposes
 SDA lfn; //locked fieldnames, pending conversion to lfpos
	SArray<long> subsort;
	SDWordArray softpos[10]; //maximum level of grouping .. can be increased
 SArray<TBox*> labels,glabels;
 int currentrow;
 void Refresh();
 DED void arrangelbls();
 DED int getlbltop();
 DED void savestate();
 DED void reststate();
 DED int getctrlpos(const char * field);
 DED void position(int top);
 DED void drawtext(int top);
 DED void fill(bool actual);
 DED void eofset(bbaserst * rr,bool selected);
 DED void Cleartextall();
 DED void Settextall(bool actual,bbaserst * rr);
 DED void setredline(bool t);
 DED void setfontbold(bool t);
 DED int getstriptop();
 SDA groupfields;
 //bool Grid::isingroup(SD & fn);
 DED void SetHeightLines(double d);
 DED bool Setfocus();
 DED bool Setfocus2();
 HCURSOR hcursor;
private:
	TBox filterbox;
 DED static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
 SPtrArray buttons;
	TempTable hcols;
	TempTableRst rhcols;
	SPtrArray rtables,rsts;
	SDWordArray grouped,grpcumm; //,softgrouped;
	DED static LRESULT CALLBACK ErecvProc(Grid* tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> &st);
 DED static LRESULT CALLBACK ErecvProc2(Grid* tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> &st);
};


//ISREADONLY MDI2Form::isr=0;
#endif
