#ifndef UTILS2_INCLUDED
#define UTILS2_INCLUDED

//#define MFC
#ifndef _MSC_VER
 typedef long long _int64;
 using namespace std;
#else
 #if _MSC_VER>1200
  #define VS2005
 #endif
#endif

#ifdef VS2005
 #pragma warning(disable:4996)
 //#define _CRT_SECURE_NO_DEPRECATE
 //#define stricmp(x) _stricmp(x)
#endif


#ifdef EXPP
 #define DED __declspec (dllexport)
 #define DED1 __declspec (dllexport) {
 #define DED2 }
#else
 #ifdef IMPP
  #define DED __declspec (dllimport)
  #define DED1 __declspec (dllimport) {
  #define DED2 }
 #else
  #define DED
  #define DED1
  #define DED2
 #endif
#endif
#ifdef WINE
 #include "wine.h"
#else
 #ifndef MFC
  #include <winsock2.h>
  //#include <windows.h>
  #define ASSERT assert //{if (!(x)) {MMsgbox("Assertion Failed: Line="+str(__LINE__)+", File name="+__FILE__);exit(0);}}
  #ifdef NDEBUG
   #define VERIFY(x) ((void)(x))
  #else
   #define VERIFY assert
  #endif
 #else
  #include <afxwin.h>
  #include <afxdisp.h>
  #include <winsock2.h>
 #endif

 #include <commdlg.h>
#endif

#include <assert.h>
#include <stdio.h>
#ifdef _MSC_VER
 #include <crtdbg.h>
#endif
#include <malloc.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>
#include <float.h>
#ifdef _MSC_VER
 #include "typeinfo.h"
#else
 #include <typeinfo>
#endif
//#define SDA StringDataArray
DED extern bool serverside;
extern unsigned long halloctimes;
class ctrl;
//#define CString StringData
//#define CStringArray StringDataArray //2<StringData>
#define SPtrArray SArray<void*>
#define SDWordArray SArray<unsigned long>
#define SByteArray SArray<unsigned char>
//typedef CString StringData;
int memicmp(const void *buf1, const void *buf2, unsigned int count );
DED int MMsgbox(const char * s,UINT type=MB_OK,const char * title=0);
bool GetFileInfo(const char * fn,_int64 * size,FILETIME *ftc,FILETIME *ftw,FILETIME *fta=0);
//#ifndef ASSERT
 //#define ASSERT assert //{if (!(x)) {MMsgbox("Assertion Failed: Line="+str(__LINE__)+", File name="+__FILE__);exit(0);}}
//#endif
#ifdef AASERT
 #undef ASSERT
 #define ASSERT(x) aasert(!(x),__LINE__,__FILE__) //do {if (!(x)) {MMsgbox("Assertion Failed: Line="+str(__LINE__)+SD(", File name=")+__FILE__);::DebugBreak();}} while (0);
 #undef VERIFY
 #define VERIFY ASSERT
//(void)((x) || sassert(__LINE__,__FILE__)) //
#endif
#define HALF_SECOND  (1.0/172800.0)
#define SHORT(x,y) ((short)(((y)*256)+(x)))
class baserst;
//#include "rdao.h"



#define SC_UP 72
#define SC_DOWN 80
#define SC_RIGHT 77
#define SC_LEFT 75
#define SC_7 71
#define SC_9 73
#define SC_1 79
#define SC_3 81
#define SC_5 76

#define VK_BACKSPACE 8
#define VK_1 49
#define VK_2 50
#define VK_3 51
#define VK_A 65
#define VK_B 66
#define VK_C 67
#define VK_D 68
#define VK_E 69
#define VK_F 70
#define VK_G 71
#define VK_H 72
#define VK_I 73
#define VK_J 74
#define VK_K 75
#define VK_L 76
#define VK_M 77
#define VK_N 78
#define VK_O 79
#define VK_P 80
#define VK_Q 81
#define VK_R 82
#define VK_S 83
#define VK_T 84
#define VK_U 85
#define VK_V 86
#define VK_W 87
#define VK_X 88
#define VK_Y 89
#define VK_Z 90
#define VK_RIGHTCLICK 93

#define VK_QUOTE 222
#define VK_F11  0x7A
#define VK_MINUS 189
#define VK_PLUS 187

DED void aasert(bool x,long line,const char * file);

class DED StringData {
private:
 void init();
public:
 unsigned char dt;
 union {
  char bval;
  short wval;
  long lval;
  double dval;
  float fval;
  _int64 llval;
 };
 char * buf;
 const void * sp; //actual pointer
 unsigned long actualsize;
 void StringData::Dump();
 void StringData::operator =(double d );
 void StringData::operator =(float d );
 void operator =(const StringData & sd );
 StringData asdatetime();
 StringData asdate();
 char aschar();
 short asshort();
 StringData & tostring();
 StringData & tofloat();
 long aslong();
 StringData & tolong();
 StringData & todatetime();
 StringData & todate();
 _int64 aslonglong();
 StringData & tolonglong();
 double asdouble();
 StringData & todouble();
 float asfloat();
 bool StringData::isdouble();
 bool StringData::islong();
 bool StringData::isstring();
 StringData asstring();
 StringData & asstring(StringData & sd);
 void StringData::SetDateTime(long y,long m,long d,long hour,long minute,long second);
 void StringData::SetDate(long y,long m,long d);
 long StringData::GetSecond();
 long StringData::GetMinute();
 long StringData::GetHour();
 void StringData::GetHMS(long *h,long * m,long * s);
 void StringData::GetYMD(long *y,long * m,long * d);
 StringData DateFormat(const char * format);
 long StringData::GetDayOfYear();
 long StringData::GetDayOfWeek();
 long StringData::GetDay();
 long StringData::GetYear();
 long StringData::GetMonth();
 void StringData::operator +=(const StringData & s);
 void StringData::operator +=(double d );
 void StringData::operator -=(double d );
 bool StringData::operator ==(StringData & sd);
 bool StringData::operator !=(StringData & sd);
 long operator () () {
  return actualsize;
 }
 void operator +=(const char * s);
 void operator =(long l);
 void operator =(_int64 l);
 void operator =(short l);
 void operator =(char l);
 void operator =(bool b);
 void operator =(const char * s);
 void operator =(unsigned short *s);

 char * GetBuffer(int x) {
  setsize(x+1);
  return buf;
 }

 void ReleaseBuffer(int x);

 void Empty() {
  actualsize=0;
 }

 StringData(SYSTEMTIME &st) {
  init();
  SetDateTime(st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
 }

 StringData(unsigned short *s) {
  init();
  (*this)=s;
 }
 StringData(bool b) {
  init();
  (*this)=b;
 }
 StringData(char c) {
  init();
  (*this)=c;
 }

 StringData(long l) {
  init();
  (*this)=l;
 }

 StringData(float f) {
  init();
  (*this)=f;
 }

 StringData(double d) {
  init();
  (*this)=d;
 }

 StringData(_int64 ll) {
  init();
  (*this)=ll;
 }

 StringData(StringData const & sd) {
  init();
  (*this)=(StringData &) sd;
 }

 StringData() {
  init();
 }
 StringData(const char *s) {
  init();
  *this=s;
 }
 StringData(unsigned char *s) {
  init();
  *this=(const char *)s;
 }
 char & operator [](int pos);
 void RemoveLast();
 char GetAt(int pos);
 char GetLast();
 void SetAt(int pos,char c);
 void destroy();

 ~StringData();

 StringData & TrimRight() {
  while (actualsize>0) {
   if (buf[actualsize-1]==' ' || buf[actualsize-1]==10 || buf[actualsize-1]==13) actualsize--;
   else break;
  }
  return *this;
 }

 StringData & AllTrim() {
  TrimLeft();
  TrimRight();
  return *this;
 }

 StringData & TrimLeft();
 void StringData::RemoveAt(int spos,int epos);

 StringData StringData::Mid(int pos,int len) const;
 StringData StringData::Mid(int pos) const;
 StringData StringData::Right(int count);
 StringData StringData::Left(int count);

 void setsize(unsigned int n,bool fast=false);

 StringData & MakeLower();
 StringData & MakeUpper();
 signed char cmp(StringData & sd);
 bool cmpeq(StringData & sd);
 void StringData::RemoveAt(int pos);
 void StringData::Delete(int pos);
 bool StringData::seq(StringData & sd);
 bool StringData::iseq(StringData & sd);
 signed char seq2(StringData & sd);
 signed char StringData::compare(StringData &sd);
 void StringData::Insert(int pos,const char * s);
 void StringData::Insert(int pos,char c);
 StringData & StringData::Remove(char c);

 /*int zzactualsize() {
  int top=0,bot=actualsize-1,mid;
  while (true) {
   if (bot<top) return top;
   mid=(top+bot)/2;
   if (buf[mid]==0) bot=mid-1;
   else top=mid+1;
  }
 }*/

 void zzactualsize() {
  int top=0,mid;actualsize--;
  while (true) {
   if ((signed)actualsize<top) {actualsize++;return;}
   mid=(top+actualsize)/2;
   if (buf[mid]==0) actualsize=mid-1;
   else top=mid+1;
  }
 }

 void fputs(const char *s);
 void addtobuf(void * bf,unsigned long n,bool fast=true);
 void addzerotobuf(unsigned long n);
// bool StringData::operator =(StringData & sd);
 bool StringData::operator >=(const char * s) {
  return Compare(s)<=0;
 }
 bool StringData::operator <=(const char * s) {
  return Compare(s)>=0;
 }
 bool StringData::operator >(const char * s) {
  return Compare(s)<0;
 }
 bool StringData::operator <(const char * s) {
  return Compare(s)>0;
 }

 bool StringData::operator ==(const char c) {
  return (actualsize==1 && buf[0]==c);
 }
 bool StringData::operator ==(const char * s) {
  return Compare(s)==0;
 }
 bool StringData::operator >=(StringData & sd);
 bool StringData::operator <=(StringData & sd);
 bool StringData::operator <(StringData & sd);
 bool StringData::operator >(StringData & sd);
 void StringData::free();
 inline int GetLength() {
  return actualsize;
 }
 int Compare(const char *s);
 int CompareNoCase(const char *s);

 //bool operator ==(const char *s) ;

 bool operator !=(const char *s) {
  return !((*this)==s);
 }

 char * putz() {
  //must not change the dt
  setsize(actualsize+1);
  actualsize--;
  buf[actualsize]=0;
  return buf;
 }

 //operator long();
 operator const char *() ;
 //operator char *();

 void operator +=(char c);



 signed int ReverseFind(char c) {
  //must not change dt
  for (int x=actualsize-1;x>=0;x--) {
   if (buf[x]==c) return x;
  }
  return -1;
 }

 signed int Find(const char * s,int start=0) const;
 signed int Find(char c,int start=0,int end=-1) const ;
 StringData & Replace(const char * oldstr,const char * newstr);
 StringData & Replace(char old,char nnew);
//private:
 unsigned long totsize;
};

typedef StringData SD;

#ifndef VS2005
DED StringData operator+(const char * lpsz, const StringData& sd);
#endif
DED StringData operator+(const StringData& sd,const char * lpsz);
DED StringData operator+(const StringData& sd,const StringData& sd2);
DED StringData operator+(StringData& sd,char c);
DED StringData operator+(char c, StringData& sd);

bool sassert(int line,const char * fn);
DED SD str(signed long n);
DED StringData iptostr(unsigned long ip);
DED unsigned long strtoip(StringData s);
DED extern int ScreenDPIX,ScreenDPIY;
struct FONT {
 int DPIX,DPIY;
 char name[32];
 bool bold;
 bool italic;
 bool underline;
 bool strikeout;
 //unsigned char size;
 double size;
 unsigned char width;
 LONG escapement;
 void operator =(FONT & f) {
  DPIX=f.DPIX;
  DPIY=f.DPIY;
  strcpy(name,f.name);
  bold=f.bold;
  italic=f.italic;
  underline=f.underline;
  strikeout=f.strikeout;
  size=f.size;
  width=f.width;
  escapement=f.escapement;
 }
 bool operator ==(FONT & f) {
  if (DPIX!=f.DPIX) return false;
  if (DPIY!=f.DPIY) return false;
  if (stricmp(name,f.name)!=0) return false;
  if (bold!=f.bold) return false;
  if (italic!=f.italic) return false;
  if (underline!=f.underline) return false;
  if (strikeout!=f.strikeout) return false;
  if (size!=f.size) return false;
  if (width!=f.width) return false;
  if (escapement!=f.escapement) return false;
  return true;
 }
 DED FONT() {
  DPIX=::ScreenDPIX;
  DPIY=::ScreenDPIY;
  escapement=0;
  strikeout=false;
  bold=false;
  italic=false;
  underline=false;
  size=8;
  width=0;
  ASSERT(true);
  ASSERT(sizeof(name)==32);
  memset(name,0,sizeof(name));
  strcpy(name,"Arial");
 }
};

DED SD hstr(signed long n);
DED unsigned long getmaxram();
DED void tthrow2(const char *s,bool quiet=false);
DED void tthrow(const char *s,bool quiet=false);
DED void vfree(void * buf);
DED void sfree(void * buf);
DED void * vrealloc(void * buf,DWORD size,DWORD oldsize);
DED void vreset(void * buf,DWORD size);
DED void * vvalloc(DWORD size);
DED void * salloc(DWORD size);
DED void * halloc(DWORD size);
DED void * hrealloc(void * buf,DWORD size);
DED void * halloc2(DWORD size);
DED void * hrealloc2(void * buf,DWORD size);
DED void hfree(void * buf);
DED void hfree2(void * buf);
DED HFONT zEzCreateFont(HDC hdc,char * FaceName,int PtHeight,int PtWidth=0,bool bold=false,bool italic=false,bool underline=false,bool strikeout=false,bool fLogRes=true);
DED void SetWindowtlbh(HWND hwnd, RECT * rc);
DED void GetWindowtlbh(HWND hwnd, RECT * rc);

//DED StringData century(SD d);
DED void Setwidth(HWND hwnd,int n);
DED void Setheight(HWND hwnd,int n);
DED int Getwidth(HWND hwnd);
DED int Getheight(HWND hwnd);
DED void getmessage();
DED double getdt(long y,long m,long d);
DED HBITMAP CaptureScreen(HWND hwnd,int t, int l, int width, int height);
DED bool toip(const char * name,unsigned char * ip);
DED void PaintBitmap(HWND hwnd, HBITMAP hbitmap,int t, int l);
DED void Hidewindow(HWND hwnd);
DED void Settop(HWND hwnd,int n);
DED void Showwindow(HWND hwnd);
DED void Invalidatewindow(HWND hwnd);
DED void Setleft(HWND hwnd,int n);
DED bool Isvisible(HWND hwnd);
DED void MD5Hash(const char * buf,long size,unsigned char * hash);
DED void MD5Hash(SD & in,SD & hash);
DED void AESEncrypt(SD & in,SD & out,SD & pwd);
DED void AESDecrypt(SD & in,SD & out,SD & pwd);
DED SD getservername(SD path);
DED SD getqpath(SD path);
DED SD GetComputerName();
DED int Gettop(HWND hwnd);
DED int Getleft(HWND hwnd);
DED void Validatewindow(HWND hwnd);
DED int Getclientwidth(HWND hwnd);
DED void Getclienttlbh(HWND hwnd, RECT * rc);
DED void InvalidateChildwindows(HWND hwnd);
BOOL sSetCaretPos(int X,int Y);
DED COLORREF GetBrushColor(HBRUSH hbrush);
DED DWORD Getmodulesize(HMODULE handle);

DED bool AskForClose();
DED bool AskForRename();
DED void Setbottom(HWND hwnd,int n);
DED void Maskset(SD * mask,SD * s);
DED int Bside(HWND hwnd);
DED bool isneumerictype(SHORT type);
DED SD datestr(int d,int m,int y);
DED SD GetFieldstr(const char * f,baserst * r);
DED bool DrainMessages();
DED StringData replicate(const char *s,int nod);
DED int Textheight(HDC hdc,const char * s);
DED int CurrentY(HDC hdc);
DED int CurrentX(HDC hdc);
//DED SD strw(_int64 n);
DED SD dstr(double n,int nod);
DED double round(double d,char nod);
DED double roundt(double d,double tens);
_int64 roundl(double d);
_int64 gethash(char * buf,long n);//alternative to MD5 hash
DED int Verticalprint(HDC hdc,SD s,int width,int height,bool center=true,bool calculate=false);
DED int Boxprint(HDC hdc,SD s,int width,bool calculate=false,char lines=0,bool center=true);
DED SD cut(HDC hdc,SD *s,int width,bool spacecut);
DED double roundh(double d,char nod);
DED int Textwidth(HDC hdc,const char * s);

template<class T> void swap(T & a,T & b) {
 T c;
 c=a;
 a=b;
 b=c;
}

inline void toggle(bool & b) {
 if (b) b=false;
 else b=true;
}

template<class T> bool isin(T & item,T & start, T & end) {
 if (item>=start && item<=end) return true;
 if (item>=end && item<=start) return true;
 return false;
}

template<class T> bool isin2(T item,T start, T end) {
 if (item>=start && item<=end) return true;
 if (item>=end && item<=start) return true;
 return false;
}

DED bool isdate(SD d,bool nullvalid=false);
DED SD ltrim(SD s);
DED long todate(const char * c,int len);
DED SD Maskfix(SD s);
SD & str(signed long n,SD & sd);
DED long strtodate(SD &s);
DED double strtodatetime(SD & s);

DED double Age(SD dob,SD date);
DED bool IsLeapYear(long year);
DED int YearDays(long year);
DED bool AskForSeeries();
class bbaserst;
DED SD Maskset(SD mask,SD s);
DED void seteof(bbaserst * r);
DED int Rside(HWND hwnd);
DED int Lside(HWND hwnd);


class baserst;
class MDIForm;

//DED SD ADate(SD d);
DED void MoveChildren(HWND hwndparent,int m);
DED int Tside2(HWND hwnd,HWND parent);
DED int Bside2(HWND hwnd,HWND parent);
DED SD getday(SD & d);
DED bool AskForDelete();
DED SD dttostr(unsigned char dt);
bool isvaliddt(unsigned char dt);
unsigned char strtodt(SD & sd);
//void deleteclear(DaoRecordset * rst);
DED SD upper(const char * s);
DED void deleteclear(baserst * rst);
DED bool scmp(SD * s1,SD * s2,bool reset=false);
DED int Lside2(HWND hwnd,HWND parent);
DED int Rside2(HWND hwnd,HWND parent);
DED bool isinbetween(int n,int a,int b);
DED bool Iswindowmaximized(HWND hwnd);
DED SD Getpath(const char*fn=0,bool full=false);
DED SD lstr(_int64 n);
DED SD getmonth(unsigned char mm);
DED SD Getpath2(const char * fn);
DED int getdiff(int sy,int sm,int ey,int em);
DED void delay(WORD milliseconds);

DED void setbof(bbaserst * r);
DED int countinstances95();
DED HINSTANCE gethinst();

DED void CenterScreen(HWND hwnd);
//int safeconnect(SOCKET s,PSOCKADDR sa,int z);
//HOSTENT * safegethostbyname(const char * name);
DED void selfcheck();


DED void focusblink();
DED SD readfiletext(const char * fn);
DED void disablethreadwindows();
DED void enablethreadwindows();

DED void Maximizewindow(HWND hwnd);
DED bool bmptojpeg(HBITMAP hbmp,const char * filename);
DED bool bmptojpeg(FILE * outfile,unsigned char * buf,int width,int height,int rowsize,bool mono,RGBQUAD * ctable,ULONG numentries);
DED bool setfiletime(SD fn,FILETIME * ftcreate,FILETIME * ftaccess,FILETIME * ftwrite);
DED bool getfiletime(SD fn,FILETIME * ftcreate,FILETIME * ftaccess,FILETIME * ftwrite);
DED void * readfile(SD fn,DWORD & n);
DED bool writefile(SD fn,void * buf,DWORD  n);
DED SD getprintername();
DED bool isprinterok(HANDLE h,bool & default98);

//DED _int64 getmac();
DED void Validatetree(HWND hwnd);
DED void vASSERT(bool b);
DED void tcpnodelay(SOCKET soc);
DED void flash(const char * s,HWND hwnd=0);
DED signed char MMsgbox2(const char * s,int seconds=10,const char * buttons[]=0,int n=0);
DED SD wctomb(void * a);
DED void readFile(HANDLE h,void * buf,DWORD size);
DED MDIForm *Getactivateform();
DED SD century(SD d);
DED SD gettempfilename(const char * path=0);
DED SD gettempfilename2(SD ext);

class DED SMS2 {
public:
	WSAEVENT hevent;
 WSAOVERLAPPED overlapped;
 long recvpacket(void * buf,long maxbytes,SOCKET sc,DWORD timeout);
 void recvbytes(char * buf,int n,SOCKET sc,DWORD timeout=25);
 void sendbytes(char * buf,long n,SOCKET soc);
 bool sendsms(SD phone,SD text,SD servername);
};
//---------------------------Stack starts------------------------------
template <class C> class DED Stack {
private:
 C * buf;
 int n,max;
 void init() {
  errorstr=0;
  buf=0; //(C *)halloc(10); //0;
		growby=2; //elements
		startwith=1; //elements
		n=0;
 }
public:
 char * errorstr;
	int growby,startwith;

 Stack(Stack<C> & s) {
  init();
  *this=s;
	}
	Stack(){
  init();
	}

	~Stack() {
  if (errorstr && n!=0) MMsgbox(errorstr);
		if (buf) hfree2(buf);
	}

 void RemoveAt(int pos) {
		ASSERT(pos>=0 && pos<n);
  n--;
  memmove(buf+pos,buf+pos+1,(n-pos)*sizeof(C));
	}

	inline void Add(C ele) {
  InsertAt(n,ele);
  //push(ele);
 }

 void InsertAt(int pos,C ele) {
  if (buf==0) {
			ASSERT(startwith>0);
			buf=(C*)halloc2(startwith*sizeof(C));
			if (buf==0) tthrow("No Memory");
			max=startwith;
			ASSERT(n==0);
		}
		ASSERT(n<=max);
  if (n==max) {
			ASSERT(growby>0);
			//int oldmax=max;
			max+=growby;growby*=2;
   buf=(C*)hrealloc2(buf,max*sizeof(C)); //,oldmax*sizeof(C));
			if (buf==0) tthrow("No Memory");
		}
		ASSERT(n<max);
  ASSERT(n>=0);
  memmove(buf+((pos+1)),buf+(pos),(n-pos)*sizeof(C));
  buf[pos]=ele;
  n++;
 }

 inline int operator()() {
  return GetSize();
 }

	inline void push(C ele) {
  InsertAt(n,ele);
 }

 void operator += (long r) {
  for (int x=0;x<GetSize();x++) {
   GetAt2(x)+=r;
  }
 }

	inline int GetSize() {
		return n;
	}
 signed long Find(C ele) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x)==ele) return x;
  }
  return -1;
 }
	void RemoveAll() {
		//if (buf) vreset(buf,max*8);
		n=0;
	}

	C GetAt(int pos) {
		ASSERT(pos>=0 && pos<n);
  return buf[pos];
	}

 C pop() {
  ASSERT(n>0);
  n--;
  return buf[n];
	}

 C & GetAt2(int pos) {
		ASSERT(pos>=0 && pos<n);
  return buf[pos];
	}

 void SetAt(int pos,C ele) {
		ASSERT(pos>=0 && pos<n);
  buf[pos]=ele;
	}

 /*void SetAtGrow(int pos,C ele) {
  ASSERT(pos>=0);
  while (pos>=n) {
   Add(C());
  }
  SetAt(pos,ele);
 }*/

 /*void RemoveAt(int pos) {
		ASSERT(pos>=0 && pos<n);
		remove2(pos+top);
 }*/

 C GetLast() {
  return GetAt(GetSize()-1);
	}

 inline C & operator [] (long pos) {
  return GetAt2(pos);
 }

 void operator =(Stack<C> & s) {
  RemoveAll();
  for (int x=0;x<s.GetSize();x++) {
   Add(s.GetAt(x));
  }
 }
};

//---------------------------SArray starts------------------------------
template <class C> class DED SArray {
private:
 C * buf;
 int n,top,bot,max;

 void insert2(C ele,int pos) {
  ASSERT(top>=0 && top<=bot);
  ASSERT(bot>=top && bot<max);
  ASSERT(pos>=top && pos<=bot+1);
  ASSERT(bot-top+1==n);
  ASSERT(n<max);
  if (pos-top<bot-pos+1) { //left side
   if (top==0) { //make space
    int diff=max-bot;
    ASSERT(diff>=2);
    diff/=2;
    memmove(buf+diff,buf,n*sizeof(C));
    pos+=diff;
    top+=diff;
    bot+=diff;
   }
   ASSERT(top>0);
   memmove(buf+((top-1)),buf+(top),(pos-top)*sizeof(C));
   buf[pos-1]=ele;
   top--;
  } else {
   if (bot==max-1) { //make space
    int diff=top+1;
    ASSERT(diff>=2);
    diff/=2;
    memmove(buf+((top-diff)),buf+(top),n*sizeof(C));
    pos-=diff;
    top-=diff;
    bot-=diff;
   }
   ASSERT(bot<max-1);
   memmove(buf+((pos+1)),buf+(pos),(bot-pos+1)*sizeof(C));
   buf[pos]=ele;
		 bot++;
	 }
	 n++;
	}

	void remove2(int pos) {
  ASSERT(top>=0 && top<=bot);
	 ASSERT(bot>=top && bot<max);
	 ASSERT(pos>=top && pos<=bot);
	 ASSERT(bot-top+1==n);
	 ASSERT(n<=max && n>0);
	 if (pos-top<bot-pos) { //left side
   memmove(buf+top+1,buf+top,(pos-top)*sizeof(C));
			top++;
		} else {
			memmove(buf+pos,buf+pos+1,(bot-pos)*sizeof(C));
			bot--;
		}
		n--;
	}
 void init() {
  errorstr=0;
  buf=0; //(C *)halloc(10); //0;
		growby=2; //elements
		startwith=1; //elements
		n=0;
 }

 SArray(SArray<C> & s) {
  init();
  *this=s;
	}

public:
 char * errorstr;
	int growby,startwith;


	SArray(){
  init();
	}

	~SArray() {
  if (errorstr && n!=0) MMsgbox(errorstr);
		if (buf) hfree2(buf);
	}

	void InsertAt(int pos,C ele) {
		if (buf==0) {
			ASSERT(startwith>0);
			buf=(C*)halloc2(startwith*sizeof(C));
			if (buf==0) tthrow("No Memory");
			max=startwith;
			ASSERT(n==0);
		}
		ASSERT(n<=max);
  if (n==max) {
			ASSERT(growby>0);
			int oldmax=max;
			max+=growby;growby*=2;
   buf=(C*)hrealloc2(buf,max*sizeof(C)); //,oldmax*sizeof(C));
			if (buf==0) tthrow("No Memory");
		}
		ASSERT(n<max);
		if (n==0) {
			top=max/2;
			bot=top;
			buf[top]=ele;
			n=1;
			return;
		}
		ASSERT(pos>=0 && pos<=n);
		ASSERT(n==bot-top+1);
  insert2(ele,pos+top);
	}

 void operator += (SArray<C> & a) {
  for (int x=0;x<a.GetSize();x++) {
   Add(a[x]);
  }
 }

 void operator += (long r) {
  for (int x=0;x<GetSize();x++) {
   GetAt2(x)+=r;
  }
 }
	inline void Add(C ele) {
		InsertAt(n,ele);
	}
	inline int GetSize() {
		return n;
	}
 signed long Find(C ele) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x)==ele) return x;
  }
  return -1;
 }
	void RemoveAll() {
		//if (buf) vreset(buf,max*8);
		n=0;
	}

 inline C GetAt3(int pos) {
		if (pos>=0 && pos<n) return buf[pos+top];
  return 0;
	}

	inline C GetAt(int pos) {
		ASSERT(pos>=0 && pos<n);
  return buf[pos+top];
	}

 C & GetAt2(int pos) {
		ASSERT(pos>=0 && pos<n);
  return buf[pos+top];
	}

 void SetAt(int pos,C ele) {
		ASSERT(pos>=0 && pos<n);
  buf[pos+top]=ele;
	}

 void SetAtGrow(int pos,C ele) {
  ASSERT(pos>=0);
  while (pos>=n) {
   Add(C());
  }
  SetAt(pos,ele);
 }

 C RemoveLast() {
  //C & c=GetLast2();
  //RemoveAt(n-1); //will not result in any memmove
  ASSERT(n>0);
  n--;
  bot--;
  return buf[n+top];
		//return c;
	}

 C RemoveFirst() {
  ASSERT(n>0);
  n--;
  top++; //bot--;
  return buf[top-1];

  //C & c=GetAt2(0);
  //RemoveAt(0); //will not result in any memmove
		//return c;
	}

 C & RemoveLast2() {
  ASSERT(n>0);
  n--;
  bot--;
  return buf[n+top];

  //C & c=GetLast2();
  //RemoveAt(n-1); //will not result in any memmove
		//return c;
	}

 C & RemoveFirst2() {
  ASSERT(n>0);
  n--;
  top++; //bot--;
  return buf[top-1];

  //C & c=GetAt2(0);
  //RemoveAt(0); //will not result in any memmove
		//return c;
	}

 C Remove(int pos) {
  C c=GetAt2(pos);
		ASSERT(pos>=0 && pos<n);
		remove2(pos+top);
  return c;
 }

 void RemoveAt(int pos) {
		ASSERT(pos>=0 && pos<n);
		remove2(pos+top);
 }

 //void RemoveLast() {
  //RemoveAt(GetSize()-1);
 //}

 C GetLast() {
  return GetAt(GetSize()-1);
	}

 C & GetLast2() {
  return GetAt2(GetSize()-1);
	}

 inline int operator()() {
  return GetSize();
 }

 inline C & operator [] (long pos) {
  return GetAt2(pos);
 }

 void operator =(SArray<C> & s) {
  RemoveAll();
  for (int x=0;x<s.GetSize();x++) {
   Add(s.GetAt(x));
  }
 }
};

#ifdef _MSC_VER
 #ifndef _DEBUG
  inline void * operator new(size_t,void * p) {
   return p;
  }
 #else
  void * operator new(size_t,void * p);
 #endif
 void operator delete(void * p,void *c);
#else
 inline void * operator new(size_t,void * p) {
  return p;
 }
#endif
//---------------------------SArrayzz ------------------------------
template <class C> class DED SArrayzz {
private:
 C * buf;
	int n,top,bot,max;
	void insert2(const C &ele,int pos) {
  ASSERT(top>=0 && top<=bot);
	 ASSERT(bot>=top && bot<max);
	 ASSERT(pos>=top && pos<=bot+1);
	 ASSERT(bot-top+1==n);
	 ASSERT(n<max);
	 if (pos-top<bot-pos+1) { //left side
		 if (top==0) { //make space
    int diff=max-bot;
		  ASSERT(diff>=2);
		  diff/=2;
    memmove(buf+diff,buf,n*sizeof(C));
    pos+=diff;
		  top+=diff;
		  bot+=diff;
		 }
		 ASSERT(top>0);
   memmove(buf+((top-1)),buf+(top),(pos-top)*sizeof(C));
   new (buf+pos-1) C;
   //buf[pos-1].init();
		 buf[pos-1]=ele;
		 top--;
	 } else {
   if (bot==max-1) { //make space
    int diff=top+1;
		  ASSERT(diff>=2);
		  diff/=2;
    memmove(buf+((top-diff)),buf+(top),n*sizeof(C));
    pos-=diff;
		  top-=diff;
		  bot-=diff;
		 }
	  ASSERT(bot<max-1);
   memmove(buf+((pos+1)),buf+(pos),(bot-pos+1)*sizeof(C));
   new (buf+pos) C;
   //buf[pos].init();
	  buf[pos]=ele;
		 bot++;
	 }
	 n++;
	}

	void remove2(int pos) {
  ASSERT(top>=0 && top<=bot);
	 ASSERT(bot>=top && bot<max);
	 ASSERT(pos>=top && pos<=bot);
	 ASSERT(bot-top+1==n);
	 ASSERT(n<=max && n>0);
	 if (pos-top<bot-pos) { //left side
   memmove(buf+top+1,buf+top,(pos-top)*sizeof(C));
			top++;
		} else {
			memmove(buf+pos,buf+pos+1,(bot-pos)*sizeof(C));
			bot--;
		}
		n--;
	}
 void init() {
  buf=0;
		startwith=1; //elements
		n=0;
 }
public:
	int startwith;

	SArrayzz(){
		init();
	}
 SArrayzz(SArrayzz<C> & s) {
  init();
  *this=s;
	}
	~SArrayzz() {
  RemoveAll();
		if (buf) hfree2(buf);
	}
 inline int operator()() {
  return GetSize();
 }
 inline C & operator [] (long pos) {
  return GetAt(pos);
 }
	void InsertAt(int pos,const C & ele) {
		if (buf==0) {
			ASSERT(startwith>0);
			buf=(C*)halloc2(startwith*sizeof(C));
			if (buf==0) tthrow("No Memory");
			max=startwith;
			ASSERT(n==0);
		}
		ASSERT(n<=max);
  if (n==max) {
			//ASSERT(growby>0);
			int oldmax=max;
   max*=2;
			//max+=growby;growby*=2;
   buf=(C*)hrealloc2(buf,max*sizeof(C)); //,oldmax*sizeof(C));
			if (buf==0) tthrow("No Memory");
		}
		ASSERT(n<max);
		if (n==0) {
			top=max/2;
			bot=top;
   new (buf+top) C;
   //buf[top].init();
			buf[top]=ele;
			n=1;
			return;
		}
		ASSERT(pos>=0 && pos<=n);
		ASSERT(n==bot-top+1);
  insert2(ele,pos+top);
	}

 /*void operator =(SArray<C> &s) {
  RemoveAll();
  for (int x=0;x<s.GetSize();x++) {
   Add(s.GetAt(x));
  }
 }*/

 inline void Add(const C & ele) {
		InsertAt(n,ele);
	}
	inline void Add(C *ele) {
		InsertAt(n,*ele);
	}
	inline int GetSize() {
		return n;
	}
	void RemoveAll() {
  for (int x=0;x<n;x++) {
   buf[top+x].~C();
   //C *c=&buf[top+x];
   //c->~C();
   //~buf[top+x]() ;//.destroy();
  }
		//--if (buf) vreset(buf,max*8);
		n=0;
	}

	C & GetAt(int pos) { //MLock operator = , swaps, therefore reference cannot be returned
		ASSERT(pos>=0 && pos<n);
  return buf[pos+top];
	}

 void SetAtGrow(int pos,const C & ele) {
  ASSERT(pos>=0);
  while (pos>=n) {
   Add(C());
  }
  SetAt(pos,ele);
 }

 C & GetLast() {
  return GetAt(GetSize()-1);
	}

 void SetAt(int pos,const C & ele) {
  ASSERT(pos>=0 && pos<n);
  buf[pos+top]=(C &)ele;
 }

 void SetAt(int pos,C *ele) {
		ASSERT(pos>=0 && pos<n);
  buf[pos+top]=(*ele);
	}

 void operator =(SArrayzz<C> & s) {
  RemoveAll();
  for (int x=0;x<s.GetSize();x++) {
   Add(s.GetAt(x));
  }
 }

 void RemoveAt(int pos) {
		ASSERT(pos>=0 && pos<n);
  buf[pos+top].~C();
  //C *c=&buf[pos+top];
  //c->~C();
  //buf[pos+top].destroy();
		remove2(pos+top);
 }

 void RemoveLast() {
  RemoveAt(GetSize()-1);
 }
};

//---------------------------SArray2 ------------------------------

template <class C> class DED SArray2 {
public:
 SArray<C *> pa;
	SArray2(){

	}
 SArray2(SArray2<C> & s) {
  //init();
  *this=s;
	}
	~SArray2() {
  RemoveAll();
		//if (buf) hfree(buf);
	}
 inline int operator()() {
  return GetSize();
 }

	inline C & operator[](long pos) {
  //return *pa.GetAt(pos);
  return GetAt(pos);
 }
	C & InsertAt(int pos,const C & ele) {
  C * c=new C;
  *c=(C &)ele;
  pa.InsertAt(pos,c);
  return *c;
 }


 inline C & Add(const C & ele) {
	 return InsertAt(pa.GetSize(),ele);
 }
	//inline void Add(C *ele) {
		//InsertAt(n,*ele);
	//}
	inline int GetSize() {
		return pa.GetSize();
	}

	void RemoveAll() {
  while (pa.GetSize()!=0) {
   RemoveAt(0);
  }
	}

 C & GetLast() {
  return GetAt(GetSize()-1);
	}

	C & GetAt(int pos) {
  return *pa.GetAt(pos);
	}

 void SetAtGrow(int pos,C & ele) {
  ASSERT(pos>=0);
  while (pos>=pa.GetSize()) {
   Add(C());
  }
  SetAt(pos,ele);
 }

 void SetAt(int pos,C & ele) {
  GetAt(pos)=ele;
  //ASSERT(pos>=0 && pos<n);
  //buf[pos+top]=ele;
 }

 //void SetAt(int pos,C *ele) {
		//ASSERT(pos>=0 && pos<n);
  //buf[pos+top]=(*ele);
	//}

 void operator =(SArray2<C> & s) {
  RemoveAll();
  for (int x=0;x<s.GetSize();x++) {
   Add(s.GetAt(x));
  }
 }

 void RemoveAt(int pos) {
  C * c=pa.GetAt(pos);
  delete c;
  pa.RemoveAt(pos);
 }
 
 void RemoveLast() {
  RemoveAt(GetSize()-1);
 }
};

template <class C> class DED SArray3:public SArray2<C> {
 signed int Find(C & ele) {
  int x;
  for (x=0;x<SArray2<C>::GetSize();x++) {
   if (ele==SArray2<C>::GetAt(x)) return x;
  }
  return -1;
 }
};


class StringDataArray :public SArrayzz<StringData> {
 public:
 DED int Find(StringData & sd) {
  for (int x=0;x<GetSize();x++) {
   if (GetAt(x)==sd) return x;
  }
  return -1;
 }
 DED void Add2(StringData sd) {
  SArrayzz<StringData>::Add(sd);
 }
 DED void InsertAt2(int pos,StringData sd) {
  SArrayzz<StringData>::InsertAt(pos,sd);
 }
 DED void SetAt2(int pos,StringData sd) {
  SArrayzz<StringData>::SetAt(pos,sd);
 }
};

typedef StringDataArray SDA;

DED void cmdline(SDA & a);

template<class ARY,class ELE> signed int Seek2(ARY & a,ELE & e) {
 //ary must be sorted. *a, derefrence
//returns the 0 based position at which the element is found, -1 if not found
 signed int top=0;
 signed int bot=a.GetSize()-1;
 if (bot==-1) return -1;
 signed int mid;
 while (true) {
  mid=(top+bot)/2;
  if (bot<top) {
   if (top>=a.GetSize()) return -1;
   if ((*a.GetAt(top))==e) return top;
   return -1;
  }
  if ((*a.GetAt(mid))<e) top=mid+1;
  else bot=mid-1;
 }
}

template<class ARY,class ELE> signed int Seek(ARY & a,ELE & e) {
 //ary must be sorted
//returns the 0 based position at which the element is found, -1 if not found
 signed int top=0;
 signed int bot=a.GetSize()-1;
 if (bot==-1) return -1;
 signed int mid;
 while (true) {
  mid=(top+bot)/2;
  if (bot<top) {
   if (top>=a.GetSize()) return -1;
   if (a.GetAt(top)==e) return top;
   return -1;
  }
  if (a.GetAt(mid)<e) top=mid+1;
  else bot=mid-1;
 }
}

template<class ARY,class ELE> int SortedAdd(ARY & a,ELE & e) {
 //ary must be sorted
 //returns the position at which the new element is inserted
 signed int top=0;
 signed int bot=a.GetSize()-1;
 signed int mid; //=(top+bot)/2;
 while (true) {
  mid=(top+bot)/2;
  if (bot<top) {
   a.InsertAt(top,e);
   return top;
  }
  if (e>=a.GetAt(mid)) top=mid+1;
  else bot=mid-1;
 }
}

/*class SPtrArray {
private:
 void ** buf;
	int n,top,bot,max;
	DED void insert2(void * ele,int pos) {
  ASSERT(top>=0 && top<=bot);
	 ASSERT(bot>=top && bot<max);
	 ASSERT(pos>=top && pos<=bot+1);
	 ASSERT(bot-top+1==n);
	 ASSERT(n<max);
	 if (pos-top<bot-pos+1) { //left side
		 if (top==0) { //make space
    int diff=max-bot;
		  ASSERT(diff>=2);
		  diff/=2;
    memmove(buf+diff,buf,n*4);
    pos+=diff;
		  top+=diff;
		  bot+=diff;
		 }
		 ASSERT(top>0);
   memmove(buf+((top-1)),buf+(top),(pos-top)*4);
		 buf[pos-1]=ele;
		 top--;
	 } else {
   if (bot==max-1) { //make space
    int diff=top+1;
		  ASSERT(diff>=2);
		  diff/=2;
    memmove(buf+((top-diff)),buf+(top),n*4);
    pos-=diff;
		  top-=diff;
		  bot-=diff;
		 }
	  ASSERT(bot<max-1);
   memmove(buf+((pos+1)),buf+(pos),(bot-pos+1)*4);
	  buf[pos]=ele;
		 bot++;
	 }
	 n++;
	}

	DED void remove2(int pos) {
  ASSERT(top>=0 && top<=bot);
	 ASSERT(bot>=top && bot<max);
	 ASSERT(pos>=top && pos<=bot);
	 ASSERT(bot-top+1==n);
	 ASSERT(n<=max && n>0);
	 if (pos-top<bot-pos) { //left side
   memmove(buf+top+1,buf+top,(pos-top)*4);
			top++;
		} else {
			memmove(buf+pos,buf+pos+1,(bot-pos)*4);
			bot--;
		}
		n--;
	}
public:
	int growby,startwith;
	DED SPtrArray(){
		buf=0;
		growby=1000; //elements
		startwith=1000; //elements
		n=0;
	}
	DED ~SPtrArray() {
		if (buf) vfree(buf);
	}

	DED void InsertAt(int pos,void * ele) {
		if (buf==0) {
			ASSERT(startwith>0);
			buf=(void **)valloc(startwith*4);
			if (buf==0) tthrow("No Memory");
			max=startwith;
			ASSERT(n==0);
		}
		ASSERT(n<=max);
  if (n==max) {
			ASSERT(growby>0);
			int oldmax=max;
			max+=growby;growby*=2;
   buf=(void **)vrealloc(buf,max*4,oldmax*4);
			if (buf==0) tthrow("No Memory");
		}
		ASSERT(n<max);
		if (n==0) {
			top=max/2;
			bot=top;
			buf[top]=ele;
			n=1;
			return;
		}
		ASSERT(pos>=0 && pos<=n);
		ASSERT(n==bot-top+1);
  insert2(ele,pos+top);
	}
	DED inline void Add(void * ele) {
		InsertAt(n,ele);
	}
	DED inline int GetSize() {
		return n;
	}
	DED void RemoveAll() {
		if (buf) vreset(buf,max*4);
		n=0;
	}

	DED void * GetAt(int pos) {
		ASSERT(pos>=0 && pos<n);
  return buf[pos+top];
	}

 DED void RemoveAt(int pos) {
		ASSERT(pos>=0 && pos<n);
		remove2(pos+top);
 }
};*/

/*class Stack {
private:
 void ** buf;
	int n,max;

public:
	int growby,startwith;
	DED Stack(){
		buf=0;
		growby=10; //elements
		max=0;
		//startwith=1000; //elements
		n=0;
	}
	DED ~Stack() {
		if (buf) hfree(buf);
	}

	DED void push(void * ele) {
		ASSERT(n<=max);
  if (n==max) {
			ASSERT(growby>0);
			max+=growby;growby*=2;
   buf=(void **)hrealloc(buf,max*4);
			if (buf==0) tthrow("No Memory");
		}
		buf[n]=ele;
		n++;
 }


	DED inline int GetSize() {
		return n;
	}
	DED void RemoveAll() {
		//if (buf) vreset(buf,max*4);
		n=0;
	}

	DED void SetAt(int i,void * a) {
  ASSERT(i<n);
  buf[i]=a;
	}

	DED void * GetAt(int i) {
  ASSERT(i<n);
  return buf[i];
	}

	DED void * pop() {
		ASSERT(n>0);
		n--;
  return buf[n];
	}

};*/

class Hptimer {
	DED static LARGE_INTEGER fq;
	LARGE_INTEGER i1,i2;
public:
	DED void reset() {
		VERIFY(QueryPerformanceCounter(&i1));
	}
	DED double gettime(bool rreset=false) {
		VERIFY(QueryPerformanceCounter(&i2));
		double d=((i2.QuadPart-i1.QuadPart)/(double)fq.QuadPart);
		if (rreset) reset();
		return d;
	}
 DED void report();
 DED void trace();
 SD ts;
	DED Hptimer() {
  VERIFY(QueryPerformanceFrequency(&fq));
  VERIFY(QueryPerformanceCounter(&i1));
	}
	//VERIFY(QueryPerformanceFrequency(&fq));
};

class CDate {
public:
	long date;
 DED void SetDate(long y,long m,long d);
 DED static void Gettime(struct tm& tmDest,double date);
	DED static void Gettm(struct tm& tmDest,long date);
	DED static long GetDay(long date);
	DED static long GetMonth(long date);
	DED static long GetYear(long date);
 DED static void GetYMD(long date,long &y,long & m,long & d);
 DED CDate(long d) {
  date=d;
 }
	DED CDate() {
		date=0;
	}
};

DED SD & lstr(_int64 n,SD & sd);
DED void DateOnlyFormat(const char * format,long d,SD & sd);
DED SD Getcurrentdirectory();
DED long Date(long y,long m,long d);
DED bool Shellexecute(const char * fn,const char * param=0);
DED bool isparent(HWND child,HWND parent);
//DED void setlbls(SPtrArray * ctrls);
DED bool spltoemf(const char * spl,int pageno,const char * emf);
DED SD gettemppath();
//SD getservername(SD path);
#ifndef THREED
//#error rrr
 class _3DText {
 public:
 	char signal;
 	DED _3DText();
 };
#endif
//class Wheel {
//public:
	//void create(HWND h);
	//HWND hwnd;
	//void InitD3DEnv();
//};
DED void split(const SD & s,SDA & ca,char c);
DED int SFind(SDA & a,SD & s);
DED void fillsda(const char * fn,SDA * s);
DED void updatesda(const char *s,SDA &cs);
DED void sort(SDA & cs);
DED bool writesda(const char * fn,SDA * s);
DED bool Nonechanged(SArray<ctrl*>& ctrls);
DED void Undoall(SArray<ctrl*>& ctrls);
//DED void UndoallEX(SPtrArray * ctrls);
DED bool Setnextfocus(SArray<ctrl*> & ctrls,SHORT d);
DED bool Somethingchanged(SArray<ctrl*> & ctrls);
DED bool SomethingchangedEX(SPtrArray * ctrls);
DED void Clearchanged(SArray<ctrl*>& ctrls);
DED void ClearchangedEX(SPtrArray * ctrls);
DED void Setleftmostfocus(SArray<ctrl*>& ctrls);
DED void Setrightmostfocus(SArray<ctrl*>& ctrls);
//DED void Eofset(SPtrArray * ctrls,baserst * rst);
DED SD Sysdate(int n=0);
DED void Writectrls(SArray<ctrl*>& ctrls, bbaserst * rst,bool changedonly);
DED void Writechanged(SArray<ctrl*>& ctrls, bbaserst * rst);
DED void Sendmouseclick(int y,UINT msg);
DED void Sendkey(BYTE key);
DED int Getclientheight(HWND hwnd);
DED SD ntow(long n);
DED SD dtow(double d);
DED void Cleartextall(SArray<ctrl*> & ctrls);
DED void Settextall(SArray<ctrl*>& ctrls,baserst* rst);
DED int Bside3(HWND hwnd,HWND parent);
DED void setctrls(SPtrArray &ctrls,int h,int cols,int gap=-1);
DED SD Alltrim(SD s);
DED void Invalidatetree(HWND hwnd);
DED HBITMAP jpegtobmp(const char * filename,void ** membuf=0);
DED void zap(baserst * r);
//DED void Disperr(CException * e);
DED void Lockall(SArray<ctrl*>& ctrls);
DED void Centerwindow(HWND child,HWND parent);
DED void Activateform(MDIForm * f);
//DED void decr(char * buf,int size,char * pwd);
DED HFONT CreateFont(FONT * font);
DED void FlushMessages();
DED void Updatetree(HWND hwnd);
SD & dstr(double n,int nod,SD & sd);
DED SD dstr(double n);
DED SD dstr2(double n);
DED BOOL Execute(SD fn,const char * cmdline=0,LPPROCESS_INFORMATION pi=0,bool hidden=false);
class ctrl;
DED bool navigate(SArray<ctrl*> & ctrls,WPARAM wParam);
//DED bool NonechangedEX(SPtrArray * ctrls);
DED bool Ask(const char * s);
DED double rounddbl(double d);
DED long round32(double d);
DED _int64 round64(double d);
DED int round2(double d,char bias);
DED void Flushallmsg(UINT message,HWND hwnd=0);
DED void Maskfix(SD * s);
DED bool toblocking(SOCKET soc,HWND hwnd);
DED bool hasfocus(SPtrArray * ctrls);
DED void PaintBitmap(HWND hwnd, HBITMAP hbitmap,int t, int l, int height,char dir);
DED void Updatechildwindows(HWND hwnd);
DED bool appendfiletext(const char * fn,const char * text);
DED bool appendfile(const char * fn,const void * buf,long n);
int _find(char *buf,int len, char * s);
int _getclen(char *buf,int len); //returns content-length, 0 if not found
int _gethttpcode(char *buf,int len);
DED bool setfiletext(const char * fn,const char * text);
DED SD getfiletext(const char * fn);
DED void getfilelines(const char * fn,SDA & s);
DED bool writefiletext(const char * fn,const char * text);
DED double hoursd(SD &st,SD &et,bool * absent=NULL);
DED double hoursd2(SD &st,SD &et,bool * absent=NULL);
DED double tto24(SD &s);
//DED double atoff(const char * s);
DED double hours(SD &st,SD &et,bool * absent=NULL);
DED SD Getsocname(SOCKET soc);
DED HOSTENT * safegethostbyaddr(const char *addr,int len,int type);
DED double Sysdatetime();
DED StringData Sysdate2();
DED double dtoh(double d);
DED double htod(double d);
DED void disablewindow(HWND hwnd);
DED void enablewindow(HWND hwnd);
DED SD Gettext(HWND hwnd);
DED void Clearsomethingchanged(SPtrArray * ctrls);
DED void dzfix(SD & sd);
SD & dstr(double n,SD & sd);
void DateFormat(const char * format,double d,SD & sd);
DED void dtohex(unsigned char c,char * buf);
DED unsigned long hextod(char * buf);
DED SD & dtohex(unsigned long l,SD & sd);
DED unsigned char tobase64(unsigned char c);
DED SD base64encode(const SD & src);
DED unsigned char frombase64(unsigned char c);
DED SD base64decode(SD & src);
DED unsigned long getip(const char * server);
//DED signed int ffind(SPtrArray * a,void * p);
DED void setfont(SPtrArray &ctrls,HFONT f,HFONT n);
void logbreak(SD & sd,SDA & fields,SDA & values);
/*template <class C> class DED SArray {
private:
 C * buf;
	int n,top,bot,max;
	void insert2(C ele,int pos);
 void remove2(int pos);
public:
	int growby,startwith;
	SArray();
	~SArray();
	void InsertAt(int pos,C ele);
	inline void Add(C ele);
	inline int GetSize();
 signed long Find(C ele);
	void RemoveAll();
	C GetAt(int pos);
 void SetAt(int pos,C ele);
 void SetAtGrow(int pos,C ele);
 void RemoveAt(int pos);
};*/
void drawbox(HDC hdc,int l,int t,int r,int b);
void drawbox2(HDC hdc,int l,int t,int r,int b);
DED SD encr(SD s);
DED SD decr(SD s);
DED void getnullfield(unsigned char dt,StringData & sd);
void GetClipboardText(SD & s);
void SetClipboardText(const char * s);
#endif
